# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/BasicContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class BasicContainer(genpy.Message):
  _md5sum = "df4bef22c2839a3b929c4078659bba51"
  _type = "etsi_its_vam_ts_msgs/BasicContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a general container for usage in various types of messages.
#  *
#  * It shall include the following components: 
#  *
#  * @field stationType: the type of technical context in which the ITS-S that has generated the message is integrated in.
#  *
#  * @field referencePosition: the reference position of the station that has generated the message that contains the basic container.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# BasicContainer ::= SEQUENCE {
# 	stationType          TrafficParticipantType,
# 	referencePosition    ReferencePositionWithConfidence,
# 	...
# }
# ------------------------------------------------------------------------------

TrafficParticipantType station_type

ReferencePositionWithConfidence reference_position


================================================================================
MSG: etsi_its_vam_ts_msgs/TrafficParticipantType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a traffic participant.
#  * 
#  * The value shall be set to:
#  * - 0 `unknown`          - information about traffic participant is not provided,
#  * - 1 `pedestrian`       - human being not using a mechanical device for their trip (VRU profile 1),
#  * - 2 `cyclist`          - non-motorized unicycles, bicycles , tricycles, quadracycles (VRU profile 2),
#  * - 3 `moped`            - light motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L1, L2 (VRU Profile 3),
#  * - 4 `motorcycles`      - motor vehicles with less than four wheels as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class L3, L4, L5, L6, L7 (VRU Profile 3),
#  * - 5 `passengerCar`     - small passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M1,
#  * - 6 `bus`              - large passenger vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class M2, M3,
#  * - 7 `lightTruck`       - light Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N1,
#  * - 8 `heavyTruck`       - Heavy Goods Vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class N2 and N3,
#  * - 9 `trailer`          - unpowered vehicle that is intended to be towed by a powered vehicle as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class O,
#  * - 10 `specialVehicles` - vehicles which have special purposes other than the above (e.g. moving road works vehicle),
#  * - 11 `tram`            - vehicle which runs on tracks along public streets,
#  * - 12 `lightVruVehicle` - human being traveling on light vehicle, incl. possible use of roller skates or skateboards (VRU profile 2),
#  * - 13 `animal`          - animal presenting a safety risk to other road users e.g. domesticated dog in a city or horse (VRU Profile 4),
#  * - 14 `agricultural`    - agricultural and forestry vehicles as defined in UNECE/TRANS/WP.29/78/Rev.4 [16] class T,
#  * - 15 `roadSideUnit`    - infrastructure typically positioned outside of the drivable roadway (e.g. on a gantry, on a pole, 
#                             on a stationary road works trailer); the infrastructure is static during the entire operation period of the ITS-S (e.g. no stop and go activity),
#  * - 16-255               - are reserved for future usage.
#  * 
#  * @category: Communication information.
#  * @revision: Created in V2.1.1 based on StationType
#  */
# TrafficParticipantType ::= INTEGER {
#     unknown         (0), 
#     pedestrian      (1), 
#     cyclist         (2), 
#     moped           (3), 
#     motorcycle      (4), 
#     passengerCar    (5), 
#     bus             (6), 
#     lightTruck      (7), 
#     heavyTruck      (8), 
#     trailer         (9), 
#     specialVehicle  (10), 
#     tram            (11), 
#     lightVruVehicle (12), 
#     animal          (13),
#     agricultural    (14), 
#     roadSideUnit    (15)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNKNOWN = 0
uint8 PEDESTRIAN = 1
uint8 CYCLIST = 2
uint8 MOPED = 3
uint8 MOTORCYCLE = 4
uint8 PASSENGER_CAR = 5
uint8 BUS = 6
uint8 LIGHT_TRUCK = 7
uint8 HEAVY_TRUCK = 8
uint8 TRAILER = 9
uint8 SPECIAL_VEHICLE = 10
uint8 TRAM = 11
uint8 LIGHT_VRU_VEHICLE = 12
uint8 ANIMAL = 13
uint8 AGRICULTURAL = 14
uint8 ROAD_SIDE_UNIT = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/ReferencePositionWithConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * A position within a geographic coordinate system together with a confidence ellipse. 
#  *
#  * It shall include the following components: 
#  *
#  * @field latitude: the latitude of the geographical point.
#  *
#  * @field longitude: the longitude of the geographical point.
#  *
#  * @field positionConfidenceEllipse: the confidence ellipse associated to the geographical position.
#  *
#  * @field altitude: the altitude and an altitude accuracy of the geographical point.
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.1.1 based on @ref ReferencePosition but using @ref PositionConfidenceEllipse.
#  */
# ReferencePositionWithConfidence ::= SEQUENCE {
#     latitude                     Latitude,
#     longitude                    Longitude,
#     positionConfidenceEllipse    PositionConfidenceEllipse,
#     altitude                     Altitude
# }
# ------------------------------------------------------------------------------

Latitude latitude

Longitude longitude

PositionConfidenceEllipse position_confidence_ellipse

Altitude altitude


================================================================================
MSG: etsi_its_vam_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
#  * in south hemisphere.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
#  * - `0` is used for the latitude of the equator,
#  * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
#  * - `900 000 001` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Editorial update in V2.1.1
#  */
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001


================================================================================
MSG: etsi_its_vam_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
#  * to the east or to the west of the prime meridian.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
#  * - `0` to indicate the prime meridian,
#  * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
#  * - `1 800 000 001` when the information is unavailable.
#  *
#  * The value -1 800 000 000 shall not be used. 
#  * 
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001


================================================================================
MSG: etsi_its_vam_ts_msgs/PositionConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95 %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorAxisLength: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorAxisLength: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorAxisOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * @category GeoReference information
#  * @revision: created in V2.1.1 based on @ref PosConfidenceEllipse
#  */
# PositionConfidenceEllipse ::= SEQUENCE {
#     semiMajorAxisLength         SemiAxisLength,
#     semiMinorAxisLength         SemiAxisLength,
#     semiMajorAxisOrientation    Wgs84AngleValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_axis_length

SemiAxisLength semi_minor_axis_length

Wgs84AngleValue semi_major_axis_orientation


================================================================================
MSG: etsi_its_vam_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/Altitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the altitude and confidence level of an altitude information in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field altitudeValue: altitude of a geographical point.
#  *
#  * @field altitudeConfidence: confidence level of the altitudeValue.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref AltitudeWithConfidence instead. 
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# Altitude ::= SEQUENCE {
#     altitudeValue         AltitudeValue,
#     altitudeConfidence    AltitudeConfidence
# }
# ------------------------------------------------------------------------------

AltitudeValue altitude_value

AltitudeConfidence altitude_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the altitude value in a WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `-100 000` if the altitude is equal to or less than -1 000 m,
#  * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
#  * - `800 000` if the altitude  greater than 7 999,99 m,
#  * - `800 001` if the information is not available.
#  *
#  * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
#  */
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001


================================================================================
MSG: etsi_its_vam_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15

"""
  __slots__ = ['station_type','reference_position']
  _slot_types = ['etsi_its_vam_ts_msgs/TrafficParticipantType','etsi_its_vam_ts_msgs/ReferencePositionWithConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       station_type,reference_position

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BasicContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.station_type is None:
        self.station_type = etsi_its_vam_ts_msgs.msg.TrafficParticipantType()
      if self.reference_position is None:
        self.reference_position = etsi_its_vam_ts_msgs.msg.ReferencePositionWithConfidence()
    else:
      self.station_type = etsi_its_vam_ts_msgs.msg.TrafficParticipantType()
      self.reference_position = etsi_its_vam_ts_msgs.msg.ReferencePositionWithConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B2i3HiB().pack(_x.station_type.value, _x.reference_position.latitude.value, _x.reference_position.longitude.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.reference_position.altitude.altitude_value.value, _x.reference_position.altitude.altitude_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.station_type is None:
        self.station_type = etsi_its_vam_ts_msgs.msg.TrafficParticipantType()
      if self.reference_position is None:
        self.reference_position = etsi_its_vam_ts_msgs.msg.ReferencePositionWithConfidence()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.station_type.value, _x.reference_position.latitude.value, _x.reference_position.longitude.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.reference_position.altitude.altitude_value.value, _x.reference_position.altitude.altitude_confidence.value,) = _get_struct_B2i3HiB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B2i3HiB().pack(_x.station_type.value, _x.reference_position.latitude.value, _x.reference_position.longitude.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.reference_position.altitude.altitude_value.value, _x.reference_position.altitude.altitude_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.station_type is None:
        self.station_type = etsi_its_vam_ts_msgs.msg.TrafficParticipantType()
      if self.reference_position is None:
        self.reference_position = etsi_its_vam_ts_msgs.msg.ReferencePositionWithConfidence()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.station_type.value, _x.reference_position.latitude.value, _x.reference_position.longitude.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_minor_axis_length.value, _x.reference_position.position_confidence_ellipse.semi_major_axis_orientation.value, _x.reference_position.altitude.altitude_value.value, _x.reference_position.altitude.altitude_confidence.value,) = _get_struct_B2i3HiB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B2i3HiB = None
def _get_struct_B2i3HiB():
    global _struct_B2i3HiB
    if _struct_B2i3HiB is None:
        _struct_B2i3HiB = struct.Struct("<B2i3HiB")
    return _struct_B2i3HiB
