# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/ClusterBreakupInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class ClusterBreakupInfo(genpy.Message):
  _md5sum = "4bb1d6ee711db86fafbede866b0a6972"
  _type = "etsi_its_vam_ts_msgs/ClusterBreakupInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides information about the breakup of a cluster.
#  *
#  * It shall include the following components: 
#  * 
#  * @field clusterBreakupReason: indicates the reason for breakup.
#  * 
#  * @field breakupTime: indicates the time of breakup. 
#  *
#  * @category: Cluster Information
#  * @revision: Created in V2.1.1
#  */
# ClusterBreakupInfo ::= SEQUENCE {
#     clusterBreakupReason    ClusterBreakupReason,
#     breakupTime             DeltaTimeQuarterSecond,
#     ...
# }
# ------------------------------------------------------------------------------

ClusterBreakupReason cluster_breakup_reason

DeltaTimeQuarterSecond breakup_time


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterBreakupReason
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the reason why a cluster leader intends to break up the cluster.
#  * 
#  * The value shall be set to:
#  * - 0 - `notProvided`                          - if the information is not provided,
#  * - 1 - `clusteringPurposeCompleted`           - if the cluster purpose has been completed,
#  * - 2 - `leaderMovedOutOfClusterBoundingBox`   - if the leader moved out of the cluster's bounding box,
#  * - 3 - `joiningAnotherCluster`                - if the cluster leader is about to join another cluster,
#  * - 4 - `enteringLowRiskAreaBasedOnMaps`       - if the cluster is entering an area idenrified as low risk based on the use of maps,
#  * - 5 - `receptionOfCpmContainingCluster`      - if the leader received a Collective Perception Message containing information about the same cluster. 
#  * - 6 to 15                                    - are reserved for future use.                                    
#  *
#  * @category: Cluster information
#  * @revision: Created in V2.1.1
# */
# ClusterBreakupReason ::= ENUMERATED {
#     notProvided                        (0),
#     clusteringPurposeCompleted         (1),
#     leaderMovedOutOfClusterBoundingBox (2),    
#     joiningAnotherCluster              (3),
#     enteringLowRiskAreaBasedOnMaps     (4),
#     receptionOfCpmContainingCluster    (5),
#     max(15)                                                                 
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NOT_PROVIDED = 0
uint8 CLUSTERING_PURPOSE_COMPLETED = 1
uint8 LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX = 2
uint8 JOINING_ANOTHER_CLUSTER = 3
uint8 ENTERING_LOW_RISK_AREA_BASED_ON_MAPS = 4
uint8 RECEPTION_OF_CPM_CONTAINING_CLUSTER = 5
uint8 MAX = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaTimeQuarterSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  * It can be interpreted as the first 8 bits of a GenerationDeltaTime. To convert it to a @ref GenerationDeltaTime, 
#  * multiply by 256 (i.e. append a `00` byte)
#  *
#  * @unit: 256 * 0,001 s 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# DeltaTimeQuarterSecond::= INTEGER {
#     unavailable (255)  
# } (1..255) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 255
uint8 UNAVAILABLE = 255

"""
  __slots__ = ['cluster_breakup_reason','breakup_time']
  _slot_types = ['etsi_its_vam_ts_msgs/ClusterBreakupReason','etsi_its_vam_ts_msgs/DeltaTimeQuarterSecond']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cluster_breakup_reason,breakup_time

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClusterBreakupInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cluster_breakup_reason is None:
        self.cluster_breakup_reason = etsi_its_vam_ts_msgs.msg.ClusterBreakupReason()
      if self.breakup_time is None:
        self.breakup_time = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
    else:
      self.cluster_breakup_reason = etsi_its_vam_ts_msgs.msg.ClusterBreakupReason()
      self.breakup_time = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.cluster_breakup_reason.value, _x.breakup_time.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cluster_breakup_reason is None:
        self.cluster_breakup_reason = etsi_its_vam_ts_msgs.msg.ClusterBreakupReason()
      if self.breakup_time is None:
        self.breakup_time = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.cluster_breakup_reason.value, _x.breakup_time.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.cluster_breakup_reason.value, _x.breakup_time.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cluster_breakup_reason is None:
        self.cluster_breakup_reason = etsi_its_vam_ts_msgs.msg.ClusterBreakupReason()
      if self.breakup_time is None:
        self.breakup_time = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.cluster_breakup_reason.value, _x.breakup_time.value,) = _get_struct_2B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
