# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/ClusterLeaveReason.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ClusterLeaveReason(genpy.Message):
  _md5sum = "1b98840bc866f061cfa18b41ac6d51ea"
  _type = "etsi_its_vam_ts_msgs/ClusterLeaveReason"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the reason why a cluster participant is leaving the cluster.
#  * 
#  * The value shall be set to:
#  * - 0 - `notProvided `                 - if the information is not provided,
#  * - 1 - `clusterLeaderLost`            - if the cluster leader cannot be found anymore,   
#  * - 2 - `clusterDisbandedByLeader`     - if the cluster has been disbanded by the leader,
#  * - 3 - `outOfClusterBoundingBox`      - if the participants moved out of the cluster's bounding box,
#  * - 4 - `outOfClusterSpeedRange`       - if the cluster speed moved out of a defined range, 
#  * - 5 - `joiningAnotherCluster`        - if the participant is joining another cluster,
#  * - 6 - `cancelledJoin`                - if the participant is cancelling a joining procedure,
#  * - 7 - `failedJoin`                   - if the participant failed to join the cluster,
#  * - 8 - `safetyCondition`              - if a safety condition applies.
#  * - 9 to 15                            - are reserved for future use                             
#  *
#  * @category: Cluster information
#  * @revision: Created in V2.1.1
#  */
# ClusterLeaveReason ::= ENUMERATED {
#     notProvided                   (0), 
#     clusterLeaderLost             (1),    
#     clusterDisbandedByLeader      (2),    
#     outOfClusterBoundingBox       (3),    
#     outOfClusterSpeedRange        (4),
#     joiningAnotherCluster         (5),
#     cancelledJoin                 (6),
#     failedJoin                    (7),
#     safetyCondition               (8),
#     max(15)            
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NOT_PROVIDED = 0
uint8 CLUSTER_LEADER_LOST = 1
uint8 CLUSTER_DISBANDED_BY_LEADER = 2
uint8 OUT_OF_CLUSTER_BOUNDING_BOX = 3
uint8 OUT_OF_CLUSTER_SPEED_RANGE = 4
uint8 JOINING_ANOTHER_CLUSTER = 5
uint8 CANCELLED_JOIN = 6
uint8 FAILED_JOIN = 7
uint8 SAFETY_CONDITION = 8
uint8 MAX = 15

"""
  # Pseudo-constants
  NOT_PROVIDED = 0
  CLUSTER_LEADER_LOST = 1
  CLUSTER_DISBANDED_BY_LEADER = 2
  OUT_OF_CLUSTER_BOUNDING_BOX = 3
  OUT_OF_CLUSTER_SPEED_RANGE = 4
  JOINING_ANOTHER_CLUSTER = 5
  CANCELLED_JOIN = 6
  FAILED_JOIN = 7
  SAFETY_CONDITION = 8
  MAX = 15

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ClusterLeaveReason, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
