# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/Curvature.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class Curvature(genpy.Message):
  _md5sum = "dd540b01c8b10d496a0626774bffbc7d"
  _type = "etsi_its_vam_ts_msgs/Curvature"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the curvature of the vehicle trajectory and the associated confidence value.
#  * The curvature detected by a vehicle represents the curvature of actual vehicle trajectory.
#  *
#  * It shall include the following components: 
#  * 
#  * @field curvatureValue: Detected curvature of the vehicle trajectory.
#  * 
#  * @field curvatureConfidence: along with a confidence value of the curvature value with a predefined confidence level. 
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# Curvature ::= SEQUENCE {
#     curvatureValue         CurvatureValue,
#     curvatureConfidence    CurvatureConfidence
# }
# ------------------------------------------------------------------------------

CurvatureValue curvature_value

CurvatureConfidence curvature_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/CurvatureValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes vehicle turning curve with the following information:
#  * ```
#  *     Value = 1 / Radius * 10000
#  * ```
#  * wherein radius is the vehicle turning curve radius in metres. 
#  * 
#  * Positive values indicate a turning curve to the left hand side of the driver.
#  * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].
#  *
#  * The value shall be set to:
#  * - `-1023` for  values smaller than -1023,
#  * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,
#  * - `0` when the vehicle is moving straight,
#  * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,
#  * - `1022`, for values  greater than 1021,
#  * - `1023`, if the information is not available.
#  * 
#  * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].
#  * 
#  * @unit: 1 over 10 000 metres
#  * @category: Vehicle information
#  * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)
#  */
# CurvatureValue ::= INTEGER {
#     outOfRangeNegative (-1023),
#     straight           (0),
#     outOfRangePositive (1022), 
#     unavailable        (1023)
# } (-1023..1023)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -1023
int16 MAX = 1023
int16 OUT_OF_RANGE_NEGATIVE = -1023
int16 STRAIGHT = 0
int16 OUT_OF_RANGE_POSITIVE = 1022
int16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_vam_ts_msgs/CurvatureConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,
#  * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,
#  * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,
#  * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,
#  * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,
#  * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,
#  * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,
#  * - 7 - `unavailable`         - if the confidence value is not available.
#  * 
#  * @note:	The fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the curvature value may be valid and used by the application.
#  * 
#  * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid 
#  * and therefore cannot be trusted. Such value is not useful for the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
# */
# CurvatureConfidence ::= ENUMERATED {
#     onePerMeter-0-00002 (0),
#     onePerMeter-0-0001  (1),
#     onePerMeter-0-0005  (2),
#     onePerMeter-0-002   (3),
#     onePerMeter-0-01    (4),
#     onePerMeter-0-1     (5),
#     outOfRange          (6),
#     unavailable         (7)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ONE_PER_METER_0_00002 = 0
uint8 ONE_PER_METER_0_0001 = 1
uint8 ONE_PER_METER_0_0005 = 2
uint8 ONE_PER_METER_0_002 = 3
uint8 ONE_PER_METER_0_01 = 4
uint8 ONE_PER_METER_0_1 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7

"""
  __slots__ = ['curvature_value','curvature_confidence']
  _slot_types = ['etsi_its_vam_ts_msgs/CurvatureValue','etsi_its_vam_ts_msgs/CurvatureConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       curvature_value,curvature_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Curvature, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.curvature_value is None:
        self.curvature_value = etsi_its_vam_ts_msgs.msg.CurvatureValue()
      if self.curvature_confidence is None:
        self.curvature_confidence = etsi_its_vam_ts_msgs.msg.CurvatureConfidence()
    else:
      self.curvature_value = etsi_its_vam_ts_msgs.msg.CurvatureValue()
      self.curvature_confidence = etsi_its_vam_ts_msgs.msg.CurvatureConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.curvature_value.value, _x.curvature_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.curvature_value is None:
        self.curvature_value = etsi_its_vam_ts_msgs.msg.CurvatureValue()
      if self.curvature_confidence is None:
        self.curvature_confidence = etsi_its_vam_ts_msgs.msg.CurvatureConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.curvature_value.value, _x.curvature_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.curvature_value.value, _x.curvature_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.curvature_value is None:
        self.curvature_value = etsi_its_vam_ts_msgs.msg.CurvatureValue()
      if self.curvature_confidence is None:
        self.curvature_confidence = etsi_its_vam_ts_msgs.msg.CurvatureConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.curvature_value.value, _x.curvature_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
