# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/LaneType.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class LaneType(genpy.Message):
  _md5sum = "c492684564e374e0613d34673a80316b"
  _type = "etsi_its_vam_ts_msgs/LaneType"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a lane. 
#  * 
#  * The value shall be set to:
#  * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
#  * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
#  * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
#  * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
#  * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
#  * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
#  * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
#  * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
#  * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
#  * - 9	- `taxi`               - Lane dedicated to movement of taxis,
#  * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
#  * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
#  * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
#  * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
#  * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
#                                  separating the two directional carriageways of the highway,
#  * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
#  * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
#  * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
#  * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
#  * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
#                                  the road surface edge and the boundary of a road,
#  * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre.
#  * - values 21 to 30             reserved for future use. 
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
# */
# LaneType::= INTEGER{
# 	traffic              (0),
# 	through	             (1),
# 	reversible           (2),
# 	acceleration         (3),
# 	deceleration         (4),
# 	leftHandTurning      (5),
# 	rightHandTurning     (6),
# 	dedicatedVehicle     (7),
# 	bus                  (8),
# 	taxi                 (9),
# 	hov                  (10),
# 	hot                  (11),
# 	pedestrian           (12),
# 	cycleLane            (13),
# 	median               (14),   
# 	striping             (15),
# 	trackedVehicle       (16),
# 	parking	             (17),
# 	emergency            (18),
# 	verge                (19),
# 	minimumRiskManoeuvre (20),
# 	unknown              (31)
# }(0..31)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 TRAFFIC = 0
uint8 THROUGH = 1
uint8 REVERSIBLE = 2
uint8 ACCELERATION = 3
uint8 DECELERATION = 4
uint8 LEFT_HAND_TURNING = 5
uint8 RIGHT_HAND_TURNING = 6
uint8 DEDICATED_VEHICLE = 7
uint8 BUS = 8
uint8 TAXI = 9
uint8 HOV = 10
uint8 HOT = 11
uint8 PEDESTRIAN = 12
uint8 CYCLE_LANE = 13
uint8 MEDIAN = 14
uint8 STRIPING = 15
uint8 TRACKED_VEHICLE = 16
uint8 PARKING = 17
uint8 EMERGENCY = 18
uint8 VERGE = 19
uint8 MINIMUM_RISK_MANOEUVRE = 20
uint8 UNKNOWN = 31

"""
  # Pseudo-constants
  MIN = 0
  MAX = 31
  TRAFFIC = 0
  THROUGH = 1
  REVERSIBLE = 2
  ACCELERATION = 3
  DECELERATION = 4
  LEFT_HAND_TURNING = 5
  RIGHT_HAND_TURNING = 6
  DEDICATED_VEHICLE = 7
  BUS = 8
  TAXI = 9
  HOV = 10
  HOT = 11
  PEDESTRIAN = 12
  CYCLE_LANE = 13
  MEDIAN = 14
  STRIPING = 15
  TRACKED_VEHICLE = 16
  PARKING = 17
  EMERGENCY = 18
  VERGE = 19
  MINIMUM_RISK_MANOEUVRE = 20
  UNKNOWN = 31

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LaneType, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
