# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/LateralAcceleration.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class LateralAcceleration(genpy.Message):
  _md5sum = "071654489f8c101d9b570376a5e96124"
  _type = "etsi_its_vam_ts_msgs/LateralAcceleration"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the vehicle acceleration at lateral direction and the confidence value of the lateral acceleration.
#  *
#  * It shall include the following components: 
#  * 
#  * @field lateralAccelerationValue: lateral acceleration value at a point in time.
#  * 
#  * @field lateralAccelerationConfidence: confidence value of the lateral acceleration value.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationComponent instead.
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# LateralAcceleration ::= SEQUENCE {
#     lateralAccelerationValue         LateralAccelerationValue,
#     lateralAccelerationConfidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

LateralAccelerationValue lateral_acceleration_value

AccelerationConfidence lateral_acceleration_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LateralAccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle acceleration at lateral direction in the centre of the mass of the empty vehicle.
#  * It corresponds to the vehicle coordinate system as specified in ISO 8855 [21].
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is accelerating towards the right side with regards to the vehicle orientation 
#  *                            with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,
#  * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating towards the left hand side with regards to the vehicle orientation 
# 						     with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  *
#  * @note: the empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.
#  *  
#  * @unit: 0,1 m/s^2
#  * @category: Vehicle information
#  * @revision: Description updated in V2.1.1 (the meaning of 160 has changed slightly). 
#  */
# LateralAccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_vam_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
#  * - `102` if the confidence value is unavailable.
#  *
#  * The value 0 shall not be used.
#  *
#  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the acceleration value may be valid and used by the application.
#  * 
#  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
#  *
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1
#  */
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102

"""
  __slots__ = ['lateral_acceleration_value','lateral_acceleration_confidence']
  _slot_types = ['etsi_its_vam_ts_msgs/LateralAccelerationValue','etsi_its_vam_ts_msgs/AccelerationConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       lateral_acceleration_value,lateral_acceleration_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LateralAcceleration, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.lateral_acceleration_value is None:
        self.lateral_acceleration_value = etsi_its_vam_ts_msgs.msg.LateralAccelerationValue()
      if self.lateral_acceleration_confidence is None:
        self.lateral_acceleration_confidence = etsi_its_vam_ts_msgs.msg.AccelerationConfidence()
    else:
      self.lateral_acceleration_value = etsi_its_vam_ts_msgs.msg.LateralAccelerationValue()
      self.lateral_acceleration_confidence = etsi_its_vam_ts_msgs.msg.AccelerationConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.lateral_acceleration_value.value, _x.lateral_acceleration_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lateral_acceleration_value is None:
        self.lateral_acceleration_value = etsi_its_vam_ts_msgs.msg.LateralAccelerationValue()
      if self.lateral_acceleration_confidence is None:
        self.lateral_acceleration_confidence = etsi_its_vam_ts_msgs.msg.AccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.lateral_acceleration_value.value, _x.lateral_acceleration_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.lateral_acceleration_value.value, _x.lateral_acceleration_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lateral_acceleration_value is None:
        self.lateral_acceleration_value = etsi_its_vam_ts_msgs.msg.LateralAccelerationValue()
      if self.lateral_acceleration_confidence is None:
        self.lateral_acceleration_confidence = etsi_its_vam_ts_msgs.msg.AccelerationConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.lateral_acceleration_value.value, _x.lateral_acceleration_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
