# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/LongitudinalLanePosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class LongitudinalLanePosition(genpy.Message):
  _md5sum = "f60a21cee35464ede365258df24a077c"
  _type = "etsi_its_vam_ts_msgs/LongitudinalLanePosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the estimated position along the longitudinal length of a particular lane. 
#  *
#  * It shall include the following components: 
#  *
#  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
#  *
#  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
#  *
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
#  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
#  * - `32 767` if the longitudinal offset information is not available. 
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
#  * - `1 023` if the confidence value is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

"""
  __slots__ = ['longitudinal_lane_position_value','longitudinal_lane_position_confidence']
  _slot_types = ['etsi_its_vam_ts_msgs/LongitudinalLanePositionValue','etsi_its_vam_ts_msgs/LongitudinalLanePositionConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       longitudinal_lane_position_value,longitudinal_lane_position_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LongitudinalLanePosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.longitudinal_lane_position_value is None:
        self.longitudinal_lane_position_value = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionValue()
      if self.longitudinal_lane_position_confidence is None:
        self.longitudinal_lane_position_confidence = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionConfidence()
    else:
      self.longitudinal_lane_position_value = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionValue()
      self.longitudinal_lane_position_confidence = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2H().pack(_x.longitudinal_lane_position_value.value, _x.longitudinal_lane_position_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.longitudinal_lane_position_value is None:
        self.longitudinal_lane_position_value = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionValue()
      if self.longitudinal_lane_position_confidence is None:
        self.longitudinal_lane_position_confidence = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionConfidence()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.longitudinal_lane_position_value.value, _x.longitudinal_lane_position_confidence.value,) = _get_struct_2H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2H().pack(_x.longitudinal_lane_position_value.value, _x.longitudinal_lane_position_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.longitudinal_lane_position_value is None:
        self.longitudinal_lane_position_value = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionValue()
      if self.longitudinal_lane_position_confidence is None:
        self.longitudinal_lane_position_confidence = etsi_its_vam_ts_msgs.msg.LongitudinalLanePositionConfidence()
      end = 0
      _x = self
      start = end
      end += 4
      (_x.longitudinal_lane_position_value.value, _x.longitudinal_lane_position_confidence.value,) = _get_struct_2H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2H = None
def _get_struct_2H():
    global _struct_2H
    if _struct_2H is None:
        _struct_2H = struct.Struct("<2H")
    return _struct_2H
