# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/MapPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class MapPosition(genpy.Message):
  _md5sum = "76b09f64eb0b8aa5534e4afd8aab9c5a"
  _type = "etsi_its_vam_ts_msgs/MapPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  * 
#  * @field mapReference: optionally identifies the MAPEM containing the topology information.
#  * It is absent if the MAPEM topology is known from the context.
#  * 
#  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
#  *
#  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
#  * conflict area of an intersection which connects e.g an ingress with an egress lane.
#  *
#  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
#  * 
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
#  *
#  * The following options are provided:
#  * 
#  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
#  * 
#  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_vam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for a road segment
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the road segment.
#  *
#  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_vam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the intersection
#  *
#  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the estimated position along the longitudinal length of a particular lane. 
#  *
#  * It shall include the following components: 
#  *
#  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
#  *
#  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
#  *
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
#  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
#  * - `32 767` if the longitudinal offset information is not available. 
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
#  * - `1 023` if the confidence value is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

"""
  __slots__ = ['map_reference','map_reference_is_present','lane_id','lane_id_is_present','connection_id','connection_id_is_present','longitudinal_lane_position','longitudinal_lane_position_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/MapReference','bool','etsi_its_vam_ts_msgs/Identifier1B','bool','etsi_its_vam_ts_msgs/Identifier1B','bool','etsi_its_vam_ts_msgs/LongitudinalLanePosition','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       map_reference,map_reference_is_present,lane_id,lane_id_is_present,connection_id,connection_id_is_present,longitudinal_lane_position,longitudinal_lane_position_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MapPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.map_reference is None:
        self.map_reference = etsi_its_vam_ts_msgs.msg.MapReference()
      if self.map_reference_is_present is None:
        self.map_reference_is_present = False
      if self.lane_id is None:
        self.lane_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.lane_id_is_present is None:
        self.lane_id_is_present = False
      if self.connection_id is None:
        self.connection_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.connection_id_is_present is None:
        self.connection_id_is_present = False
      if self.longitudinal_lane_position is None:
        self.longitudinal_lane_position = etsi_its_vam_ts_msgs.msg.LongitudinalLanePosition()
      if self.longitudinal_lane_position_is_present is None:
        self.longitudinal_lane_position_is_present = False
    else:
      self.map_reference = etsi_its_vam_ts_msgs.msg.MapReference()
      self.map_reference_is_present = False
      self.lane_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      self.lane_id_is_present = False
      self.connection_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      self.connection_id_is_present = False
      self.longitudinal_lane_position = etsi_its_vam_ts_msgs.msg.LongitudinalLanePosition()
      self.longitudinal_lane_position_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBH5B2HB().pack(_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present, _x.lane_id.value, _x.lane_id_is_present, _x.connection_id.value, _x.connection_id_is_present, _x.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.longitudinal_lane_position_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.map_reference is None:
        self.map_reference = etsi_its_vam_ts_msgs.msg.MapReference()
      if self.lane_id is None:
        self.lane_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.connection_id is None:
        self.connection_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.longitudinal_lane_position is None:
        self.longitudinal_lane_position = etsi_its_vam_ts_msgs.msg.LongitudinalLanePosition()
      end = 0
      _x = self
      start = end
      end += 21
      (_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present, _x.lane_id.value, _x.lane_id_is_present, _x.connection_id.value, _x.connection_id_is_present, _x.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.longitudinal_lane_position_is_present,) = _get_struct_BHB2HBH5B2HB().unpack(str[start:end])
      self.map_reference.roadsegment.region_is_present = bool(self.map_reference.roadsegment.region_is_present)
      self.map_reference.intersection.region_is_present = bool(self.map_reference.intersection.region_is_present)
      self.map_reference_is_present = bool(self.map_reference_is_present)
      self.lane_id_is_present = bool(self.lane_id_is_present)
      self.connection_id_is_present = bool(self.connection_id_is_present)
      self.longitudinal_lane_position_is_present = bool(self.longitudinal_lane_position_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBH5B2HB().pack(_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present, _x.lane_id.value, _x.lane_id_is_present, _x.connection_id.value, _x.connection_id_is_present, _x.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.longitudinal_lane_position_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.map_reference is None:
        self.map_reference = etsi_its_vam_ts_msgs.msg.MapReference()
      if self.lane_id is None:
        self.lane_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.connection_id is None:
        self.connection_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.longitudinal_lane_position is None:
        self.longitudinal_lane_position = etsi_its_vam_ts_msgs.msg.LongitudinalLanePosition()
      end = 0
      _x = self
      start = end
      end += 21
      (_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present, _x.lane_id.value, _x.lane_id_is_present, _x.connection_id.value, _x.connection_id_is_present, _x.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.longitudinal_lane_position_is_present,) = _get_struct_BHB2HBH5B2HB().unpack(str[start:end])
      self.map_reference.roadsegment.region_is_present = bool(self.map_reference.roadsegment.region_is_present)
      self.map_reference.intersection.region_is_present = bool(self.map_reference.intersection.region_is_present)
      self.map_reference_is_present = bool(self.map_reference_is_present)
      self.lane_id_is_present = bool(self.lane_id_is_present)
      self.connection_id_is_present = bool(self.connection_id_is_present)
      self.longitudinal_lane_position_is_present = bool(self.longitudinal_lane_position_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BHB2HBH5B2HB = None
def _get_struct_BHB2HBH5B2HB():
    global _struct_BHB2HBH5B2HB
    if _struct_BHB2HBH5B2HB is None:
        _struct_BHB2HBH5B2HB = struct.Struct("<BHB2HBH5B2HB")
    return _struct_BHB2HBH5B2HB
