# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/MapReference.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class MapReference(genpy.Message):
  _md5sum = "03f74514f338ac22201d8e5c25edf1f4"
  _type = "etsi_its_vam_ts_msgs/MapReference"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
#  *
#  * The following options are provided:
#  * 
#  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
#  * 
#  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_vam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for a road segment
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the road segment.
#  *
#  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_vam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the intersection
#  *
#  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id

"""
  # Pseudo-constants
  CHOICE_ROADSEGMENT = 0
  CHOICE_INTERSECTION = 1

  __slots__ = ['choice','roadsegment','intersection']
  _slot_types = ['uint8','etsi_its_vam_ts_msgs/RoadSegmentReferenceId','etsi_its_vam_ts_msgs/IntersectionReferenceId']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       choice,roadsegment,intersection

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MapReference, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.choice is None:
        self.choice = 0
      if self.roadsegment is None:
        self.roadsegment = etsi_its_vam_ts_msgs.msg.RoadSegmentReferenceId()
      if self.intersection is None:
        self.intersection = etsi_its_vam_ts_msgs.msg.IntersectionReferenceId()
    else:
      self.choice = 0
      self.roadsegment = etsi_its_vam_ts_msgs.msg.RoadSegmentReferenceId()
      self.intersection = etsi_its_vam_ts_msgs.msg.IntersectionReferenceId()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBH().pack(_x.choice, _x.roadsegment.region.value, _x.roadsegment.region_is_present, _x.roadsegment.id.value, _x.intersection.region.value, _x.intersection.region_is_present, _x.intersection.id.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roadsegment is None:
        self.roadsegment = etsi_its_vam_ts_msgs.msg.RoadSegmentReferenceId()
      if self.intersection is None:
        self.intersection = etsi_its_vam_ts_msgs.msg.IntersectionReferenceId()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.choice, _x.roadsegment.region.value, _x.roadsegment.region_is_present, _x.roadsegment.id.value, _x.intersection.region.value, _x.intersection.region_is_present, _x.intersection.id.value,) = _get_struct_BHB2HBH().unpack(str[start:end])
      self.roadsegment.region_is_present = bool(self.roadsegment.region_is_present)
      self.intersection.region_is_present = bool(self.intersection.region_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBH().pack(_x.choice, _x.roadsegment.region.value, _x.roadsegment.region_is_present, _x.roadsegment.id.value, _x.intersection.region.value, _x.intersection.region_is_present, _x.intersection.id.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roadsegment is None:
        self.roadsegment = etsi_its_vam_ts_msgs.msg.RoadSegmentReferenceId()
      if self.intersection is None:
        self.intersection = etsi_its_vam_ts_msgs.msg.IntersectionReferenceId()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.choice, _x.roadsegment.region.value, _x.roadsegment.region_is_present, _x.roadsegment.id.value, _x.intersection.region.value, _x.intersection.region_is_present, _x.intersection.id.value,) = _get_struct_BHB2HBH().unpack(str[start:end])
      self.roadsegment.region_is_present = bool(self.roadsegment.region_is_present)
      self.intersection.region_is_present = bool(self.intersection.region_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BHB2HBH = None
def _get_struct_BHB2HBH():
    global _struct_BHB2HBH
    if _struct_BHB2HBH is None:
        _struct_BHB2HBH = struct.Struct("<BHB2HBH")
    return _struct_BHB2HBH
