# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/PathPredicted.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class PathPredicted(genpy.Message):
  _md5sum = "cc964c2dc1e19c53d544d5f2b9f4139b"
  _type = "etsi_its_vam_ts_msgs/PathPredicted"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a predicted path with a set of path points.
#  * It shall contain up to `15` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.1.1 based on PathHistory
#  */
# PathPredicted::= SEQUENCE (SIZE(0..15,...)) OF PathPointPredicted
# ------------------------------------------------------------------------------

PathPointPredicted[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/PathPointPredicted
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  defines a predicted offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: an offset latitude with regards to a pre-defined reference position. 
#  *
#  * @field deltaLongitude: an offset longitude with regards to a pre-defined reference position. 
#  * 
#  * @field horizontalPositionConfidence: the confidence value associated to the horizontal geographical position.
#  *
#  * @field deltaAltitude: an offset altitude with regards to a pre-defined reference position. 
#  *
#  * @field altitudeConfidence: the confidence value associated to the altitude value of the geographical position.
#  * 
#  * @field pathDeltaTime: The  travel time separated from the waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPointPredicted::= SEQUENCE {
#   deltaLatitude                 DeltaLatitude,      
#   deltaLongitude                DeltaLongitude, 
#   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,   
#   deltaAltitude                 DeltaAltitude DEFAULT unavailable, 
#   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
#   pathDeltaTime                 DeltaTimeTenthOfSecond,
#   ... 
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

PosConfidenceEllipse horizontal_position_confidence
bool horizontal_position_confidence_is_present

DeltaAltitude delta_altitude
uint16 DELTA_ALTITUDE_DEFAULT = 12800

AltitudeConfidence altitude_confidence
uint8 ALTITUDE_CONFIDENCE_DEFAULT = 15

DeltaTimeTenthOfSecond path_delta_time


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset latitude with regards to a defined latitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
#  * - `0` for no latitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset longitude with regards to a defined longitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
#  * - `0` for no longitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_vam_ts_msgs/PosConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  *
#  * @category GeoReference information
#  * @revision: V1.3.1
#  */
# PosConfidenceEllipse ::= SEQUENCE {
#     semiMajorConfidence     SemiAxisLength,
#     semiMinorConfidence     SemiAxisLength,
#     semiMajorOrientation    HeadingValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_confidence

SemiAxisLength semi_minor_confidence

HeadingValue semi_major_orientation


================================================================================
MSG: etsi_its_vam_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset altitude with regards to a defined altitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `-12 700` for values equal to or lower than -127 metres,
#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
#  * - `0` for no altitudinal offset,
#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
#  * - `12 799` for values equal to or greater than 127,99 metres,
#  * - `12 800` when the information is unavailable.
#  *
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800


================================================================================
MSG: etsi_its_vam_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `0` for a difference in time of 0 seconds. 
#  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
#  *
#  * @unit: 0,1 s
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# DeltaTimeTenthOfSecond::= INTEGER {
#     unavailable (127)  
# } (0..127) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 UNAVAILABLE = 127

"""
  # Pseudo-constants
  MIN_SIZE = 0
  MAX_SIZE = 15

  __slots__ = ['array']
  _slot_types = ['etsi_its_vam_ts_msgs/PathPointPredicted[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PathPredicted, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.delta_latitude
        _x = _v1.value
        buff.write(_get_struct_i().pack(_x))
        _v2 = val1.delta_longitude
        _x = _v2.value
        buff.write(_get_struct_i().pack(_x))
        _v3 = val1.horizontal_position_confidence
        _v4 = _v3.semi_major_confidence
        _x = _v4.value
        buff.write(_get_struct_H().pack(_x))
        _v5 = _v3.semi_minor_confidence
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _v6 = _v3.semi_major_orientation
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.horizontal_position_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
        _v7 = val1.delta_altitude
        _x = _v7.value
        buff.write(_get_struct_h().pack(_x))
        _v8 = val1.altitude_confidence
        _x = _v8.value
        buff.write(_get_struct_B().pack(_x))
        _v9 = val1.path_delta_time
        _x = _v9.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPointPredicted()
        _v10 = val1.delta_latitude
        start = end
        end += 4
        (_v10.value,) = _get_struct_i().unpack(str[start:end])
        _v11 = val1.delta_longitude
        start = end
        end += 4
        (_v11.value,) = _get_struct_i().unpack(str[start:end])
        _v12 = val1.horizontal_position_confidence
        _v13 = _v12.semi_major_confidence
        start = end
        end += 2
        (_v13.value,) = _get_struct_H().unpack(str[start:end])
        _v14 = _v12.semi_minor_confidence
        start = end
        end += 2
        (_v14.value,) = _get_struct_H().unpack(str[start:end])
        _v15 = _v12.semi_major_orientation
        start = end
        end += 2
        (_v15.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.horizontal_position_confidence_is_present = bool(val1.horizontal_position_confidence_is_present)
        _v16 = val1.delta_altitude
        start = end
        end += 2
        (_v16.value,) = _get_struct_h().unpack(str[start:end])
        _v17 = val1.altitude_confidence
        start = end
        end += 1
        (_v17.value,) = _get_struct_B().unpack(str[start:end])
        _v18 = val1.path_delta_time
        start = end
        end += 1
        (_v18.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v19 = val1.delta_latitude
        _x = _v19.value
        buff.write(_get_struct_i().pack(_x))
        _v20 = val1.delta_longitude
        _x = _v20.value
        buff.write(_get_struct_i().pack(_x))
        _v21 = val1.horizontal_position_confidence
        _v22 = _v21.semi_major_confidence
        _x = _v22.value
        buff.write(_get_struct_H().pack(_x))
        _v23 = _v21.semi_minor_confidence
        _x = _v23.value
        buff.write(_get_struct_H().pack(_x))
        _v24 = _v21.semi_major_orientation
        _x = _v24.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.horizontal_position_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = val1.delta_altitude
        _x = _v25.value
        buff.write(_get_struct_h().pack(_x))
        _v26 = val1.altitude_confidence
        _x = _v26.value
        buff.write(_get_struct_B().pack(_x))
        _v27 = val1.path_delta_time
        _x = _v27.value
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPointPredicted()
        _v28 = val1.delta_latitude
        start = end
        end += 4
        (_v28.value,) = _get_struct_i().unpack(str[start:end])
        _v29 = val1.delta_longitude
        start = end
        end += 4
        (_v29.value,) = _get_struct_i().unpack(str[start:end])
        _v30 = val1.horizontal_position_confidence
        _v31 = _v30.semi_major_confidence
        start = end
        end += 2
        (_v31.value,) = _get_struct_H().unpack(str[start:end])
        _v32 = _v30.semi_minor_confidence
        start = end
        end += 2
        (_v32.value,) = _get_struct_H().unpack(str[start:end])
        _v33 = _v30.semi_major_orientation
        start = end
        end += 2
        (_v33.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.horizontal_position_confidence_is_present = bool(val1.horizontal_position_confidence_is_present)
        _v34 = val1.delta_altitude
        start = end
        end += 2
        (_v34.value,) = _get_struct_h().unpack(str[start:end])
        _v35 = val1.altitude_confidence
        start = end
        end += 1
        (_v35.value,) = _get_struct_B().unpack(str[start:end])
        _v36 = val1.path_delta_time
        start = end
        end += 1
        (_v36.value,) = _get_struct_B().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
