# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/PosConfidenceEllipse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class PosConfidenceEllipse(genpy.Message):
  _md5sum = "f1c1780d3346bd72dbde7126ef52b832"
  _type = "etsi_its_vam_ts_msgs/PosConfidenceEllipse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  *
#  * @category GeoReference information
#  * @revision: V1.3.1
#  */
# PosConfidenceEllipse ::= SEQUENCE {
#     semiMajorConfidence     SemiAxisLength,
#     semiMinorConfidence     SemiAxisLength,
#     semiMajorOrientation    HeadingValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_confidence

SemiAxisLength semi_minor_confidence

HeadingValue semi_major_orientation


================================================================================
MSG: etsi_its_vam_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601

"""
  __slots__ = ['semi_major_confidence','semi_minor_confidence','semi_major_orientation']
  _slot_types = ['etsi_its_vam_ts_msgs/SemiAxisLength','etsi_its_vam_ts_msgs/SemiAxisLength','etsi_its_vam_ts_msgs/HeadingValue']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       semi_major_confidence,semi_minor_confidence,semi_major_orientation

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PosConfidenceEllipse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.semi_major_confidence is None:
        self.semi_major_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_minor_confidence is None:
        self.semi_minor_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_major_orientation is None:
        self.semi_major_orientation = etsi_its_vam_ts_msgs.msg.HeadingValue()
    else:
      self.semi_major_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      self.semi_minor_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      self.semi_major_orientation = etsi_its_vam_ts_msgs.msg.HeadingValue()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3H().pack(_x.semi_major_confidence.value, _x.semi_minor_confidence.value, _x.semi_major_orientation.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.semi_major_confidence is None:
        self.semi_major_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_minor_confidence is None:
        self.semi_minor_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_major_orientation is None:
        self.semi_major_orientation = etsi_its_vam_ts_msgs.msg.HeadingValue()
      end = 0
      _x = self
      start = end
      end += 6
      (_x.semi_major_confidence.value, _x.semi_minor_confidence.value, _x.semi_major_orientation.value,) = _get_struct_3H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3H().pack(_x.semi_major_confidence.value, _x.semi_minor_confidence.value, _x.semi_major_orientation.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.semi_major_confidence is None:
        self.semi_major_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_minor_confidence is None:
        self.semi_minor_confidence = etsi_its_vam_ts_msgs.msg.SemiAxisLength()
      if self.semi_major_orientation is None:
        self.semi_major_orientation = etsi_its_vam_ts_msgs.msg.HeadingValue()
      end = 0
      _x = self
      start = end
      end += 6
      (_x.semi_major_confidence.value, _x.semi_minor_confidence.value, _x.semi_major_orientation.value,) = _get_struct_3H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3H = None
def _get_struct_3H():
    global _struct_3H
    if _struct_3H is None:
        _struct_3H = struct.Struct("<3H")
    return _struct_3H
