# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/RadialShape.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class RadialShape(genpy.Message):
  _md5sum = "221ce8b372a548d7e1d61b8af556d250"
  _type = "etsi_its_vam_ts_msgs/RadialShape"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a radial shape. The triangular or cone-shaped volume is
#  * constructed by sweeping the provided range about the reference point  between a horizontal start 
#  * and a horizontal end angle in positive angular direction of the WGS84
#  * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
#  * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
#  * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
#  * above intersections).
#  *
#  * It shall include the following components:
#  * 
#  * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
#  * If this component is absent, the externally specified reference position represents the shape's  reference point. 
#  *
#  * @field range: the radial range of the shape from the shape's reference point. 
#  *
#  * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the 
#  * shape's horizontal opening angle in positive angular direction with respect to the 
#  * WGS84 coordinate system.
#  *
#  * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's 
#  * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
#  * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system. 
#  *
#  * @category GeoReference information
#  * @revision: created in V2.1.1
# */
# RadialShape ::= SEQUENCE { 
#     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
#     range                                    StandardLength12b,
#     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue, 
#     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue, 
#     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianPosition3d shape_reference_point
bool shape_reference_point_is_present

StandardLength12b range

Wgs84AngleValue stationary_horizontal_opening_angle_start

Wgs84AngleValue stationary_horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianPosition3d
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
#  *
#  * It shall include the following components: 
#  *
#  * @field xCoordinate: the X coordinate value.
#  *
#  * @field yCoordinate: the Y coordinate value.
#  *
#  * @field zCoordinate: the optional Z coordinate value.
#  * 
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# CartesianPosition3d::=SEQUENCE{
#     xCoordinate    CartesianCoordinate,
#     yCoordinate    CartesianCoordinate,
#     zCoordinate    CartesianCoordinate OPTIONAL
# }
# ------------------------------------------------------------------------------

CartesianCoordinate x_coordinate

CartesianCoordinate y_coordinate

CartesianCoordinate z_coordinate
bool z_coordinate_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianCoordinate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
#  *
#  * The value shall be set to:
#  * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
#  * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
#  *
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinate::= INTEGER{
#     negativeOutOfRange (-32768),
#     positiveOutOfRange (32767)
# } (-32768..32767)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -32768
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32768
int16 POSITIVE_OUT_OF_RANGE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
#  *
#  * @unit: 0,1 metre
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
#  * a right-hand local coordinate system from the abscissa.
#  *
#  * The value shall be set to: 
#  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
#  * - `36001` if the accuracy information is not available.
#  *
#  * The value 3600 shall not be used. 
#  * 
#  * @unit 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

"""
  __slots__ = ['shape_reference_point','shape_reference_point_is_present','range','stationary_horizontal_opening_angle_start','stationary_horizontal_opening_angle_end','vertical_opening_angle_start','vertical_opening_angle_start_is_present','vertical_opening_angle_end','vertical_opening_angle_end_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/CartesianPosition3d','bool','etsi_its_vam_ts_msgs/StandardLength12b','etsi_its_vam_ts_msgs/Wgs84AngleValue','etsi_its_vam_ts_msgs/Wgs84AngleValue','etsi_its_vam_ts_msgs/CartesianAngleValue','bool','etsi_its_vam_ts_msgs/CartesianAngleValue','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       shape_reference_point,shape_reference_point_is_present,range,stationary_horizontal_opening_angle_start,stationary_horizontal_opening_angle_end,vertical_opening_angle_start,vertical_opening_angle_start_is_present,vertical_opening_angle_end,vertical_opening_angle_end_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadialShape, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.shape_reference_point is None:
        self.shape_reference_point = etsi_its_vam_ts_msgs.msg.CartesianPosition3d()
      if self.shape_reference_point_is_present is None:
        self.shape_reference_point_is_present = False
      if self.range is None:
        self.range = etsi_its_vam_ts_msgs.msg.StandardLength12b()
      if self.stationary_horizontal_opening_angle_start is None:
        self.stationary_horizontal_opening_angle_start = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.stationary_horizontal_opening_angle_end is None:
        self.stationary_horizontal_opening_angle_end = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.vertical_opening_angle_start is None:
        self.vertical_opening_angle_start = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      if self.vertical_opening_angle_start_is_present is None:
        self.vertical_opening_angle_start_is_present = False
      if self.vertical_opening_angle_end is None:
        self.vertical_opening_angle_end = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      if self.vertical_opening_angle_end_is_present is None:
        self.vertical_opening_angle_end_is_present = False
    else:
      self.shape_reference_point = etsi_its_vam_ts_msgs.msg.CartesianPosition3d()
      self.shape_reference_point_is_present = False
      self.range = etsi_its_vam_ts_msgs.msg.StandardLength12b()
      self.stationary_horizontal_opening_angle_start = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      self.stationary_horizontal_opening_angle_end = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      self.vertical_opening_angle_start = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      self.vertical_opening_angle_start_is_present = False
      self.vertical_opening_angle_end = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      self.vertical_opening_angle_end_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3h2B4HBHB().pack(_x.shape_reference_point.x_coordinate.value, _x.shape_reference_point.y_coordinate.value, _x.shape_reference_point.z_coordinate.value, _x.shape_reference_point.z_coordinate_is_present, _x.shape_reference_point_is_present, _x.range.value, _x.stationary_horizontal_opening_angle_start.value, _x.stationary_horizontal_opening_angle_end.value, _x.vertical_opening_angle_start.value, _x.vertical_opening_angle_start_is_present, _x.vertical_opening_angle_end.value, _x.vertical_opening_angle_end_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.shape_reference_point is None:
        self.shape_reference_point = etsi_its_vam_ts_msgs.msg.CartesianPosition3d()
      if self.range is None:
        self.range = etsi_its_vam_ts_msgs.msg.StandardLength12b()
      if self.stationary_horizontal_opening_angle_start is None:
        self.stationary_horizontal_opening_angle_start = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.stationary_horizontal_opening_angle_end is None:
        self.stationary_horizontal_opening_angle_end = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.vertical_opening_angle_start is None:
        self.vertical_opening_angle_start = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      if self.vertical_opening_angle_end is None:
        self.vertical_opening_angle_end = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.shape_reference_point.x_coordinate.value, _x.shape_reference_point.y_coordinate.value, _x.shape_reference_point.z_coordinate.value, _x.shape_reference_point.z_coordinate_is_present, _x.shape_reference_point_is_present, _x.range.value, _x.stationary_horizontal_opening_angle_start.value, _x.stationary_horizontal_opening_angle_end.value, _x.vertical_opening_angle_start.value, _x.vertical_opening_angle_start_is_present, _x.vertical_opening_angle_end.value, _x.vertical_opening_angle_end_is_present,) = _get_struct_3h2B4HBHB().unpack(str[start:end])
      self.shape_reference_point.z_coordinate_is_present = bool(self.shape_reference_point.z_coordinate_is_present)
      self.shape_reference_point_is_present = bool(self.shape_reference_point_is_present)
      self.vertical_opening_angle_start_is_present = bool(self.vertical_opening_angle_start_is_present)
      self.vertical_opening_angle_end_is_present = bool(self.vertical_opening_angle_end_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3h2B4HBHB().pack(_x.shape_reference_point.x_coordinate.value, _x.shape_reference_point.y_coordinate.value, _x.shape_reference_point.z_coordinate.value, _x.shape_reference_point.z_coordinate_is_present, _x.shape_reference_point_is_present, _x.range.value, _x.stationary_horizontal_opening_angle_start.value, _x.stationary_horizontal_opening_angle_end.value, _x.vertical_opening_angle_start.value, _x.vertical_opening_angle_start_is_present, _x.vertical_opening_angle_end.value, _x.vertical_opening_angle_end_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.shape_reference_point is None:
        self.shape_reference_point = etsi_its_vam_ts_msgs.msg.CartesianPosition3d()
      if self.range is None:
        self.range = etsi_its_vam_ts_msgs.msg.StandardLength12b()
      if self.stationary_horizontal_opening_angle_start is None:
        self.stationary_horizontal_opening_angle_start = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.stationary_horizontal_opening_angle_end is None:
        self.stationary_horizontal_opening_angle_end = etsi_its_vam_ts_msgs.msg.Wgs84AngleValue()
      if self.vertical_opening_angle_start is None:
        self.vertical_opening_angle_start = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      if self.vertical_opening_angle_end is None:
        self.vertical_opening_angle_end = etsi_its_vam_ts_msgs.msg.CartesianAngleValue()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.shape_reference_point.x_coordinate.value, _x.shape_reference_point.y_coordinate.value, _x.shape_reference_point.z_coordinate.value, _x.shape_reference_point.z_coordinate_is_present, _x.shape_reference_point_is_present, _x.range.value, _x.stationary_horizontal_opening_angle_start.value, _x.stationary_horizontal_opening_angle_end.value, _x.vertical_opening_angle_start.value, _x.vertical_opening_angle_start_is_present, _x.vertical_opening_angle_end.value, _x.vertical_opening_angle_end_is_present,) = _get_struct_3h2B4HBHB().unpack(str[start:end])
      self.shape_reference_point.z_coordinate_is_present = bool(self.shape_reference_point.z_coordinate_is_present)
      self.shape_reference_point_is_present = bool(self.shape_reference_point_is_present)
      self.vertical_opening_angle_start_is_present = bool(self.vertical_opening_angle_start_is_present)
      self.vertical_opening_angle_end_is_present = bool(self.vertical_opening_angle_end_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3h2B4HBHB = None
def _get_struct_3h2B4HBHB():
    global _struct_3h2B4HBHB
    if _struct_3h2B4HBHB is None:
        _struct_3h2B4HBHB = struct.Struct("<3h2B4HBHB")
    return _struct_3h2B4HBHB
