# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/RadialShapes.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class RadialShapes(genpy.Message):
  _md5sum = "39db1dca6ec499597d69b4f6df8e6d97"
  _type = "etsi_its_vam_ts_msgs/RadialShapes"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a list of radial shapes. 
#  *
#  * It shall include the following components:
# 
#  * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
#  * 
#  * @field xCoordinate: the x-coordinate of the offset point.
#  *
#  * @field yCoordinate: the y-coordinate of the offset point.
#  *
#  * @field zCoordinate: the optional z-coordinate of the offset point.
#  *
#  * @field radialShapesList: the list of radial shape details.
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */ 
# RadialShapes ::= SEQUENCE {
#     refPointId          Identifier1B,
#     xCoordinate         CartesianCoordinateSmall, 
#     yCoordinate         CartesianCoordinateSmall,
#     zCoordinate         CartesianCoordinateSmall OPTIONAL,
#     radialShapesList    RadialShapesList
# }
# ------------------------------------------------------------------------------

Identifier1B ref_point_id

CartesianCoordinateSmall x_coordinate

CartesianCoordinateSmall y_coordinate

CartesianCoordinateSmall z_coordinate
bool z_coordinate_is_present

RadialShapesList radial_shapes_list


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianCoordinateSmall
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
#  *
#  * The value shall be set to:
#  * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
#  * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
#  * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
#  *
#  * @unit 0,01 m
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianCoordinateSmall::= INTEGER {
#     negativeOutOfRange (-3094),
#     positiveOutOfRange (1001)
# } (-3094..1001) 
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -3094
int16 MAX = 1001
int16 NEGATIVE_OUT_OF_RANGE = -3094
int16 POSITIVE_OUT_OF_RANGE = 1001


================================================================================
MSG: etsi_its_vam_ts_msgs/RadialShapesList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * The DF contains a list of @ref RadialShapeDetails.
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */
# RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
# ------------------------------------------------------------------------------

RadialShapeDetails[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_vam_ts_msgs/RadialShapeDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF describes a radial shape details. The triangular or cone-shaped volume is
#  * constructed by sweeping the provided range about the reference point  or about the offset
#  * point (if provided) between a horizontal start and a horizontal end angle in positive angular direction of the WGS84
#  * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
#  * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
#  * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
#  * above intersections).
#  *
#  * It shall include the following components:
#  * 
#  * @field range: the radial range of the sensor from the reference point or sensor point offset. 
#  *
#  * @field horizontalOpeningAngleStart:  the orientation indicating the beginning of the 
#  * shape's horizontal opening angle in positive angular direction.
#  *
#  * @field horizontalOpeningAngleEnd: The orientation indicating the end of the shape's horizontal 
#  * opening angle in positive angular direction.
#  *
#  * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system.
#  *
#  * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's 
#  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis 
#  * located in the north-east plane of the WGS84 coordinate system. 
#  *
#  * @category: Georeference information
#  * @revision: created in V2.1.1
#  */
# RadialShapeDetails ::= SEQUENCE {
#     range                          StandardLength12b,
#     horizontalOpeningAngleStart    CartesianAngleValue,
#     horizontalOpeningAngleEnd      CartesianAngleValue,
#     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
#     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
# }
# ------------------------------------------------------------------------------

StandardLength12b range

CartesianAngleValue horizontal_opening_angle_start

CartesianAngleValue horizontal_opening_angle_end

CartesianAngleValue vertical_opening_angle_start
bool vertical_opening_angle_start_is_present

CartesianAngleValue vertical_opening_angle_end
bool vertical_opening_angle_end_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/StandardLength12b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
#  *
#  * @unit: 0,1 metre
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# StandardLength12b::= INTEGER (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
#  * a right-hand local coordinate system from the abscissa.
#  *
#  * The value shall be set to: 
#  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
#  * - `36001` if the accuracy information is not available.
#  *
#  * The value 3600 shall not be used. 
#  * 
#  * @unit 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601

"""
  __slots__ = ['ref_point_id','x_coordinate','y_coordinate','z_coordinate','z_coordinate_is_present','radial_shapes_list']
  _slot_types = ['etsi_its_vam_ts_msgs/Identifier1B','etsi_its_vam_ts_msgs/CartesianCoordinateSmall','etsi_its_vam_ts_msgs/CartesianCoordinateSmall','etsi_its_vam_ts_msgs/CartesianCoordinateSmall','bool','etsi_its_vam_ts_msgs/RadialShapesList']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ref_point_id,x_coordinate,y_coordinate,z_coordinate,z_coordinate_is_present,radial_shapes_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadialShapes, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.z_coordinate_is_present is None:
        self.z_coordinate_is_present = False
      if self.radial_shapes_list is None:
        self.radial_shapes_list = etsi_its_vam_ts_msgs.msg.RadialShapesList()
    else:
      self.ref_point_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      self.x_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      self.y_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      self.z_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      self.z_coordinate_is_present = False
      self.radial_shapes_list = etsi_its_vam_ts_msgs.msg.RadialShapesList()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_B3hB().pack(_x.ref_point_id.value, _x.x_coordinate.value, _x.y_coordinate.value, _x.z_coordinate.value, _x.z_coordinate_is_present))
      length = len(self.radial_shapes_list.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.radial_shapes_list.array:
        _v1 = val1.range
        _x = _v1.value
        buff.write(_get_struct_H().pack(_x))
        _v2 = val1.horizontal_opening_angle_start
        _x = _v2.value
        buff.write(_get_struct_H().pack(_x))
        _v3 = val1.horizontal_opening_angle_end
        _x = _v3.value
        buff.write(_get_struct_H().pack(_x))
        _v4 = val1.vertical_opening_angle_start
        _x = _v4.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.vertical_opening_angle_end
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.radial_shapes_list is None:
        self.radial_shapes_list = etsi_its_vam_ts_msgs.msg.RadialShapesList()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.ref_point_id.value, _x.x_coordinate.value, _x.y_coordinate.value, _x.z_coordinate.value, _x.z_coordinate_is_present,) = _get_struct_B3hB().unpack(str[start:end])
      self.z_coordinate_is_present = bool(self.z_coordinate_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.radial_shapes_list.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.RadialShapeDetails()
        _v6 = val1.range
        start = end
        end += 2
        (_v6.value,) = _get_struct_H().unpack(str[start:end])
        _v7 = val1.horizontal_opening_angle_start
        start = end
        end += 2
        (_v7.value,) = _get_struct_H().unpack(str[start:end])
        _v8 = val1.horizontal_opening_angle_end
        start = end
        end += 2
        (_v8.value,) = _get_struct_H().unpack(str[start:end])
        _v9 = val1.vertical_opening_angle_start
        start = end
        end += 2
        (_v9.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_start_is_present = bool(val1.vertical_opening_angle_start_is_present)
        _v10 = val1.vertical_opening_angle_end
        start = end
        end += 2
        (_v10.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_end_is_present = bool(val1.vertical_opening_angle_end_is_present)
        self.radial_shapes_list.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_B3hB().pack(_x.ref_point_id.value, _x.x_coordinate.value, _x.y_coordinate.value, _x.z_coordinate.value, _x.z_coordinate_is_present))
      length = len(self.radial_shapes_list.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.radial_shapes_list.array:
        _v11 = val1.range
        _x = _v11.value
        buff.write(_get_struct_H().pack(_x))
        _v12 = val1.horizontal_opening_angle_start
        _x = _v12.value
        buff.write(_get_struct_H().pack(_x))
        _v13 = val1.horizontal_opening_angle_end
        _x = _v13.value
        buff.write(_get_struct_H().pack(_x))
        _v14 = val1.vertical_opening_angle_start
        _x = _v14.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_start_is_present
        buff.write(_get_struct_B().pack(_x))
        _v15 = val1.vertical_opening_angle_end
        _x = _v15.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.vertical_opening_angle_end_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.ref_point_id is None:
        self.ref_point_id = etsi_its_vam_ts_msgs.msg.Identifier1B()
      if self.x_coordinate is None:
        self.x_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.y_coordinate is None:
        self.y_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.z_coordinate is None:
        self.z_coordinate = etsi_its_vam_ts_msgs.msg.CartesianCoordinateSmall()
      if self.radial_shapes_list is None:
        self.radial_shapes_list = etsi_its_vam_ts_msgs.msg.RadialShapesList()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.ref_point_id.value, _x.x_coordinate.value, _x.y_coordinate.value, _x.z_coordinate.value, _x.z_coordinate_is_present,) = _get_struct_B3hB().unpack(str[start:end])
      self.z_coordinate_is_present = bool(self.z_coordinate_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.radial_shapes_list.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.RadialShapeDetails()
        _v16 = val1.range
        start = end
        end += 2
        (_v16.value,) = _get_struct_H().unpack(str[start:end])
        _v17 = val1.horizontal_opening_angle_start
        start = end
        end += 2
        (_v17.value,) = _get_struct_H().unpack(str[start:end])
        _v18 = val1.horizontal_opening_angle_end
        start = end
        end += 2
        (_v18.value,) = _get_struct_H().unpack(str[start:end])
        _v19 = val1.vertical_opening_angle_start
        start = end
        end += 2
        (_v19.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_start_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_start_is_present = bool(val1.vertical_opening_angle_start_is_present)
        _v20 = val1.vertical_opening_angle_end
        start = end
        end += 2
        (_v20.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.vertical_opening_angle_end_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.vertical_opening_angle_end_is_present = bool(val1.vertical_opening_angle_end_is_present)
        self.radial_shapes_list.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B3hB = None
def _get_struct_B3hB():
    global _struct_B3hB
    if _struct_B3hB is None:
        _struct_B3hB = struct.Struct("<B3hB")
    return _struct_B3hB
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
