# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/SafeDistanceIndication.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class SafeDistanceIndication(genpy.Message):
  _md5sum = "3a0fb8f493fb4bb2d7552ecd1960483e"
  _type = "etsi_its_vam_ts_msgs/SafeDistanceIndication"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the safe distance indication of a traffic participant with other traffic participant(s).
#  *
#  * It shall include the following components: 
#  * 
#  * @field subjectStation: optionally indicates one "other" traffic participant identified by its ITS-S.
#  *  
#  * @field safeDistanceIndicator: indicates whether the distance between the ego ITS-S and the traffic participant(s) is safe.
#  * If subjectStation is present then it indicates whether the distance between the ego ITS-S and the traffic participant indicated in the component subjectStation is safe. 
#  *
#  * @field timeToCollision: optionally indicated the time-to-collision calculated as sqrt(LaDi^2 + LoDi^2 + VDi^2/relative speed 
#  * and represented in  the  nearest 100  ms. This component may be present only if subjectStation is present. 
#  *
#  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
#  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
#  */
# SafeDistanceIndication ::= SEQUENCE {
#     subjectStation           StationId OPTIONAL,
#     safeDistanceIndicator    SafeDistanceIndicator,
#     timeToCollision          DeltaTimeTenthOfSecond OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

StationId subject_station
bool subject_station_is_present

SafeDistanceIndicator safe_distance_indicator

DeltaTimeTenthOfSecond time_to_collision
bool time_to_collision_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/StationId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the identifier of an ITS-S.
#  * The ITS-S ID may be a pseudonym. It may change over space and/or over time.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1 based on @ref StationID
#  */
# StationId ::= INTEGER(0..4294967295)
# ------------------------------------------------------------------------------

uint32 value
uint32 MIN = 0
uint32 MAX = 4294967295


================================================================================
MSG: etsi_its_vam_ts_msgs/SafeDistanceIndicator
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates if a distance is safe. 
#  *
#  * The value shall be set to:
#  * -  `FALSE`  if  the triple  {LaD,  LoD, VD} < {MSLaD, MSLoD, MSVD} is simultaneously  satisfied with confidence level of  90 % or  more, 
#  * -  `TRUE` otherwise. 
#  *
#  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
#  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
# */
# SafeDistanceIndicator::= BOOLEAN
# ------------------------------------------------------------------------------

bool value


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `0` for a difference in time of 0 seconds. 
#  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
#  *
#  * @unit: 0,1 s
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# DeltaTimeTenthOfSecond::= INTEGER {
#     unavailable (127)  
# } (0..127) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 UNAVAILABLE = 127

"""
  __slots__ = ['subject_station','subject_station_is_present','safe_distance_indicator','time_to_collision','time_to_collision_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/StationId','bool','etsi_its_vam_ts_msgs/SafeDistanceIndicator','etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       subject_station,subject_station_is_present,safe_distance_indicator,time_to_collision,time_to_collision_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SafeDistanceIndication, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.subject_station is None:
        self.subject_station = etsi_its_vam_ts_msgs.msg.StationId()
      if self.subject_station_is_present is None:
        self.subject_station_is_present = False
      if self.safe_distance_indicator is None:
        self.safe_distance_indicator = etsi_its_vam_ts_msgs.msg.SafeDistanceIndicator()
      if self.time_to_collision is None:
        self.time_to_collision = etsi_its_vam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      if self.time_to_collision_is_present is None:
        self.time_to_collision_is_present = False
    else:
      self.subject_station = etsi_its_vam_ts_msgs.msg.StationId()
      self.subject_station_is_present = False
      self.safe_distance_indicator = etsi_its_vam_ts_msgs.msg.SafeDistanceIndicator()
      self.time_to_collision = etsi_its_vam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      self.time_to_collision_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_I4B().pack(_x.subject_station.value, _x.subject_station_is_present, _x.safe_distance_indicator.value, _x.time_to_collision.value, _x.time_to_collision_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.subject_station is None:
        self.subject_station = etsi_its_vam_ts_msgs.msg.StationId()
      if self.safe_distance_indicator is None:
        self.safe_distance_indicator = etsi_its_vam_ts_msgs.msg.SafeDistanceIndicator()
      if self.time_to_collision is None:
        self.time_to_collision = etsi_its_vam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.subject_station.value, _x.subject_station_is_present, _x.safe_distance_indicator.value, _x.time_to_collision.value, _x.time_to_collision_is_present,) = _get_struct_I4B().unpack(str[start:end])
      self.subject_station_is_present = bool(self.subject_station_is_present)
      self.safe_distance_indicator.value = bool(self.safe_distance_indicator.value)
      self.time_to_collision_is_present = bool(self.time_to_collision_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_I4B().pack(_x.subject_station.value, _x.subject_station_is_present, _x.safe_distance_indicator.value, _x.time_to_collision.value, _x.time_to_collision_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.subject_station is None:
        self.subject_station = etsi_its_vam_ts_msgs.msg.StationId()
      if self.safe_distance_indicator is None:
        self.safe_distance_indicator = etsi_its_vam_ts_msgs.msg.SafeDistanceIndicator()
      if self.time_to_collision is None:
        self.time_to_collision = etsi_its_vam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.subject_station.value, _x.subject_station_is_present, _x.safe_distance_indicator.value, _x.time_to_collision.value, _x.time_to_collision_is_present,) = _get_struct_I4B().unpack(str[start:end])
      self.subject_station_is_present = bool(self.subject_station_is_present)
      self.safe_distance_indicator.value = bool(self.safe_distance_indicator.value)
      self.time_to_collision_is_present = bool(self.time_to_collision_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I4B = None
def _get_struct_I4B():
    global _struct_I4B
    if _struct_I4B is None:
        _struct_I4B = struct.Struct("<I4B")
    return _struct_I4B
