# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/VruClusterOperationContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class VruClusterOperationContainer(genpy.Message):
  _md5sum = "209f35a3d55bfa0efad780f9a9749298"
  _type = "etsi_its_vam_ts_msgs/VruClusterOperationContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
#  /**
#  * @details VruClusterOperationContainer
#  * The VRU Cluster Operation container of the VAM provides information relevant to change of cluster state and composition.
#  * It is mandatory if the VAM is transmitted by a VRU joining, leaving or breaking up a cluster.
#  * It includes the following components (setting indications are specified in clause 7.3.5 of TS 103 300-3). 
#  * At least one of the fields below shall be present if the container is present in the VAM: 
#  *
#  * @field clusterJoinInfo: indicates the intent of an individual VAM transmitter to join a cluster. 
#  * @field clusterLeaveInfo : indicates that an individual VAM transmitter has recently left the VRU cluster. 
#  * @field clusterBreakupInfo: indicates the intent of a cluster VAM transmitter to stop sending cluster VAMs. 
#  * @field clusterIdChangeTimeInfo: indicates the intent of a cluster VAM transmitter to change cluster ID. 
#  * 
#  * @category: VRU information
#  * @revision: V2.2.1
#  */
#     VruClusterOperationContainer ::= SEQUENCE {
#         clusterJoinInfo         ClusterJoinInfo OPTIONAL,
#         clusterLeaveInfo        ClusterLeaveInfo OPTIONAL,
#         clusterBreakupInfo      ClusterBreakupInfo OPTIONAL,
#         clusterIdChangeTimeInfo DeltaTimeQuarterSecond OPTIONAL,
#         ...
#     }
# ------------------------------------------------------------------------------

ClusterJoinInfo cluster_join_info
bool cluster_join_info_is_present

ClusterLeaveInfo cluster_leave_info
bool cluster_leave_info_is_present

ClusterBreakupInfo cluster_breakup_info
bool cluster_breakup_info_is_present

DeltaTimeQuarterSecond cluster_id_change_time_info
bool cluster_id_change_time_info_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterJoinInfo
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides information about the joining of a cluster.
#  *
#  * It shall include the following components: 
#  * 
#  * @field clusterId: indicates the identifier of the cluster.
#  * 
#  * @field joinTime: indicates the time of joining. 
#  *
#  * @category: Cluster Information
#  * @revision: Created in V2.1.1
#  */
# ClusterJoinInfo ::= SEQUENCE {
#     clusterId    Identifier1B,
#     joinTime     DeltaTimeQuarterSecond,
#     ...
# }
# ------------------------------------------------------------------------------

Identifier1B cluster_id

DeltaTimeQuarterSecond join_time


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaTimeQuarterSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  * It can be interpreted as the first 8 bits of a GenerationDeltaTime. To convert it to a @ref GenerationDeltaTime, 
#  * multiply by 256 (i.e. append a `00` byte)
#  *
#  * @unit: 256 * 0,001 s 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# DeltaTimeQuarterSecond::= INTEGER {
#     unavailable (255)  
# } (1..255) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 255
uint8 UNAVAILABLE = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterLeaveInfo
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DF provides information about the leaving of a cluster.
#  *
#  * It shall include the following components: 
#  * 
#  * @field clusterId: indicates the cluster.
#  * 
#  * @field clusterLeaveReason: indicates the reason for leaving. 
#  *
#  * @category: Cluster Information
#  * @revision: Created in V2.1.1
#  */
# ClusterLeaveInfo ::= SEQUENCE {
#     clusterId             Identifier1B,
#     clusterLeaveReason    ClusterLeaveReason,
#     ...
# }
# ------------------------------------------------------------------------------

Identifier1B cluster_id

ClusterLeaveReason cluster_leave_reason


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterLeaveReason
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the reason why a cluster participant is leaving the cluster.
#  * 
#  * The value shall be set to:
#  * - 0 - `notProvided `                 - if the information is not provided,
#  * - 1 - `clusterLeaderLost`            - if the cluster leader cannot be found anymore,   
#  * - 2 - `clusterDisbandedByLeader`     - if the cluster has been disbanded by the leader,
#  * - 3 - `outOfClusterBoundingBox`      - if the participants moved out of the cluster's bounding box,
#  * - 4 - `outOfClusterSpeedRange`       - if the cluster speed moved out of a defined range, 
#  * - 5 - `joiningAnotherCluster`        - if the participant is joining another cluster,
#  * - 6 - `cancelledJoin`                - if the participant is cancelling a joining procedure,
#  * - 7 - `failedJoin`                   - if the participant failed to join the cluster,
#  * - 8 - `safetyCondition`              - if a safety condition applies.
#  * - 9 to 15                            - are reserved for future use                             
#  *
#  * @category: Cluster information
#  * @revision: Created in V2.1.1
#  */
# ClusterLeaveReason ::= ENUMERATED {
#     notProvided                   (0), 
#     clusterLeaderLost             (1),    
#     clusterDisbandedByLeader      (2),    
#     outOfClusterBoundingBox       (3),    
#     outOfClusterSpeedRange        (4),
#     joiningAnotherCluster         (5),
#     cancelledJoin                 (6),
#     failedJoin                    (7),
#     safetyCondition               (8),
#     max(15)            
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NOT_PROVIDED = 0
uint8 CLUSTER_LEADER_LOST = 1
uint8 CLUSTER_DISBANDED_BY_LEADER = 2
uint8 OUT_OF_CLUSTER_BOUNDING_BOX = 3
uint8 OUT_OF_CLUSTER_SPEED_RANGE = 4
uint8 JOINING_ANOTHER_CLUSTER = 5
uint8 CANCELLED_JOIN = 6
uint8 FAILED_JOIN = 7
uint8 SAFETY_CONDITION = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterBreakupInfo
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides information about the breakup of a cluster.
#  *
#  * It shall include the following components: 
#  * 
#  * @field clusterBreakupReason: indicates the reason for breakup.
#  * 
#  * @field breakupTime: indicates the time of breakup. 
#  *
#  * @category: Cluster Information
#  * @revision: Created in V2.1.1
#  */
# ClusterBreakupInfo ::= SEQUENCE {
#     clusterBreakupReason    ClusterBreakupReason,
#     breakupTime             DeltaTimeQuarterSecond,
#     ...
# }
# ------------------------------------------------------------------------------

ClusterBreakupReason cluster_breakup_reason

DeltaTimeQuarterSecond breakup_time


================================================================================
MSG: etsi_its_vam_ts_msgs/ClusterBreakupReason
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the reason why a cluster leader intends to break up the cluster.
#  * 
#  * The value shall be set to:
#  * - 0 - `notProvided`                          - if the information is not provided,
#  * - 1 - `clusteringPurposeCompleted`           - if the cluster purpose has been completed,
#  * - 2 - `leaderMovedOutOfClusterBoundingBox`   - if the leader moved out of the cluster's bounding box,
#  * - 3 - `joiningAnotherCluster`                - if the cluster leader is about to join another cluster,
#  * - 4 - `enteringLowRiskAreaBasedOnMaps`       - if the cluster is entering an area idenrified as low risk based on the use of maps,
#  * - 5 - `receptionOfCpmContainingCluster`      - if the leader received a Collective Perception Message containing information about the same cluster. 
#  * - 6 to 15                                    - are reserved for future use.                                    
#  *
#  * @category: Cluster information
#  * @revision: Created in V2.1.1
# */
# ClusterBreakupReason ::= ENUMERATED {
#     notProvided                        (0),
#     clusteringPurposeCompleted         (1),
#     leaderMovedOutOfClusterBoundingBox (2),    
#     joiningAnotherCluster              (3),
#     enteringLowRiskAreaBasedOnMaps     (4),
#     receptionOfCpmContainingCluster    (5),
#     max(15)                                                                 
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 NOT_PROVIDED = 0
uint8 CLUSTERING_PURPOSE_COMPLETED = 1
uint8 LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX = 2
uint8 JOINING_ANOTHER_CLUSTER = 3
uint8 ENTERING_LOW_RISK_AREA_BASED_ON_MAPS = 4
uint8 RECEPTION_OF_CPM_CONTAINING_CLUSTER = 5
uint8 MAX = 15

"""
  __slots__ = ['cluster_join_info','cluster_join_info_is_present','cluster_leave_info','cluster_leave_info_is_present','cluster_breakup_info','cluster_breakup_info_is_present','cluster_id_change_time_info','cluster_id_change_time_info_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/ClusterJoinInfo','bool','etsi_its_vam_ts_msgs/ClusterLeaveInfo','bool','etsi_its_vam_ts_msgs/ClusterBreakupInfo','bool','etsi_its_vam_ts_msgs/DeltaTimeQuarterSecond','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cluster_join_info,cluster_join_info_is_present,cluster_leave_info,cluster_leave_info_is_present,cluster_breakup_info,cluster_breakup_info_is_present,cluster_id_change_time_info,cluster_id_change_time_info_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VruClusterOperationContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cluster_join_info is None:
        self.cluster_join_info = etsi_its_vam_ts_msgs.msg.ClusterJoinInfo()
      if self.cluster_join_info_is_present is None:
        self.cluster_join_info_is_present = False
      if self.cluster_leave_info is None:
        self.cluster_leave_info = etsi_its_vam_ts_msgs.msg.ClusterLeaveInfo()
      if self.cluster_leave_info_is_present is None:
        self.cluster_leave_info_is_present = False
      if self.cluster_breakup_info is None:
        self.cluster_breakup_info = etsi_its_vam_ts_msgs.msg.ClusterBreakupInfo()
      if self.cluster_breakup_info_is_present is None:
        self.cluster_breakup_info_is_present = False
      if self.cluster_id_change_time_info is None:
        self.cluster_id_change_time_info = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      if self.cluster_id_change_time_info_is_present is None:
        self.cluster_id_change_time_info_is_present = False
    else:
      self.cluster_join_info = etsi_its_vam_ts_msgs.msg.ClusterJoinInfo()
      self.cluster_join_info_is_present = False
      self.cluster_leave_info = etsi_its_vam_ts_msgs.msg.ClusterLeaveInfo()
      self.cluster_leave_info_is_present = False
      self.cluster_breakup_info = etsi_its_vam_ts_msgs.msg.ClusterBreakupInfo()
      self.cluster_breakup_info_is_present = False
      self.cluster_id_change_time_info = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      self.cluster_id_change_time_info_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_11B().pack(_x.cluster_join_info.cluster_id.value, _x.cluster_join_info.join_time.value, _x.cluster_join_info_is_present, _x.cluster_leave_info.cluster_id.value, _x.cluster_leave_info.cluster_leave_reason.value, _x.cluster_leave_info_is_present, _x.cluster_breakup_info.cluster_breakup_reason.value, _x.cluster_breakup_info.breakup_time.value, _x.cluster_breakup_info_is_present, _x.cluster_id_change_time_info.value, _x.cluster_id_change_time_info_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cluster_join_info is None:
        self.cluster_join_info = etsi_its_vam_ts_msgs.msg.ClusterJoinInfo()
      if self.cluster_leave_info is None:
        self.cluster_leave_info = etsi_its_vam_ts_msgs.msg.ClusterLeaveInfo()
      if self.cluster_breakup_info is None:
        self.cluster_breakup_info = etsi_its_vam_ts_msgs.msg.ClusterBreakupInfo()
      if self.cluster_id_change_time_info is None:
        self.cluster_id_change_time_info = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.cluster_join_info.cluster_id.value, _x.cluster_join_info.join_time.value, _x.cluster_join_info_is_present, _x.cluster_leave_info.cluster_id.value, _x.cluster_leave_info.cluster_leave_reason.value, _x.cluster_leave_info_is_present, _x.cluster_breakup_info.cluster_breakup_reason.value, _x.cluster_breakup_info.breakup_time.value, _x.cluster_breakup_info_is_present, _x.cluster_id_change_time_info.value, _x.cluster_id_change_time_info_is_present,) = _get_struct_11B().unpack(str[start:end])
      self.cluster_join_info_is_present = bool(self.cluster_join_info_is_present)
      self.cluster_leave_info_is_present = bool(self.cluster_leave_info_is_present)
      self.cluster_breakup_info_is_present = bool(self.cluster_breakup_info_is_present)
      self.cluster_id_change_time_info_is_present = bool(self.cluster_id_change_time_info_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_11B().pack(_x.cluster_join_info.cluster_id.value, _x.cluster_join_info.join_time.value, _x.cluster_join_info_is_present, _x.cluster_leave_info.cluster_id.value, _x.cluster_leave_info.cluster_leave_reason.value, _x.cluster_leave_info_is_present, _x.cluster_breakup_info.cluster_breakup_reason.value, _x.cluster_breakup_info.breakup_time.value, _x.cluster_breakup_info_is_present, _x.cluster_id_change_time_info.value, _x.cluster_id_change_time_info_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cluster_join_info is None:
        self.cluster_join_info = etsi_its_vam_ts_msgs.msg.ClusterJoinInfo()
      if self.cluster_leave_info is None:
        self.cluster_leave_info = etsi_its_vam_ts_msgs.msg.ClusterLeaveInfo()
      if self.cluster_breakup_info is None:
        self.cluster_breakup_info = etsi_its_vam_ts_msgs.msg.ClusterBreakupInfo()
      if self.cluster_id_change_time_info is None:
        self.cluster_id_change_time_info = etsi_its_vam_ts_msgs.msg.DeltaTimeQuarterSecond()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.cluster_join_info.cluster_id.value, _x.cluster_join_info.join_time.value, _x.cluster_join_info_is_present, _x.cluster_leave_info.cluster_id.value, _x.cluster_leave_info.cluster_leave_reason.value, _x.cluster_leave_info_is_present, _x.cluster_breakup_info.cluster_breakup_reason.value, _x.cluster_breakup_info.breakup_time.value, _x.cluster_breakup_info_is_present, _x.cluster_id_change_time_info.value, _x.cluster_id_change_time_info_is_present,) = _get_struct_11B().unpack(str[start:end])
      self.cluster_join_info_is_present = bool(self.cluster_join_info_is_present)
      self.cluster_leave_info_is_present = bool(self.cluster_leave_info_is_present)
      self.cluster_breakup_info_is_present = bool(self.cluster_breakup_info_is_present)
      self.cluster_id_change_time_info_is_present = bool(self.cluster_id_change_time_info_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_11B = None
def _get_struct_11B():
    global _struct_11B
    if _struct_11B is None:
        _struct_11B = struct.Struct("<11B")
    return _struct_11B
