# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/VruExteriorLights.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class VruExteriorLights(genpy.Message):
  _md5sum = "d11e6c7cb9ea62c0b1d95fe9f1f1f55b"
  _type = "etsi_its_vam_ts_msgs/VruExteriorLights"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the status of the exterior light switches of a VRU.
#  * This DF is an extension of the vehicular DE @ref ExteriorLights.
#  *
#  * It shall include the following components: 
#  * 
#  * @field vehicular:  represents the status of the exterior light switches of a road vehicle.
#  * 
#  * @field vruSpecific: represents the status of the exterior light switches of a VRU.
#  *
#  * @category: VRU information
#  * @revision: created in V2.1.1
#  */
# VruExteriorLights ::= SEQUENCE {
#    vehicular      ExteriorLights, 
#    vruSpecific    VruSpecificExteriorLights,
#    ...
# }
# ------------------------------------------------------------------------------

ExteriorLights vehicular

VruSpecificExteriorLights vru_specific


================================================================================
MSG: etsi_its_vam_ts_msgs/ExteriorLights
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
#  * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
#  * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
#  * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
#  * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
#  * - 5 - `reverseLightOn`         - when the reverse light switch is on,
#  * - 6 - `fogLightOn`             - when the tail fog light switch is on,
#  * - 7 - `parkingLightsOn`        - when the parking light switch is on.
#  * 
#  * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
#  * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
#  * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
#  * if the corresponding lamps are alight or not.
#  * 
#  * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
#  * the corresponding bit shall be set to `0`.
#  * 
#  * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
#  * alternate with the blinking interval.
#  * 
#  * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
#  * 
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# ExteriorLights ::= BIT STRING {
#     lowBeamHeadlightsOn      (0),
#     highBeamHeadlightsOn     (1),
#     leftTurnSignalOn         (2),
#     rightTurnSignalOn        (3),
#     daytimeRunningLightsOn   (4),
#     reverseLightOn           (5),
#     fogLightOn               (6),
#     parkingLightsOn          (7)
# } (SIZE(8))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 8
uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5
uint8 BIT_INDEX_FOG_LIGHT_ON = 6
uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7


================================================================================
MSG: etsi_its_vam_ts_msgs/VruSpecificExteriorLights
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes the status of the exterior light switches of a VRU.
#  *
#  * The value of each bit indicates the state of the switch, which commands the corresponding light. 
#  * The bit corresponding to a specific light shall be set to 1, when the corresponding switch is turned on, either manually by the driver or VRU 
#  * or automatically by a vehicle or VRU system: 
#  * - 0 `unavailable`     - indicates no information available, 
#  * - 1 `backFlashLight ` - indicates the status of the back flash light,
#  * - 2 `helmetLight`     - indicates the status of the helmet light,
#  * - 3 `armLight`        - indicates the status of the arm light,
#  * - 4 `legLight`        - indicates the status of the leg light,
#  * - 5 `wheelLight`      - indicates the status of the wheel light. 
#  * - Bits 6 to 8         - are reserved for future use. 
#  * The bit values do not indicate if the corresponding lamps are alight or not.
#  * If  VRU is not equipped with a certain light or if the light switch status information is not available, the corresponding bit shall be set to 0.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */ 
# VruSpecificExteriorLights ::= BIT STRING {
#     unavailable    (0),
#     backFlashLight (1),
#     helmetLight    (2),
#     armLight       (3),
#     legLight       (4),
#     wheelLight     (5)
# } (SIZE(8))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 8
uint8 BIT_INDEX_UNAVAILABLE = 0
uint8 BIT_INDEX_BACK_FLASH_LIGHT = 1
uint8 BIT_INDEX_HELMET_LIGHT = 2
uint8 BIT_INDEX_ARM_LIGHT = 3
uint8 BIT_INDEX_LEG_LIGHT = 4
uint8 BIT_INDEX_WHEEL_LIGHT = 5

"""
  __slots__ = ['vehicular','vru_specific']
  _slot_types = ['etsi_its_vam_ts_msgs/ExteriorLights','etsi_its_vam_ts_msgs/VruSpecificExteriorLights']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       vehicular,vru_specific

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VruExteriorLights, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.vehicular is None:
        self.vehicular = etsi_its_vam_ts_msgs.msg.ExteriorLights()
      if self.vru_specific is None:
        self.vru_specific = etsi_its_vam_ts_msgs.msg.VruSpecificExteriorLights()
    else:
      self.vehicular = etsi_its_vam_ts_msgs.msg.ExteriorLights()
      self.vru_specific = etsi_its_vam_ts_msgs.msg.VruSpecificExteriorLights()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.vehicular.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicular.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.vru_specific.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vru_specific.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicular is None:
        self.vehicular = etsi_its_vam_ts_msgs.msg.ExteriorLights()
      if self.vru_specific is None:
        self.vru_specific = etsi_its_vam_ts_msgs.msg.VruSpecificExteriorLights()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.vehicular.value = str[start:end]
      start = end
      end += 1
      (self.vehicular.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.vru_specific.value = str[start:end]
      start = end
      end += 1
      (self.vru_specific.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.vehicular.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicular.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.vru_specific.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vru_specific.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.vehicular is None:
        self.vehicular = etsi_its_vam_ts_msgs.msg.ExteriorLights()
      if self.vru_specific is None:
        self.vru_specific = etsi_its_vam_ts_msgs.msg.VruSpecificExteriorLights()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.vehicular.value = str[start:end]
      start = end
      end += 1
      (self.vehicular.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.vru_specific.value = str[start:end]
      start = end
      end += 1
      (self.vru_specific.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
