# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/VruHighFrequencyContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class VruHighFrequencyContainer(genpy.Message):
  _md5sum = "cff8c830f5144b6d718eec0c99fe2750"
  _type = "etsi_its_vam_ts_msgs/VruHighFrequencyContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * @details VruHighFrequencyContainer
#  * The VRU HF container of the VAM contains potentially fast-changing status information of the VRU ITS-S.
#  * It includes the following components (setting indications are specified in clause 7.3.3 of TS 103 300-3): 
#  * 
#  * @field heading: heading and heading confidence of the originating VRU with regards to the true north. 
#  * @field speed: speed in moving direction and speed confidence of the originating VRU.   
#  * @field longitudinalAcceleration: longitudinal acceleration of the originating VRU. 
#  * @field curvature: related to the actual trajectory of the originating VRU vehicle.
#           _(recommended for VRU Profile 2)_
#  * @field curvatureCalculationMode: indicates whether vehicle yaw-rate is used in the calculation of
#  *        the curvature of the VRU vehicle ITS-S that originates the VAM. _(recommended for VRU Profile 2)_
#  * @field yawRate: yaw rate of originating VRU vehicle. _(recommended for VRU Profile 2)_
#  * @field lateralAcceleration: originating VRU lateral acceleration in the street plane.
#  *        This field shall be present if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_ 
#  * @field verticalAcceleration: vertical acceleration of the originating VRU.
#  *        This field shall be present if the data is available at the originating ITS-S.
#  * @field vruLanePosition: lane position of the referencePosition of a VRU, which is either a VRU-specific non-traffic lane  
#  *        or a standard traffic lane. This field shall be present if the data is available at the originating ITS-S.
#  * @field environment: provides contextual awareness of the VRU among other road users.
#  *        This field shall be present only if the data is available at the originating ITS-S.
#  * @field movementControl: indicates the mechanism used by the VRU to control the  longitudinal movement of the VRU vehicle.
#  *        This field shall be present only if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_
#  * @field orientation : complements the dimensions of the VRU vehicle by defining the angle of the VRU vehicle longitudinal
#  *        axis with regards to the WGS84 north. _(recommended for VRU Profile 2)_
#  * @field rollAngle: provides the angle and angle accuracy between the ground plane and the current orientation of a vehicle's
#  *        y-axis with respect to the ground plane about the x-axis according to the ISO 8855. 
#  *        This field shall be present only if the data is available at the originating ITS-S. _(recommended for VRU Profile 2)_
#  * @field deviceUsage: provides indications from the personal device about the potential 
#  *        activity of the VRU. This field shall be present only if the data is available at the originating ITS-S.
#  *        _(recommended for VRU Profile 1)_
#  * 
#  * @category: VRU information
#  * @revision: V2.2.1
#  */
#     VruHighFrequencyContainer ::= SEQUENCE {
#         heading                  Wgs84Angle,  
#         speed                    Speed, 
#         longitudinalAcceleration LongitudinalAcceleration, 
#         curvature                Curvature OPTIONAL, 
#         curvatureCalculationMode CurvatureCalculationMode OPTIONAL, 
#         yawRate                  YawRate OPTIONAL, 
#         lateralAcceleration      LateralAcceleration OPTIONAL, 
#         verticalAcceleration     VerticalAcceleration OPTIONAL, 
#         vruLanePosition          GeneralizedLanePosition OPTIONAL, 
#         environment              VruEnvironment OPTIONAL,
#         movementControl          VruMovementControl OPTIONAL,
#         orientation              Wgs84Angle OPTIONAL, 
#         rollAngle                CartesianAngle OPTIONAL,  
#         deviceUsage              VruDeviceUsage OPTIONAL,
#         ...
#     }
# ------------------------------------------------------------------------------

Wgs84Angle heading

Speed speed

LongitudinalAcceleration longitudinal_acceleration

Curvature curvature
bool curvature_is_present

CurvatureCalculationMode curvature_calculation_mode
bool curvature_calculation_mode_is_present

YawRate yaw_rate
bool yaw_rate_is_present

LateralAcceleration lateral_acceleration
bool lateral_acceleration_is_present

VerticalAcceleration vertical_acceleration
bool vertical_acceleration_is_present

GeneralizedLanePosition vru_lane_position
bool vru_lane_position_is_present

VruEnvironment environment
bool environment_is_present

VruMovementControl movement_control
bool movement_control_is_present

Wgs84Angle orientation
bool orientation_is_present

CartesianAngle roll_angle
bool roll_angle_is_present

VruDeviceUsage device_usage
bool device_usage_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/Wgs84Angle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents an angular component along with a confidence value in the WGS84 coordinate system.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: the angle value, which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: the confidence value associated to the angle value.
#  *
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# Wgs84Angle ::= SEQUENCE {
#     value         Wgs84AngleValue,
#     confidence    Wgs84AngleConfidence
# }
# ------------------------------------------------------------------------------

Wgs84AngleValue value

Wgs84AngleConfidence confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/Wgs84AngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/Wgs84AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angle confidence value which represents the estimated accuracy of an angle value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 1` and `n < 126`) if the confidence value is equal to or less than n x 0,1 degrees and more than (n-1) x 0,1 degrees,
#  * - `126` if the confidence value is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the confidence value is not available.
#  *
#  *
#  * @unit 0,1 degrees
#  * @category: GeoReference Information
#  * @revision: Created in V2.1.1
# */
# Wgs84AngleConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)  
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_vam_ts_msgs/Speed
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the speed and associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field speedValue: the speed value.
#  * 
#  * @field speedConfidence: the confidence value of the speed value.
#  *
#  * @category: Kinematic information
#  * @revision: V1.3.1
#  */
# Speed ::= SEQUENCE {
#     speedValue         SpeedValue,
#     speedConfidence    SpeedConfidence
# }
# ------------------------------------------------------------------------------

SpeedValue speed_value

SpeedConfidence speed_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/SpeedValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents a speed value, i.e. the magnitude of the velocity-vector. 
#  *
#  * The value shall be set to:
#  * - `0` in a standstill situation.
#  * - `n` (`n > 0` and `n < 16 382`) if the applicable value is equal to or less than n x 0,01 m/s, and greater than (n-1) x 0,01 m/s,
#  * - `16 382` for speed values greater than 163,81 m/s,
#  * - `16 383` if the speed accuracy information is not available.
#  * 
#  * @note: the definition of standstill is out of scope of the present document.
#  *
#  * @unit: 0,01 m/s
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1 (the meaning of 16382 has changed slightly) 
# */
# SpeedValue ::= INTEGER {
#     standstill  (0), 
#     outOfRange  (16382), 
#     unavailable (16383)
# } (0..16383)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 16383
uint16 STANDSTILL = 0
uint16 OUT_OF_RANGE = 16382
uint16 UNAVAILABLE = 16383


================================================================================
MSG: etsi_its_vam_ts_msgs/SpeedConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the speed confidence value which represents the estimated absolute accuracy of a speed value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 126`) if the confidence value is equal to or less than n * 0,01 m/s.
#  * - `126` if the confidence value is out of range, i.e. greater than 1,25 m/s,
#  * - `127` if the confidence value information is not available.
#  *  
#  * @note: The fact that a speed value is received with confidence value set to `unavailable(127)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the speed value may be valid and used by the application.
#  * 
#  * @note: If a speed value is received and its confidence value is set to `outOfRange(126)`, it means that the speed value is not valid 
#  * and therefore cannot be trusted. Such is not useful for the application.
#  *
#  * @unit: 0,01 m/s
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1 
#  */
# SpeedConfidence ::= INTEGER {
#     outOfRange  (126), 
#     unavailable (127)
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalAcceleration
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the vehicle acceleration at longitudinal direction and the confidence value of the longitudinal acceleration.
#  *
#  * It shall include the following components: 
#  *
#  * @field longitudinalAccelerationValue: longitudinal acceleration value at a point in time.
# 
#  * @field longitudinalAccelerationConfidence: confidence value of the longitudinal acceleration value.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationComponent instead. 
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# LongitudinalAcceleration ::= SEQUENCE {
#     longitudinalAccelerationValue         LongitudinalAccelerationValue,
#     longitudinalAccelerationConfidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalAccelerationValue longitudinal_acceleration_value

AccelerationConfidence longitudinal_acceleration_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalAccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
#  /**
#  * This DE represents the vehicle acceleration at longitudinal direction in the centre of the mass of the empty vehicle.
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is braking with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2
#  * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable. 
#  * 
#  * This acceleration is along the tangent plane of the road surface and does not include gravity components.
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.
#  * 
#  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * @unit: 0,1 m/s^2
#  * @category: Vehicle information
#  * @revision: description revised in V2.1.1 (the meaning of 160 has changed slightly). T
#  */
# LongitudinalAccelerationValue::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_vam_ts_msgs/AccelerationConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
#  * - `102` if the confidence value is unavailable.
#  *
#  * The value 0 shall not be used.
#  *
#  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the acceleration value may be valid and used by the application.
#  * 
#  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
#  *
#  * @unit 0,1 m/s^2
#  * @category: Kinematic information
#  * @revision: Description revised in V2.1.1
#  */
# AccelerationConfidence ::= INTEGER {
#     outOfRange                 (101), 
#     unavailable                (102)
# } (0..102)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 102
uint8 OUT_OF_RANGE = 101
uint8 UNAVAILABLE = 102


================================================================================
MSG: etsi_its_vam_ts_msgs/Curvature
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents the curvature of the vehicle trajectory and the associated confidence value.
#  * The curvature detected by a vehicle represents the curvature of actual vehicle trajectory.
#  *
#  * It shall include the following components: 
#  * 
#  * @field curvatureValue: Detected curvature of the vehicle trajectory.
#  * 
#  * @field curvatureConfidence: along with a confidence value of the curvature value with a predefined confidence level. 
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# Curvature ::= SEQUENCE {
#     curvatureValue         CurvatureValue,
#     curvatureConfidence    CurvatureConfidence
# }
# ------------------------------------------------------------------------------

CurvatureValue curvature_value

CurvatureConfidence curvature_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/CurvatureValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE describes vehicle turning curve with the following information:
#  * ```
#  *     Value = 1 / Radius * 10000
#  * ```
#  * wherein radius is the vehicle turning curve radius in metres. 
#  * 
#  * Positive values indicate a turning curve to the left hand side of the driver.
#  * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].
#  *
#  * The value shall be set to:
#  * - `-1023` for  values smaller than -1023,
#  * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,
#  * - `0` when the vehicle is moving straight,
#  * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,
#  * - `1022`, for values  greater than 1021,
#  * - `1023`, if the information is not available.
#  * 
#  * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].
#  * 
#  * @unit: 1 over 10 000 metres
#  * @category: Vehicle information
#  * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)
#  */
# CurvatureValue ::= INTEGER {
#     outOfRangeNegative (-1023),
#     straight           (0),
#     outOfRangePositive (1022), 
#     unavailable        (1023)
# } (-1023..1023)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -1023
int16 MAX = 1023
int16 OUT_OF_RANGE_NEGATIVE = -1023
int16 STRAIGHT = 0
int16 OUT_OF_RANGE_POSITIVE = 1022
int16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_vam_ts_msgs/CurvatureConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,
#  * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,
#  * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,
#  * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,
#  * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,
#  * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,
#  * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,
#  * - 7 - `unavailable`         - if the confidence value is not available.
#  * 
#  * @note:	The fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the curvature value may be valid and used by the application.
#  * 
#  * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid 
#  * and therefore cannot be trusted. Such value is not useful for the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
# */
# CurvatureConfidence ::= ENUMERATED {
#     onePerMeter-0-00002 (0),
#     onePerMeter-0-0001  (1),
#     onePerMeter-0-0005  (2),
#     onePerMeter-0-002   (3),
#     onePerMeter-0-01    (4),
#     onePerMeter-0-1     (5),
#     outOfRange          (6),
#     unavailable         (7)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ONE_PER_METER_0_00002 = 0
uint8 ONE_PER_METER_0_0001 = 1
uint8 ONE_PER_METER_0_0005 = 2
uint8 ONE_PER_METER_0_002 = 3
uint8 ONE_PER_METER_0_01 = 4
uint8 ONE_PER_METER_0_1 = 5
uint8 OUT_OF_RANGE = 6
uint8 UNAVAILABLE = 7


================================================================================
MSG: etsi_its_vam_ts_msgs/CurvatureCalculationMode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE describes whether the yaw rate is used to calculate the curvature for a curvature value.
#  * 
#  * The value shall be set to:
#  * - 0 - `yawRateUsed`    - if the yaw rate is used,
#  * - 1 - `yawRateNotUsed` - if the yaw rate is not used,
#  * - 2 - `unavailable`    - if the information of curvature calculation mode is unknown.
#  *
#  * @category: Vehicle information
#  * @revision: V1.3.1
#  */
# CurvatureCalculationMode ::= ENUMERATED {
#     yawRateUsed    (0), 
#     yawRateNotUsed (1), 
#     unavailable    (2), 
#     ...
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 YAW_RATE_USED = 0
uint8 YAW_RATE_NOT_USED = 1
uint8 UNAVAILABLE = 2


================================================================================
MSG: etsi_its_vam_ts_msgs/YawRate
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a yaw rate of vehicle at a point in time.
#  *
#  * It shall include the following components: 
#  * 
#  * @field yawRateValue: yaw rate value at a point in time.
#  * 
#  * @field yawRateConfidence: confidence value associated to the yaw rate value.
#  * 
#  * @category: Vehicle Information
#  * @revision: V1.3.1
#  */
# YawRate::= SEQUENCE {
#     yawRateValue         YawRateValue,
#     yawRateConfidence    YawRateConfidence
# }
# ------------------------------------------------------------------------------

YawRateValue yaw_rate_value

YawRateConfidence yaw_rate_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/YawRateValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle rotation around z-axis of the coordinate system centred on the centre of mass of the empty-loaded
#  * vehicle. The leading sign denotes the direction of rotation.
#  * 
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  *
#  * The value shall be set to:
#  * - `-32 766` to indicate that the yaw rate is equal to or greater than 327,66 degrees/second to the right,
#  * - `n` (`n > -32 766` and `n <= 0`) to indicate that the rotation is clockwise (i.e. to the right) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `n` (`n > 0` and `n < 32 766`) to indicate that the rotation is anti-clockwise (i.e. to the left) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `32 766` to indicate that the yaw rate is greater than 327.65 degrees/second to the left,
#  * - `32 767` to indicate that the information is not available.
#  * 
#  * The yaw rate value shall be a raw data value, i.e. not filtered, smoothed or otherwise modified.
#  * The reading instant should be the same as for the vehicle acceleration.
#  * 
#  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * 
#  * @unit: 0,01 degree per second. 
#  * @category: Vehicle Information
#  * @revision: Desription revised in V2.1.1 (the meaning of 32766 has changed slightly). 
# */
# YawRateValue ::= INTEGER {
#     negativeOutOfRange (-32766), 
#     positiveOutOfRange (32766), 
#     unavailable        (32767)
# } (-32766..32767)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -32766
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32766
int16 POSITIVE_OUT_OF_RANGE = 32766
int16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/YawRateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the yaw rate confidence value which represents the estimated accuracy for a yaw rate value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `0` if the confidence value is equal to or less than 0,01 degree/second,
#  * - `1` if the confidence value is equal to or less than 0,05 degrees/second or greater than 0,01 degree/second,
#  * - `2` if the confidence value is equal to or less than 0,1 degree/second or greater than 0,05 degree/second,
#  * - `3` if the confidence value is equal to or less than 1 degree/second or greater than 0,1 degree/second,
#  * - `4` if the confidence value is equal to or less than 5 degrees/second or greater than 1 degrees/second,
#  * - `5` if the confidence value is equal to or less than 10 degrees/second or greater than 5 degrees/second,
#  * - `6` if the confidence value is equal to or less than 100 degrees/second or greater than 10 degrees/second,
#  * - `7` if the confidence value is out of range, i.e. greater than 100 degrees/second,
#  * - `8` if the confidence value is unavailable.
#  * 
#  * NOTE: The fact that a yaw rate value is received with confidence value set to `unavailable(8)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the yaw rate value may be valid and used by the application.
#  * 
#  * If a yaw rate value is received and its confidence value is set to `outOfRange(7)`, it means that the 
#  * yaw rate value is not valid and therefore cannot be trusted. Such value is not useful the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# YawRateConfidence ::= ENUMERATED {
#     degSec-000-01 (0),
#     degSec-000-05 (1),
#     degSec-000-10 (2),
#     degSec-001-00 (3), 
#     degSec-005-00 (4),
#     degSec-010-00 (5),
#     degSec-100-00 (6),
#     outOfRange    (7),
#     unavailable   (8)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEG_SEC_000_01 = 0
uint8 DEG_SEC_000_05 = 1
uint8 DEG_SEC_000_10 = 2
uint8 DEG_SEC_001_00 = 3
uint8 DEG_SEC_005_00 = 4
uint8 DEG_SEC_010_00 = 5
uint8 DEG_SEC_100_00 = 6
uint8 OUT_OF_RANGE = 7
uint8 UNAVAILABLE = 8


================================================================================
MSG: etsi_its_vam_ts_msgs/LateralAcceleration
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the vehicle acceleration at lateral direction and the confidence value of the lateral acceleration.
#  *
#  * It shall include the following components: 
#  * 
#  * @field lateralAccelerationValue: lateral acceleration value at a point in time.
#  * 
#  * @field lateralAccelerationConfidence: confidence value of the lateral acceleration value.
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationComponent instead.
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# LateralAcceleration ::= SEQUENCE {
#     lateralAccelerationValue         LateralAccelerationValue,
#     lateralAccelerationConfidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

LateralAccelerationValue lateral_acceleration_value

AccelerationConfidence lateral_acceleration_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LateralAccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle acceleration at lateral direction in the centre of the mass of the empty vehicle.
#  * It corresponds to the vehicle coordinate system as specified in ISO 8855 [21].
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is accelerating towards the right side with regards to the vehicle orientation 
#  *                            with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,
#  * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating towards the left hand side with regards to the vehicle orientation 
# 						     with acceleration equal to or less than n x 0,1 m/s^2 and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  *
#  * @note: the empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.
#  *  
#  * @unit: 0,1 m/s^2
#  * @category: Vehicle information
#  * @revision: Description updated in V2.1.1 (the meaning of 160 has changed slightly). 
#  */
# LateralAccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_vam_ts_msgs/VerticalAcceleration
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the vehicle acceleration at vertical direction and the associated confidence value.
#  *
#  * It shall include the following components: 
#  * 
#  * @field verticalAccelerationValue: vertical acceleration value at a point in time.
#  * 
#  * @field verticalAccelerationConfidence: confidence value of the vertical acceleration value with a predefined confidence level.
#  * 
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationComponent instead.
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# VerticalAcceleration ::= SEQUENCE {
#     verticalAccelerationValue         VerticalAccelerationValue,
#     verticalAccelerationConfidence    AccelerationConfidence
# }
# ------------------------------------------------------------------------------

VerticalAccelerationValue vertical_acceleration_value

AccelerationConfidence vertical_acceleration_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/VerticalAccelerationValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle acceleration at vertical direction in the centre of the mass of the empty vehicle.
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  *
#  * The value shall be set to:
#  * - `-160` for acceleration values equal to or less than -16 m/s^2,
#  * - `n` (`n > -160` and `n <= 0`) to indicate downwards acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `n` (`n > 0` and `n < 160`) to indicate upwards acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
#  * - `160` for acceleration values greater than 15,9 m/s^2,
#  * - `161` when the data is unavailable.
#  * 
#  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  *
#  * @category: Vehicle information
#  * @unit: 0,1 m/s^2
#  * @revision: Desciption updated in V2.1.1 (the meaning of 160 has changed slightly).
#  *  
# */
# VerticalAccelerationValue ::= INTEGER {
#     negativeOutOfRange (-160),
#     positiveOutOfRange (160),
#     unavailable        (161)  
# } (-160 .. 161)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -160
int16 MAX = 161
int16 NEGATIVE_OUT_OF_RANGE = -160
int16 POSITIVE_OUT_OF_RANGE = 160
int16 UNAVAILABLE = 161


================================================================================
MSG: etsi_its_vam_ts_msgs/GeneralizedLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a transversal position in relation to the different lanes of the road. 
#  * It is an extension of DE_LanePosition to cover locations (sidewalks, bicycle paths), where Vehicle ITS-S would normally not be present. 
#  *
#  * The following options are available:
#  *
#  * @field trafficLanePosition: a position on a traffic lane. 
#  * 
#  * @field nonTrafficLanePosition: a position on a lane which is not a traffic lane.
#  * 
#  * @field trafficIslandPosition: a position on a traffic island
#  * 
#  * @field mapPosition: a position on a lane identified in a MAPEM.
#  *  
#  * @category: Road Topology information
#  * @revision: created in V2.1.1
#  */
# GeneralizedLanePosition::= CHOICE {
#     trafficLanePosition       LanePosition,
#     nonTrafficLanePosition    LanePositionAndType,
#     trafficIslandPosition     TrafficIslandPosition,
#     mapPosition               MapPosition,
#     ...
# }	
# ------------------------------------------------------------------------------

uint8 choice

LanePosition traffic_lane_position
uint8 CHOICE_TRAFFIC_LANE_POSITION = 0

LanePositionAndType non_traffic_lane_position
uint8 CHOICE_NON_TRAFFIC_LANE_POSITION = 1

TrafficIslandPosition traffic_island_position
uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 2

MapPosition map_position
uint8 CHOICE_MAP_POSITION = 3


================================================================================
MSG: etsi_its_vam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
#  *
#  * For right-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
#  *
#  * For left-hand traffic roads, the value shall be set to:
#  * - `-1` if the position is off, i.e. besides the road,
#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# 
#  *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
#  *
#  * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
#  * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
#  * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# 
#  * @category: Road topology information
#  * @revision: Description revised in V2.1.1
# */
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14


================================================================================
MSG: etsi_its_vam_ts_msgs/LanePositionAndType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a transversal position in resolution of lanes and the associated lane type.
#  *
#  * It shall include the following components: 
#  * 
#  * @field transversalPosition: the transversal position.
#  * 
#  * @field laneType: the type of the lane identified in the component transversalPosition.
#  * 
#  * @category Road topology information
#  * @revision: Created in V2.1.1
#  */
# LanePositionAndType::= SEQUENCE {
#     transversalPosition    LanePosition,
#     laneType               LaneType,
#     ...
# }
# ------------------------------------------------------------------------------

LanePosition transversal_position

LaneType lane_type


================================================================================
MSG: etsi_its_vam_ts_msgs/LaneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the type of a lane. 
#  * 
#  * The value shall be set to:
#  * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
#  * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
#  * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
#  * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
#  * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
#  * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
#  * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
#  * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
#  * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
#  * - 9	- `taxi`               - Lane dedicated to movement of taxis,
#  * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
#  * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
#  * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
#  * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
#  * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
#                                  separating the two directional carriageways of the highway,
#  * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
#  * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
#  * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
#  * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
#  * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
#                                  the road surface edge and the boundary of a road,
#  * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre.
#  * - values 21 to 30             reserved for future use. 
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
# */
# LaneType::= INTEGER{
# 	traffic              (0),
# 	through	             (1),
# 	reversible           (2),
# 	acceleration         (3),
# 	deceleration         (4),
# 	leftHandTurning      (5),
# 	rightHandTurning     (6),
# 	dedicatedVehicle     (7),
# 	bus                  (8),
# 	taxi                 (9),
# 	hov                  (10),
# 	hot                  (11),
# 	pedestrian           (12),
# 	cycleLane            (13),
# 	median               (14),   
# 	striping             (15),
# 	trackedVehicle       (16),
# 	parking	             (17),
# 	emergency            (18),
# 	verge                (19),
# 	minimumRiskManoeuvre (20),
# 	unknown              (31)
# }(0..31)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 TRAFFIC = 0
uint8 THROUGH = 1
uint8 REVERSIBLE = 2
uint8 ACCELERATION = 3
uint8 DECELERATION = 4
uint8 LEFT_HAND_TURNING = 5
uint8 RIGHT_HAND_TURNING = 6
uint8 DEDICATED_VEHICLE = 7
uint8 BUS = 8
uint8 TAXI = 9
uint8 HOV = 10
uint8 HOT = 11
uint8 PEDESTRIAN = 12
uint8 CYCLE_LANE = 13
uint8 MEDIAN = 14
uint8 STRIPING = 15
uint8 TRACKED_VEHICLE = 16
uint8 PARKING = 17
uint8 EMERGENCY = 18
uint8 VERGE = 19
uint8 MINIMUM_RISK_MANOEUVRE = 20
uint8 UNKNOWN = 31


================================================================================
MSG: etsi_its_vam_ts_msgs/TrafficIslandPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * Ths DF represents the a position on a traffic island between two lanes. 
#  *
#  * It shall include the following components: 
#  *
#  * @field oneSide: represents one lane.
#  * 
#  * @field otherSide: represents the other lane.
#  * 
#  * @category: Road Topology information
#  * @revision: Created in V2.1.1
#  */
# TrafficIslandPosition ::= SEQUENCE {
#     oneSide      LanePositionAndType,
#     otherSide    LanePositionAndType,
#     ...
# }
# ------------------------------------------------------------------------------

LanePositionAndType one_side

LanePositionAndType other_side


================================================================================
MSG: etsi_its_vam_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  * 
#  * @field mapReference: optionally identifies the MAPEM containing the topology information.
#  * It is absent if the MAPEM topology is known from the context.
#  * 
#  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
#  *
#  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
#  * conflict area of an intersection which connects e.g an ingress with an egress lane.
#  *
#  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
#  * 
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
#  *
#  * The following options are provided:
#  * 
#  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
#  * 
#  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
#  *
#  * @category: Road topology information
#  * @revision: Created in V2.1.1
#  */
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# 	}
# ------------------------------------------------------------------------------

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_vam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for a road segment
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the road segment.
#  *
#  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
#  * @category: GeoReference information
#  * @revision: created in V2.1.1
#  */
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_vam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
#  *
#  * It shall include the following components: 
#  *
#  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
#  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
#  *
#  * @field id: the identifier of the intersection
#  *
#  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_vam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE is a general identifier.
#  * 
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents the estimated position along the longitudinal length of a particular lane. 
#  *
#  * It shall include the following components: 
#  *
#  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
#  *
#  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
#  *
#  * @category: Road topology information
#  * @revision: created in V2.1.1
#  */
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
#  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
#  * - `32 767` if the longitudinal offset information is not available. 
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
#  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
#  * - `1 023` if the confidence value is unavailable.
#  *
#  * @unit 0,1 metre
#  * @category: GeoReference information
#  * @revision: Created in V2.1.1
# */
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023


================================================================================
MSG: etsi_its_vam_ts_msgs/VruEnvironment
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the possible VRU environment conditions.
#  *
#  * - The value shall be set to:
#  * - 0 `unavailable`            - to indicate that the information on the type of environment is unavailable,
#  * - 1 `intersectionCrossing`   - to indicate that the VRU is on an intersection or crossing,
#  * - 2 `zebraCrossing`          - to indicate that the VRU is on a  zebra crossing (crosswalk),
#  * - 3 `sidewalk`               - to indicate that the VRU is on a sidewalk,
#  * - 4 `onVehicleRoad`          - to indicate that the VRU is on a traffic lane,
#  * - 5 `protectedGeographicArea`- to indicate that the VRU is in a protected area.
#  * - value 5 to 255             - are reserved for future usage. Value 255 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruEnvironment ::= ENUMERATED {
#     unavailable             (0), 
#     intersectionCrossing    (1), 
#     zebraCrossing           (2), 
#     sidewalk                (3), 
#     onVehicleRoad           (4), 
#     protectedGeographicArea (5), 
#     max                     (255)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 INTERSECTION_CROSSING = 1
uint8 ZEBRA_CROSSING = 2
uint8 SIDEWALK = 3
uint8 ON_VEHICLE_ROAD = 4
uint8 PROTECTED_GEOGRAPHIC_AREA = 5
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/VruMovementControl
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  *  This DE indicates the status of the possible human control over a VRU vehicle.
#  *
#  * The value shall be set to:
#  * - 0 `unavailable`                 - to indicate that the information is unavailable,
#  * - 1 `braking`                     - to indicate that the VRU is braking,
#  * - 2 `hardBraking`                 - to indicate that the VRU is braking hard,
#  * - 3 `stopPedaling`                - to indicate that the VRU stopped pedaling,
#  * - 4 `brakingAndStopPedaling`      - to indicate that the VRU stopped pedaling an is braking,
#  * - 5 `hardBrakingAndStopPedaling`  - to indicate that the VRU stopped pedaling an is braking hard,
#  * - 6 `noReaction`                  - to indicate that the VRU is not changing its behavior.
#  * - 7 to 255                        - are reserved for future usage. Value 255 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruMovementControl ::= ENUMERATED {
#     unavailable                (0), 
#     braking                    (1), 
#     hardBraking                (2), 
#     stopPedaling               (3), 
#     brakingAndStopPedaling     (4), 
#     hardBrakingAndStopPedaling (5), 
#     noReaction                 (6), 
#     max                        (255)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 BRAKING = 1
uint8 HARD_BRAKING = 2
uint8 STOP_PEDALING = 3
uint8 BRAKING_AND_STOP_PEDALING = 4
uint8 HARD_BRAKING_AND_STOP_PEDALING = 5
uint8 NO_REACTION = 6
uint8 MAX = 255


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianAngle
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents a general Data Frame to describe an angle component along with a confidence value in a cartesian coordinate system.
#  *
#  * It shall include the following components: 
#  *
#  * @field value: The angle value which can be estimated as the mean of the current distribution.
#  *
#  * @field confidence: The confidence value associated to the provided value.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1
#  */
# CartesianAngle ::= SEQUENCE {
#     value         CartesianAngleValue,
#     confidence    AngleConfidence
# }
# ------------------------------------------------------------------------------

CartesianAngleValue value

AngleConfidence confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/CartesianAngleValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
#  * a right-hand local coordinate system from the abscissa.
#  *
#  * The value shall be set to: 
#  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
#  * - `36001` if the accuracy information is not available.
#  *
#  * The value 3600 shall not be used. 
#  * 
#  * @unit 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# CartesianAngleValue ::= INTEGER {
#     valueNotUsed (3600),
#     unavailable  (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 VALUE_NOT_USED = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/AngleConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates the angle confidence value which represents the estimated absolute accuracy of an angle value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  * - `n` (`n > 0` and `n < 126`)  if the accuracy is equal to or less than n * 0,1 degrees and greater than (n-1) x * 0,1 degrees,
#  * - `126` if the  accuracy is out of range, i.e. greater than 12,5 degrees,
#  * - `127` if the accuracy information is not available.
#  *
#  * @unit: 0,1 degrees
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# AngleConfidence ::= INTEGER {
#     outOfRange  (126),
#     unavailable (127)   
# } (1..127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 1
uint8 MAX = 127
uint8 OUT_OF_RANGE = 126
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_vam_ts_msgs/VruDeviceUsage
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the possible usage conditions of the VRU device.
# 
#  * - The value shall be set to:
#  * - 0 `unavailable`      - to indicate that the usage conditions are unavailable,
#  * - 1 `other`            - to indicate that the VRU device is in a state not defined below,
#  * - 2 `idle`             - to indicate that the human is currently not interacting with the device,
#  * - 3 `listeningToAudio` - to indicate that any audio source other than calling is in use,
#  * - 4 `typing`           - to indicate that the human is texting or performaing any other manual input activity,
#  * - 5 `calling`          - to indicate that the VRU device is currently receiving a call,
#  * - 6 `playingGames`     - to indicate that the human is playing games,
#  * - 7 `reading`          - to indicate that the human is reading on the VRU device,
#  * - 8 `viewing`          - to indicate that the human is watching dynamic content, including following navigation prompts, viewing videos or other visual contents that are not static.
#  * - value 9 to 255       - are reserved for future usage. Value 255 set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruDeviceUsage ::= ENUMERATED {
#     unavailable      (0), 
#     other            (1), 
#     idle             (2), 
#     listeningToAudio (3), 
#     typing           (4), 
#     calling          (5), 
#     playingGames     (6), 
#     reading          (7), 
#     viewing          (8), 
#     max              (255)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 OTHER = 1
uint8 IDLE = 2
uint8 LISTENING_TO_AUDIO = 3
uint8 TYPING = 4
uint8 CALLING = 5
uint8 PLAYING_GAMES = 6
uint8 READING = 7
uint8 VIEWING = 8
uint8 MAX = 255

"""
  __slots__ = ['heading','speed','longitudinal_acceleration','curvature','curvature_is_present','curvature_calculation_mode','curvature_calculation_mode_is_present','yaw_rate','yaw_rate_is_present','lateral_acceleration','lateral_acceleration_is_present','vertical_acceleration','vertical_acceleration_is_present','vru_lane_position','vru_lane_position_is_present','environment','environment_is_present','movement_control','movement_control_is_present','orientation','orientation_is_present','roll_angle','roll_angle_is_present','device_usage','device_usage_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/Wgs84Angle','etsi_its_vam_ts_msgs/Speed','etsi_its_vam_ts_msgs/LongitudinalAcceleration','etsi_its_vam_ts_msgs/Curvature','bool','etsi_its_vam_ts_msgs/CurvatureCalculationMode','bool','etsi_its_vam_ts_msgs/YawRate','bool','etsi_its_vam_ts_msgs/LateralAcceleration','bool','etsi_its_vam_ts_msgs/VerticalAcceleration','bool','etsi_its_vam_ts_msgs/GeneralizedLanePosition','bool','etsi_its_vam_ts_msgs/VruEnvironment','bool','etsi_its_vam_ts_msgs/VruMovementControl','bool','etsi_its_vam_ts_msgs/Wgs84Angle','bool','etsi_its_vam_ts_msgs/CartesianAngle','bool','etsi_its_vam_ts_msgs/VruDeviceUsage','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       heading,speed,longitudinal_acceleration,curvature,curvature_is_present,curvature_calculation_mode,curvature_calculation_mode_is_present,yaw_rate,yaw_rate_is_present,lateral_acceleration,lateral_acceleration_is_present,vertical_acceleration,vertical_acceleration_is_present,vru_lane_position,vru_lane_position_is_present,environment,environment_is_present,movement_control,movement_control_is_present,orientation,orientation_is_present,roll_angle,roll_angle_is_present,device_usage,device_usage_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VruHighFrequencyContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.heading is None:
        self.heading = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.speed is None:
        self.speed = etsi_its_vam_ts_msgs.msg.Speed()
      if self.longitudinal_acceleration is None:
        self.longitudinal_acceleration = etsi_its_vam_ts_msgs.msg.LongitudinalAcceleration()
      if self.curvature is None:
        self.curvature = etsi_its_vam_ts_msgs.msg.Curvature()
      if self.curvature_is_present is None:
        self.curvature_is_present = False
      if self.curvature_calculation_mode is None:
        self.curvature_calculation_mode = etsi_its_vam_ts_msgs.msg.CurvatureCalculationMode()
      if self.curvature_calculation_mode_is_present is None:
        self.curvature_calculation_mode_is_present = False
      if self.yaw_rate is None:
        self.yaw_rate = etsi_its_vam_ts_msgs.msg.YawRate()
      if self.yaw_rate_is_present is None:
        self.yaw_rate_is_present = False
      if self.lateral_acceleration is None:
        self.lateral_acceleration = etsi_its_vam_ts_msgs.msg.LateralAcceleration()
      if self.lateral_acceleration_is_present is None:
        self.lateral_acceleration_is_present = False
      if self.vertical_acceleration is None:
        self.vertical_acceleration = etsi_its_vam_ts_msgs.msg.VerticalAcceleration()
      if self.vertical_acceleration_is_present is None:
        self.vertical_acceleration_is_present = False
      if self.vru_lane_position is None:
        self.vru_lane_position = etsi_its_vam_ts_msgs.msg.GeneralizedLanePosition()
      if self.vru_lane_position_is_present is None:
        self.vru_lane_position_is_present = False
      if self.environment is None:
        self.environment = etsi_its_vam_ts_msgs.msg.VruEnvironment()
      if self.environment_is_present is None:
        self.environment_is_present = False
      if self.movement_control is None:
        self.movement_control = etsi_its_vam_ts_msgs.msg.VruMovementControl()
      if self.movement_control_is_present is None:
        self.movement_control_is_present = False
      if self.orientation is None:
        self.orientation = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.orientation_is_present is None:
        self.orientation_is_present = False
      if self.roll_angle is None:
        self.roll_angle = etsi_its_vam_ts_msgs.msg.CartesianAngle()
      if self.roll_angle_is_present is None:
        self.roll_angle_is_present = False
      if self.device_usage is None:
        self.device_usage = etsi_its_vam_ts_msgs.msg.VruDeviceUsage()
      if self.device_usage_is_present is None:
        self.device_usage_is_present = False
    else:
      self.heading = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      self.speed = etsi_its_vam_ts_msgs.msg.Speed()
      self.longitudinal_acceleration = etsi_its_vam_ts_msgs.msg.LongitudinalAcceleration()
      self.curvature = etsi_its_vam_ts_msgs.msg.Curvature()
      self.curvature_is_present = False
      self.curvature_calculation_mode = etsi_its_vam_ts_msgs.msg.CurvatureCalculationMode()
      self.curvature_calculation_mode_is_present = False
      self.yaw_rate = etsi_its_vam_ts_msgs.msg.YawRate()
      self.yaw_rate_is_present = False
      self.lateral_acceleration = etsi_its_vam_ts_msgs.msg.LateralAcceleration()
      self.lateral_acceleration_is_present = False
      self.vertical_acceleration = etsi_its_vam_ts_msgs.msg.VerticalAcceleration()
      self.vertical_acceleration_is_present = False
      self.vru_lane_position = etsi_its_vam_ts_msgs.msg.GeneralizedLanePosition()
      self.vru_lane_position_is_present = False
      self.environment = etsi_its_vam_ts_msgs.msg.VruEnvironment()
      self.environment_is_present = False
      self.movement_control = etsi_its_vam_ts_msgs.msg.VruMovementControl()
      self.movement_control_is_present = False
      self.orientation = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      self.orientation_is_present = False
      self.roll_angle = etsi_its_vam_ts_msgs.msg.CartesianAngle()
      self.roll_angle_is_present = False
      self.device_usage = etsi_its_vam_ts_msgs.msg.VruDeviceUsage()
      self.device_usage_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B().pack(_x.heading.value.value, _x.heading.confidence.value, _x.speed.speed_value.value, _x.speed.speed_confidence.value, _x.longitudinal_acceleration.longitudinal_acceleration_value.value, _x.longitudinal_acceleration.longitudinal_acceleration_confidence.value, _x.curvature.curvature_value.value, _x.curvature.curvature_confidence.value, _x.curvature_is_present, _x.curvature_calculation_mode.value, _x.curvature_calculation_mode_is_present, _x.yaw_rate.yaw_rate_value.value, _x.yaw_rate.yaw_rate_confidence.value, _x.yaw_rate_is_present, _x.lateral_acceleration.lateral_acceleration_value.value, _x.lateral_acceleration.lateral_acceleration_confidence.value, _x.lateral_acceleration_is_present, _x.vertical_acceleration.vertical_acceleration_value.value, _x.vertical_acceleration.vertical_acceleration_confidence.value, _x.vertical_acceleration_is_present, _x.vru_lane_position.choice, _x.vru_lane_position.traffic_lane_position.value, _x.vru_lane_position.non_traffic_lane_position.transversal_position.value, _x.vru_lane_position.non_traffic_lane_position.lane_type.value, _x.vru_lane_position.traffic_island_position.one_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.one_side.lane_type.value, _x.vru_lane_position.traffic_island_position.other_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.other_side.lane_type.value, _x.vru_lane_position.map_position.map_reference.choice, _x.vru_lane_position.map_position.map_reference.roadsegment.region.value, _x.vru_lane_position.map_position.map_reference.roadsegment.region_is_present, _x.vru_lane_position.map_position.map_reference.roadsegment.id.value, _x.vru_lane_position.map_position.map_reference.intersection.region.value, _x.vru_lane_position.map_position.map_reference.intersection.region_is_present, _x.vru_lane_position.map_position.map_reference.intersection.id.value, _x.vru_lane_position.map_position.map_reference_is_present, _x.vru_lane_position.map_position.lane_id.value, _x.vru_lane_position.map_position.lane_id_is_present, _x.vru_lane_position.map_position.connection_id.value, _x.vru_lane_position.map_position.connection_id_is_present, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.vru_lane_position.map_position.longitudinal_lane_position_is_present, _x.vru_lane_position_is_present, _x.environment.value, _x.environment_is_present, _x.movement_control.value, _x.movement_control_is_present, _x.orientation.value.value, _x.orientation.confidence.value, _x.orientation_is_present, _x.roll_angle.value.value, _x.roll_angle.confidence.value, _x.roll_angle_is_present, _x.device_usage.value, _x.device_usage_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.heading is None:
        self.heading = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.speed is None:
        self.speed = etsi_its_vam_ts_msgs.msg.Speed()
      if self.longitudinal_acceleration is None:
        self.longitudinal_acceleration = etsi_its_vam_ts_msgs.msg.LongitudinalAcceleration()
      if self.curvature is None:
        self.curvature = etsi_its_vam_ts_msgs.msg.Curvature()
      if self.curvature_calculation_mode is None:
        self.curvature_calculation_mode = etsi_its_vam_ts_msgs.msg.CurvatureCalculationMode()
      if self.yaw_rate is None:
        self.yaw_rate = etsi_its_vam_ts_msgs.msg.YawRate()
      if self.lateral_acceleration is None:
        self.lateral_acceleration = etsi_its_vam_ts_msgs.msg.LateralAcceleration()
      if self.vertical_acceleration is None:
        self.vertical_acceleration = etsi_its_vam_ts_msgs.msg.VerticalAcceleration()
      if self.vru_lane_position is None:
        self.vru_lane_position = etsi_its_vam_ts_msgs.msg.GeneralizedLanePosition()
      if self.environment is None:
        self.environment = etsi_its_vam_ts_msgs.msg.VruEnvironment()
      if self.movement_control is None:
        self.movement_control = etsi_its_vam_ts_msgs.msg.VruMovementControl()
      if self.orientation is None:
        self.orientation = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.roll_angle is None:
        self.roll_angle = etsi_its_vam_ts_msgs.msg.CartesianAngle()
      if self.device_usage is None:
        self.device_usage = etsi_its_vam_ts_msgs.msg.VruDeviceUsage()
      end = 0
      _x = self
      start = end
      end += 71
      (_x.heading.value.value, _x.heading.confidence.value, _x.speed.speed_value.value, _x.speed.speed_confidence.value, _x.longitudinal_acceleration.longitudinal_acceleration_value.value, _x.longitudinal_acceleration.longitudinal_acceleration_confidence.value, _x.curvature.curvature_value.value, _x.curvature.curvature_confidence.value, _x.curvature_is_present, _x.curvature_calculation_mode.value, _x.curvature_calculation_mode_is_present, _x.yaw_rate.yaw_rate_value.value, _x.yaw_rate.yaw_rate_confidence.value, _x.yaw_rate_is_present, _x.lateral_acceleration.lateral_acceleration_value.value, _x.lateral_acceleration.lateral_acceleration_confidence.value, _x.lateral_acceleration_is_present, _x.vertical_acceleration.vertical_acceleration_value.value, _x.vertical_acceleration.vertical_acceleration_confidence.value, _x.vertical_acceleration_is_present, _x.vru_lane_position.choice, _x.vru_lane_position.traffic_lane_position.value, _x.vru_lane_position.non_traffic_lane_position.transversal_position.value, _x.vru_lane_position.non_traffic_lane_position.lane_type.value, _x.vru_lane_position.traffic_island_position.one_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.one_side.lane_type.value, _x.vru_lane_position.traffic_island_position.other_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.other_side.lane_type.value, _x.vru_lane_position.map_position.map_reference.choice, _x.vru_lane_position.map_position.map_reference.roadsegment.region.value, _x.vru_lane_position.map_position.map_reference.roadsegment.region_is_present, _x.vru_lane_position.map_position.map_reference.roadsegment.id.value, _x.vru_lane_position.map_position.map_reference.intersection.region.value, _x.vru_lane_position.map_position.map_reference.intersection.region_is_present, _x.vru_lane_position.map_position.map_reference.intersection.id.value, _x.vru_lane_position.map_position.map_reference_is_present, _x.vru_lane_position.map_position.lane_id.value, _x.vru_lane_position.map_position.lane_id_is_present, _x.vru_lane_position.map_position.connection_id.value, _x.vru_lane_position.map_position.connection_id_is_present, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.vru_lane_position.map_position.longitudinal_lane_position_is_present, _x.vru_lane_position_is_present, _x.environment.value, _x.environment_is_present, _x.movement_control.value, _x.movement_control_is_present, _x.orientation.value.value, _x.orientation.confidence.value, _x.orientation_is_present, _x.roll_angle.value.value, _x.roll_angle.confidence.value, _x.roll_angle_is_present, _x.device_usage.value, _x.device_usage_is_present,) = _get_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B().unpack(str[start:end])
      self.curvature_is_present = bool(self.curvature_is_present)
      self.curvature_calculation_mode_is_present = bool(self.curvature_calculation_mode_is_present)
      self.yaw_rate_is_present = bool(self.yaw_rate_is_present)
      self.lateral_acceleration_is_present = bool(self.lateral_acceleration_is_present)
      self.vertical_acceleration_is_present = bool(self.vertical_acceleration_is_present)
      self.vru_lane_position.map_position.map_reference.roadsegment.region_is_present = bool(self.vru_lane_position.map_position.map_reference.roadsegment.region_is_present)
      self.vru_lane_position.map_position.map_reference.intersection.region_is_present = bool(self.vru_lane_position.map_position.map_reference.intersection.region_is_present)
      self.vru_lane_position.map_position.map_reference_is_present = bool(self.vru_lane_position.map_position.map_reference_is_present)
      self.vru_lane_position.map_position.lane_id_is_present = bool(self.vru_lane_position.map_position.lane_id_is_present)
      self.vru_lane_position.map_position.connection_id_is_present = bool(self.vru_lane_position.map_position.connection_id_is_present)
      self.vru_lane_position.map_position.longitudinal_lane_position_is_present = bool(self.vru_lane_position.map_position.longitudinal_lane_position_is_present)
      self.vru_lane_position_is_present = bool(self.vru_lane_position_is_present)
      self.environment_is_present = bool(self.environment_is_present)
      self.movement_control_is_present = bool(self.movement_control_is_present)
      self.orientation_is_present = bool(self.orientation_is_present)
      self.roll_angle_is_present = bool(self.roll_angle_is_present)
      self.device_usage_is_present = bool(self.device_usage_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B().pack(_x.heading.value.value, _x.heading.confidence.value, _x.speed.speed_value.value, _x.speed.speed_confidence.value, _x.longitudinal_acceleration.longitudinal_acceleration_value.value, _x.longitudinal_acceleration.longitudinal_acceleration_confidence.value, _x.curvature.curvature_value.value, _x.curvature.curvature_confidence.value, _x.curvature_is_present, _x.curvature_calculation_mode.value, _x.curvature_calculation_mode_is_present, _x.yaw_rate.yaw_rate_value.value, _x.yaw_rate.yaw_rate_confidence.value, _x.yaw_rate_is_present, _x.lateral_acceleration.lateral_acceleration_value.value, _x.lateral_acceleration.lateral_acceleration_confidence.value, _x.lateral_acceleration_is_present, _x.vertical_acceleration.vertical_acceleration_value.value, _x.vertical_acceleration.vertical_acceleration_confidence.value, _x.vertical_acceleration_is_present, _x.vru_lane_position.choice, _x.vru_lane_position.traffic_lane_position.value, _x.vru_lane_position.non_traffic_lane_position.transversal_position.value, _x.vru_lane_position.non_traffic_lane_position.lane_type.value, _x.vru_lane_position.traffic_island_position.one_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.one_side.lane_type.value, _x.vru_lane_position.traffic_island_position.other_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.other_side.lane_type.value, _x.vru_lane_position.map_position.map_reference.choice, _x.vru_lane_position.map_position.map_reference.roadsegment.region.value, _x.vru_lane_position.map_position.map_reference.roadsegment.region_is_present, _x.vru_lane_position.map_position.map_reference.roadsegment.id.value, _x.vru_lane_position.map_position.map_reference.intersection.region.value, _x.vru_lane_position.map_position.map_reference.intersection.region_is_present, _x.vru_lane_position.map_position.map_reference.intersection.id.value, _x.vru_lane_position.map_position.map_reference_is_present, _x.vru_lane_position.map_position.lane_id.value, _x.vru_lane_position.map_position.lane_id_is_present, _x.vru_lane_position.map_position.connection_id.value, _x.vru_lane_position.map_position.connection_id_is_present, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.vru_lane_position.map_position.longitudinal_lane_position_is_present, _x.vru_lane_position_is_present, _x.environment.value, _x.environment_is_present, _x.movement_control.value, _x.movement_control_is_present, _x.orientation.value.value, _x.orientation.confidence.value, _x.orientation_is_present, _x.roll_angle.value.value, _x.roll_angle.confidence.value, _x.roll_angle_is_present, _x.device_usage.value, _x.device_usage_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.heading is None:
        self.heading = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.speed is None:
        self.speed = etsi_its_vam_ts_msgs.msg.Speed()
      if self.longitudinal_acceleration is None:
        self.longitudinal_acceleration = etsi_its_vam_ts_msgs.msg.LongitudinalAcceleration()
      if self.curvature is None:
        self.curvature = etsi_its_vam_ts_msgs.msg.Curvature()
      if self.curvature_calculation_mode is None:
        self.curvature_calculation_mode = etsi_its_vam_ts_msgs.msg.CurvatureCalculationMode()
      if self.yaw_rate is None:
        self.yaw_rate = etsi_its_vam_ts_msgs.msg.YawRate()
      if self.lateral_acceleration is None:
        self.lateral_acceleration = etsi_its_vam_ts_msgs.msg.LateralAcceleration()
      if self.vertical_acceleration is None:
        self.vertical_acceleration = etsi_its_vam_ts_msgs.msg.VerticalAcceleration()
      if self.vru_lane_position is None:
        self.vru_lane_position = etsi_its_vam_ts_msgs.msg.GeneralizedLanePosition()
      if self.environment is None:
        self.environment = etsi_its_vam_ts_msgs.msg.VruEnvironment()
      if self.movement_control is None:
        self.movement_control = etsi_its_vam_ts_msgs.msg.VruMovementControl()
      if self.orientation is None:
        self.orientation = etsi_its_vam_ts_msgs.msg.Wgs84Angle()
      if self.roll_angle is None:
        self.roll_angle = etsi_its_vam_ts_msgs.msg.CartesianAngle()
      if self.device_usage is None:
        self.device_usage = etsi_its_vam_ts_msgs.msg.VruDeviceUsage()
      end = 0
      _x = self
      start = end
      end += 71
      (_x.heading.value.value, _x.heading.confidence.value, _x.speed.speed_value.value, _x.speed.speed_confidence.value, _x.longitudinal_acceleration.longitudinal_acceleration_value.value, _x.longitudinal_acceleration.longitudinal_acceleration_confidence.value, _x.curvature.curvature_value.value, _x.curvature.curvature_confidence.value, _x.curvature_is_present, _x.curvature_calculation_mode.value, _x.curvature_calculation_mode_is_present, _x.yaw_rate.yaw_rate_value.value, _x.yaw_rate.yaw_rate_confidence.value, _x.yaw_rate_is_present, _x.lateral_acceleration.lateral_acceleration_value.value, _x.lateral_acceleration.lateral_acceleration_confidence.value, _x.lateral_acceleration_is_present, _x.vertical_acceleration.vertical_acceleration_value.value, _x.vertical_acceleration.vertical_acceleration_confidence.value, _x.vertical_acceleration_is_present, _x.vru_lane_position.choice, _x.vru_lane_position.traffic_lane_position.value, _x.vru_lane_position.non_traffic_lane_position.transversal_position.value, _x.vru_lane_position.non_traffic_lane_position.lane_type.value, _x.vru_lane_position.traffic_island_position.one_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.one_side.lane_type.value, _x.vru_lane_position.traffic_island_position.other_side.transversal_position.value, _x.vru_lane_position.traffic_island_position.other_side.lane_type.value, _x.vru_lane_position.map_position.map_reference.choice, _x.vru_lane_position.map_position.map_reference.roadsegment.region.value, _x.vru_lane_position.map_position.map_reference.roadsegment.region_is_present, _x.vru_lane_position.map_position.map_reference.roadsegment.id.value, _x.vru_lane_position.map_position.map_reference.intersection.region.value, _x.vru_lane_position.map_position.map_reference.intersection.region_is_present, _x.vru_lane_position.map_position.map_reference.intersection.id.value, _x.vru_lane_position.map_position.map_reference_is_present, _x.vru_lane_position.map_position.lane_id.value, _x.vru_lane_position.map_position.lane_id_is_present, _x.vru_lane_position.map_position.connection_id.value, _x.vru_lane_position.map_position.connection_id_is_present, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_value.value, _x.vru_lane_position.map_position.longitudinal_lane_position.longitudinal_lane_position_confidence.value, _x.vru_lane_position.map_position.longitudinal_lane_position_is_present, _x.vru_lane_position_is_present, _x.environment.value, _x.environment_is_present, _x.movement_control.value, _x.movement_control_is_present, _x.orientation.value.value, _x.orientation.confidence.value, _x.orientation_is_present, _x.roll_angle.value.value, _x.roll_angle.confidence.value, _x.roll_angle_is_present, _x.device_usage.value, _x.device_usage_is_present,) = _get_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B().unpack(str[start:end])
      self.curvature_is_present = bool(self.curvature_is_present)
      self.curvature_calculation_mode_is_present = bool(self.curvature_calculation_mode_is_present)
      self.yaw_rate_is_present = bool(self.yaw_rate_is_present)
      self.lateral_acceleration_is_present = bool(self.lateral_acceleration_is_present)
      self.vertical_acceleration_is_present = bool(self.vertical_acceleration_is_present)
      self.vru_lane_position.map_position.map_reference.roadsegment.region_is_present = bool(self.vru_lane_position.map_position.map_reference.roadsegment.region_is_present)
      self.vru_lane_position.map_position.map_reference.intersection.region_is_present = bool(self.vru_lane_position.map_position.map_reference.intersection.region_is_present)
      self.vru_lane_position.map_position.map_reference_is_present = bool(self.vru_lane_position.map_position.map_reference_is_present)
      self.vru_lane_position.map_position.lane_id_is_present = bool(self.vru_lane_position.map_position.lane_id_is_present)
      self.vru_lane_position.map_position.connection_id_is_present = bool(self.vru_lane_position.map_position.connection_id_is_present)
      self.vru_lane_position.map_position.longitudinal_lane_position_is_present = bool(self.vru_lane_position.map_position.longitudinal_lane_position_is_present)
      self.vru_lane_position_is_present = bool(self.vru_lane_position_is_present)
      self.environment_is_present = bool(self.environment_is_present)
      self.movement_control_is_present = bool(self.movement_control_is_present)
      self.orientation_is_present = bool(self.orientation_is_present)
      self.roll_angle_is_present = bool(self.roll_angle_is_present)
      self.device_usage_is_present = bool(self.device_usage_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B = None
def _get_struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B():
    global _struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B
    if _struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B is None:
        _struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B = struct.Struct("<HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B")
    return _struct_HBHBhBh4Bh2Bh2Bh3B2bBbBb2BHB2HBH5B2H6BH2BH4B
