# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/VruMotionPredictionContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class VruMotionPredictionContainer(genpy.Message):
  _md5sum = "93da0ccda6e7ba4e19c354c1626cf720"
  _type = "etsi_its_vam_ts_msgs/VruMotionPredictionContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
#  /**
#  * @details VruMotionPredictionContainer
#  * The VRU Motion Prediction container of the VAM carries the past and future motion state information of the VRU.
#  * It includes the following components (setting indications are specified in clause 7.3.6 of TS 103 300-3). 
#  * At least one of the fields below shall be present if the container is present in the VAM: 
#  *
#  * @field pathHistory: represents the VRU's recent movement over some past time and/or distance. 
#  *        It consists of a list of path points. 
#  * @field pathPrediction: provides the set of predicted locations of the ITS-S, confidence values 
#  *        and the corresponding future time instants. 
#  * @field safeDistance: provides indication of safe distance between an ego-VRU and up to 8 other ITS-S 
#  *        or entity on the road to indicate whether the ego-VRU is at a safe distance (that is less likely to 
#  *        physically collide) from another ITS-S or entity on the road. 
#  * @field trajectoryInterceptionIndication: provides the indication for possible trajectory interception 
#  *        with up to 8 VRUs or other objects on the road.. 
#  * @field accelerationChangeIndication: provides an acceleration change indication of the VRU. 
#  *        When present this DF indicates an anticipated change in the VRU speed for period of actionDeltaTime.
#  * @field headingChangeIndication: provides additional data elements associated to heading change indicators 
#  *        such as a change of travel direction (left or right). 
#  *        The direction change action is performed for a period of actionDeltaTime. 
#  * @field stabilityChangeIndication: provides an estimation of the VRU stability. 
#  * 
#  * @category: GeoReference information, VRU information
#  * @revision: V2.2.1
#  */
#     VruMotionPredictionContainer ::= SEQUENCE {
#         pathHistory                      PathHistory OPTIONAL,
#         pathPrediction                   PathPredicted OPTIONAL,  
#         safeDistance                     SequenceOfSafeDistanceIndication OPTIONAL,
#         trajectoryInterceptionIndication SequenceOfTrajectoryInterceptionIndication OPTIONAL,
#         accelerationChangeIndication     AccelerationChangeIndication OPTIONAL,
#         headingChangeIndication          HeadingChangeIndication OPTIONAL,
#         stabilityChangeIndication        StabilityChangeIndication OPTIONAL,
#         ...
#     }
# ------------------------------------------------------------------------------

PathHistory path_history
bool path_history_is_present

PathPredicted path_prediction
bool path_prediction_is_present

SequenceOfSafeDistanceIndication safe_distance
bool safe_distance_is_present

SequenceOfTrajectoryInterceptionIndication trajectory_interception_indication
bool trajectory_interception_indication_is_present

AccelerationChangeIndication acceleration_change_indication
bool acceleration_change_indication_is_present

HeadingChangeIndication heading_change_indication
bool heading_change_indication_is_present

StabilityChangeIndication stability_change_indication
bool stability_change_indication_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/PathHistory
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a path history with a set of path points.
#  * It shall contain up to `40` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref Path instead.
#  * @category: GeoReference information, Vehicle information
#  * @revision: semantics updated in V2.1.1
#  */
# PathHistory::= SEQUENCE (SIZE(40)) OF PathPoint
# ------------------------------------------------------------------------------

PathPoint[] array
uint8 SIZE = 40


================================================================================
MSG: etsi_its_vam_ts_msgs/PathPoint
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines an offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
#  *
#  * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPoint ::= SEQUENCE {
#     pathPosition     DeltaReferencePosition,
#     pathDeltaTime    PathDeltaTime OPTIONAL
# }
# ------------------------------------------------------------------------------

DeltaReferencePosition path_position

PathDeltaTime path_delta_time
bool path_delta_time_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaReferencePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
#  *
#  * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
#  *
#  * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
#  *
#  * @category: GeoReference information
#  * @revision:  V1.3.1
#  */
# DeltaReferencePosition ::= SEQUENCE {
#     deltaLatitude     DeltaLatitude,
#     deltaLongitude    DeltaLongitude,
#     deltaAltitude     DeltaAltitude
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

DeltaAltitude delta_altitude


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaLatitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset latitude with regards to a defined latitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
#  * - `0` for no latitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLatitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaLongitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset longitude with regards to a defined longitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
#  * - `0` for no longitudinal offset,
#  * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
#  * - `131 072` when the information is unavailable.
#  *
#  * @unit: 10^-7 degree
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaLongitude ::= INTEGER {
#     unavailable (131072)
# } (-131071..131072)
# ------------------------------------------------------------------------------

int32 value
int32 MIN = -131071
int32 MAX = 131072
int32 UNAVAILABLE = 131072


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaAltitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents an offset altitude with regards to a defined altitude value.
#  * It may be used to describe a geographical point with regards to a specific reference geographical position.
#  *
#  * The value shall be set to:
#  * - `-12 700` for values equal to or lower than -127 metres,
#  * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
#  * - `0` for no altitudinal offset,
#  * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
#  * - `12 799` for values equal to or greater than 127,99 metres,
#  * - `12 800` when the information is unavailable.
#  *
#  * @unit: 0,01 metre
#  * @category: GeoReference information
#  * @revision: editorial update in V2.1.1
#  */
# DeltaAltitude ::= INTEGER {
#     negativeOutOfRange (-12700),
#     positiveOutOfRange (12799),
#     unavailable        (12800)
# } (-12700..12800)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -12700
int16 MAX = 12800
int16 NEGATIVE_OUT_OF_RANGE = -12700
int16 POSITIVE_OUT_OF_RANGE = 12799
int16 UNAVAILABLE = 12800


================================================================================
MSG: etsi_its_vam_ts_msgs/PathDeltaTime
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
#  *
#  * @unit 0,01 second
#  * @category: GeoReference information
#  * @revision: V1.3.1
#  */
# PathDeltaTime ::= INTEGER (1..65535, ...) 
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 1
uint16 MAX = 65535


================================================================================
MSG: etsi_its_vam_ts_msgs/PathPredicted
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a predicted path with a set of path points.
#  * It shall contain up to `15` @ref PathPoint. 
#  * 
#  * The first PathPoint presents an offset delta position with regards to an external reference position.
#  * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
#  *
#  * @category: GeoReference information
#  * @revision: created in V2.1.1 based on PathHistory
#  */
# PathPredicted::= SEQUENCE (SIZE(0..15,...)) OF PathPointPredicted
# ------------------------------------------------------------------------------

PathPointPredicted[] array
uint8 MIN_SIZE = 0
uint8 MAX_SIZE = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/PathPointPredicted
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  defines a predicted offset waypoint position within a path.
#  *
#  * It shall include the following components: 
#  *
#  * @field deltaLatitude: an offset latitude with regards to a pre-defined reference position. 
#  *
#  * @field deltaLongitude: an offset longitude with regards to a pre-defined reference position. 
#  * 
#  * @field horizontalPositionConfidence: the confidence value associated to the horizontal geographical position.
#  *
#  * @field deltaAltitude: an offset altitude with regards to a pre-defined reference position. 
#  *
#  * @field altitudeConfidence: the confidence value associated to the altitude value of the geographical position.
#  * 
#  * @field pathDeltaTime: The  travel time separated from the waypoint to the predefined reference position.
#  *
#  * @category GeoReference information
#  * @revision: semantics updated in V2.1.1
#  */
# PathPointPredicted::= SEQUENCE {
#   deltaLatitude                 DeltaLatitude,      
#   deltaLongitude                DeltaLongitude, 
#   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,   
#   deltaAltitude                 DeltaAltitude DEFAULT unavailable, 
#   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
#   pathDeltaTime                 DeltaTimeTenthOfSecond,
#   ... 
# }
# ------------------------------------------------------------------------------

DeltaLatitude delta_latitude

DeltaLongitude delta_longitude

PosConfidenceEllipse horizontal_position_confidence
bool horizontal_position_confidence_is_present

DeltaAltitude delta_altitude
uint16 DELTA_ALTITUDE_DEFAULT = 12800

AltitudeConfidence altitude_confidence
uint8 ALTITUDE_CONFIDENCE_DEFAULT = 15

DeltaTimeTenthOfSecond path_delta_time


================================================================================
MSG: etsi_its_vam_ts_msgs/PosConfidenceEllipse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
#  * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
#  * position point for which the position accuracy is evaluated.
#  *
#  * It shall include the following components: 
#  *
#  * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
#  * and major axis point of the position accuracy ellipse. 
#  *
#  * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
#  * and minor axis point of the position accuracy ellipse. 
#  *
#  * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
#  * ellipse with regards to the WGS84 north. 
#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
#  *
#  *
#  * @category GeoReference information
#  * @revision: V1.3.1
#  */
# PosConfidenceEllipse ::= SEQUENCE {
#     semiMajorConfidence     SemiAxisLength,
#     semiMinorConfidence     SemiAxisLength,
#     semiMajorOrientation    HeadingValue
# }
# ------------------------------------------------------------------------------

SemiAxisLength semi_major_confidence

SemiAxisLength semi_minor_confidence

HeadingValue semi_major_orientation


================================================================================
MSG: etsi_its_vam_ts_msgs/SemiAxisLength
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
#  * confidence level of 95 %. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
#  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
#  * - `4 095` if the accuracy information is unavailable.
#  *
#  * The value 0 shall not be used.
#  * 
#  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
#  * can be caused by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the position coordinate value may be valid and used by the application.
#  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
#  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
#  * for the application.
# 
#  * @unit 0,01 metre 
#  * @category: GeoReference Information
#  * @revision: Description revised in V2.1.1
#  */
# SemiAxisLength ::= INTEGER{
#     doNotUse    (0),
#     outOfRange  (4094), 
#     unavailable (4095)
# } (0..4095)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 4095
uint16 DO_NOT_USE = 0
uint16 OUT_OF_RANGE = 4094
uint16 UNAVAILABLE = 4095


================================================================================
MSG: etsi_its_vam_ts_msgs/HeadingValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
#  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
#  *
#  * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
#  *
#  * Unit: 0,1 degree
#  * Categories: GeoReference information
#  * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
# */
# HeadingValue ::= INTEGER { 
#     wgs84North  (0),
#     wgs84East   (900),
#     wgs84South  (1800),
#     wgs84West   (2700),
#     doNotUse    (3600),
#     unavailable (3601)
# } (0..3601)
# ------------------------------------------------------------------------------

uint16 value
uint16 MIN = 0
uint16 MAX = 3601
uint16 WGS84_NORTH = 0
uint16 WGS84_EAST = 900
uint16 WGS84_SOUTH = 1800
uint16 WGS84_WEST = 2700
uint16 DO_NOT_USE = 3600
uint16 UNAVAILABLE = 3601


================================================================================
MSG: etsi_its_vam_ts_msgs/AltitudeConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  *
#  * The value shall be set to: 
#  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
#  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
#  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
#  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
#  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
#  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
#  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
#  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
#  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
#  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
#  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
#  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
#  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
#  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
#  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
#  *   - 15 - `unavailable`  - if the confidence value is unavailable.       
#  *
#  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
#  * by several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the altitude value may be valid and used by the application.
#  * 
#  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
#  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
#  *
#  * @category: GeoReference information
#  * @revision: Description revised in V2.1.1
#  */
# AltitudeConfidence ::= ENUMERATED {
#     alt-000-01  (0),
#     alt-000-02  (1),
#     alt-000-05  (2),
#     alt-000-10  (3),
#     alt-000-20  (4),
#     alt-000-50  (5),
#     alt-001-00  (6),
#     alt-002-00  (7),
#     alt-005-00  (8),
#     alt-010-00  (9),
#     alt-020-00  (10),
#     alt-050-00  (11),
#     alt-100-00  (12),
#     alt-200-00  (13),
#     outOfRange  (14),
#     unavailable (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ALT_000_01 = 0
uint8 ALT_000_02 = 1
uint8 ALT_000_05 = 2
uint8 ALT_000_10 = 3
uint8 ALT_000_20 = 4
uint8 ALT_000_50 = 5
uint8 ALT_001_00 = 6
uint8 ALT_002_00 = 7
uint8 ALT_005_00 = 8
uint8 ALT_010_00 = 9
uint8 ALT_020_00 = 10
uint8 ALT_050_00 = 11
uint8 ALT_100_00 = 12
uint8 ALT_200_00 = 13
uint8 OUT_OF_RANGE = 14
uint8 UNAVAILABLE = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE represents a difference in time with respect to a reference time.
#  *
#  * The value shall be set to:
#  * - `0` for a difference in time of 0 seconds. 
#  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
#  *
#  * @unit: 0,1 s
#  * @category: Basic information
#  * @revision: Created in V2.1.1
# */
# DeltaTimeTenthOfSecond::= INTEGER {
#     unavailable (127)  
# } (0..127) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_vam_ts_msgs/SequenceOfSafeDistanceIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DF contains a list of DF @ref SafeDistanceIndication.
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
# */
# SequenceOfSafeDistanceIndication ::= SEQUENCE(SIZE(1..8,...)) OF SafeDistanceIndication
# ------------------------------------------------------------------------------

SafeDistanceIndication[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_vam_ts_msgs/SafeDistanceIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF provides the safe distance indication of a traffic participant with other traffic participant(s).
#  *
#  * It shall include the following components: 
#  * 
#  * @field subjectStation: optionally indicates one "other" traffic participant identified by its ITS-S.
#  *  
#  * @field safeDistanceIndicator: indicates whether the distance between the ego ITS-S and the traffic participant(s) is safe.
#  * If subjectStation is present then it indicates whether the distance between the ego ITS-S and the traffic participant indicated in the component subjectStation is safe. 
#  *
#  * @field timeToCollision: optionally indicated the time-to-collision calculated as sqrt(LaDi^2 + LoDi^2 + VDi^2/relative speed 
#  * and represented in  the  nearest 100  ms. This component may be present only if subjectStation is present. 
#  *
#  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
#  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
#  */
# SafeDistanceIndication ::= SEQUENCE {
#     subjectStation           StationId OPTIONAL,
#     safeDistanceIndicator    SafeDistanceIndicator,
#     timeToCollision          DeltaTimeTenthOfSecond OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

StationId subject_station
bool subject_station_is_present

SafeDistanceIndicator safe_distance_indicator

DeltaTimeTenthOfSecond time_to_collision
bool time_to_collision_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/StationId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the identifier of an ITS-S.
#  * The ITS-S ID may be a pseudonym. It may change over space and/or over time.
#  *
#  * @category: Basic information
#  * @revision: Created in V2.1.1 based on @ref StationID
#  */
# StationId ::= INTEGER(0..4294967295)
# ------------------------------------------------------------------------------

uint32 value
uint32 MIN = 0
uint32 MAX = 4294967295


================================================================================
MSG: etsi_its_vam_ts_msgs/SafeDistanceIndicator
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates if a distance is safe. 
#  *
#  * The value shall be set to:
#  * -  `FALSE`  if  the triple  {LaD,  LoD, VD} < {MSLaD, MSLoD, MSVD} is simultaneously  satisfied with confidence level of  90 % or  more, 
#  * -  `TRUE` otherwise. 
#  *
#  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
#  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
# */
# SafeDistanceIndicator::= BOOLEAN
# ------------------------------------------------------------------------------

bool value


================================================================================
MSG: etsi_its_vam_ts_msgs/SequenceOfTrajectoryInterceptionIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DF shall contain a list of DF @ref TrajectoryInterceptionIndication.
#  *
#  * @category: Traffic information, Kinematic information
#  * @revision: created in V2.1.1
# */
# SequenceOfTrajectoryInterceptionIndication ::=  SEQUENCE (SIZE(1..8,...)) OF TrajectoryInterceptionIndication
# ------------------------------------------------------------------------------

TrajectoryInterceptionIndication[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 8


================================================================================
MSG: etsi_its_vam_ts_msgs/TrajectoryInterceptionIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  provides the trajectory  interception  indication  of  ego-VRU  ITS-S  with another ITS-Ss. 
#  *
#  * It shall include the following components: 
#  * 
#  * @field subjectStation: indicates the subject station.
#  * 
#  * @field trajectoryInterceptionProbability: indicates the propbability of the interception of the subject station trajectory 
#  * with the trajectory of the station indicated in the component subjectStation.
#  *
#  * @field trajectoryInterceptionConfidence: indicates the confidence of interception of the subject station trajectory 
#  * with the trajectory of the station indicated in the component subjectStation.
#  * 
#  * @category: Vehicle information
#  * @revision: Created in V2.1.1
#  */
# TrajectoryInterceptionIndication  ::= SEQUENCE {
#    subjectStation                     StationId OPTIONAL, 
#    trajectoryInterceptionProbability  TrajectoryInterceptionProbability,
#    trajectoryInterceptionConfidence   TrajectoryInterceptionConfidence OPTIONAL,
#         ... 
# }
# ------------------------------------------------------------------------------

StationId subject_station
bool subject_station_is_present

TrajectoryInterceptionProbability trajectory_interception_probability

TrajectoryInterceptionConfidence trajectory_interception_confidence
bool trajectory_interception_confidence_is_present


================================================================================
MSG: etsi_its_vam_ts_msgs/TrajectoryInterceptionProbability
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This  DE  defines  the  probability  that the ego trajectory  intercepts  with any  other object's  trajectory  on the  road. 
#  * 
#  * The value shall be set to:
#  * - `n` (`n >= 0` and `n <= 50`) to indicate the actual probability,
#  * - the values between 51 and 62 are reserved,
#  * - `63`: to indicate that the information is unavailable. 
#  *
#  * @unit: 2 %
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# TrajectoryInterceptionProbability ::= INTEGER { 
#     unavailable (63) 
# } (0..63) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 63
uint8 UNAVAILABLE = 63


================================================================================
MSG: etsi_its_vam_ts_msgs/TrajectoryInterceptionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE  defines  the  confidence level of the trajectoryInterceptionProbability.
#  *
#  * The value shall be set to:
#  * - `0` - to indicate confidence level less than 50 %,
#  * - `1` - to indicate confidence level greater than or equal to 50 % and less than 70 %,
#  * - `2` - to indicate confidence level greater than or equal to 70 % and less than 90 %,
#  * - `3` - to indicate confidence level greater than or equal to 90%.
#  * 
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# TrajectoryInterceptionConfidence ::= INTEGER { 
#     lessthan50percent     (0), 
#     between50and70Percent (1),
#     between70and90Percent (2), 
#     above90Percent        (3) 
# } (0..3)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 LESSTHAN50_PERCENT = 0
uint8 BETWEEN50_AND70_PERCENT = 1
uint8 BETWEEN70_AND90_PERCENT = 2
uint8 ABOVE90_PERCENT = 3


================================================================================
MSG: etsi_its_vam_ts_msgs/AccelerationChangeIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DF represents information associated to changes in acceleration. 
#  *
#  * It shall include the following components: 
#  *
#  * @field accelOrDecel: the indication of an acceleration change.
#  *
#  * @field actionDeltaTime: the period over which the acceleration change action is performed.
#  *
#  * @category: Kinematic Information
#  * @revision: Created in V2.1.1
#  */
# AccelerationChangeIndication ::= SEQUENCE {
#     accelOrDecel       AccelerationChange,
#     actionDeltaTime    DeltaTimeTenthOfSecond,
#     ...
# }
# ------------------------------------------------------------------------------

AccelerationChange accel_or_decel

DeltaTimeTenthOfSecond action_delta_time


================================================================================
MSG: etsi_its_vam_ts_msgs/AccelerationChange
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /** 
#  * This DE indicates a change of acceleration.
#  *
#  * The value shall be set to:
#  * - 0 - `accelerate` - if the magnitude of the horizontal velocity vector increases.
#  * - 1 - `decelerate` - if the magnitude of the horizontal velocity vector decreases.
#  *
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
# */
# AccelerationChange::= ENUMERATED { 
#     accelerate (0), 
#     decelerate (1) 
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 ACCELERATE = 0
uint8 DECELERATE = 1


================================================================================
MSG: etsi_its_vam_ts_msgs/HeadingChangeIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  provides  information  associated to heading  change indicators  such as  a  change  of  direction.
#  *
#  * It shall include the following components: 
#  * 
#  * @field direction: the direction of heading change value.
#  * 
#  * @field actionDeltaTime: the period over which a direction change action is performed. 
#  * 
#  * @category: Kinematic Information
#  * @revision: created in V2.1.1
#  */
# HeadingChangeIndication ::= SEQUENCE {
#     direction          TurningDirection,
#     actionDeltaTime    DeltaTimeTenthOfSecond,
#     ...
# }
# ------------------------------------------------------------------------------

TurningDirection direction

DeltaTimeTenthOfSecond action_delta_time


================================================================================
MSG: etsi_its_vam_ts_msgs/TurningDirection
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE provides the turning direction. 
#  * 
#  * The value shall be set to:
#  * - `left`  for turning to te left.
#  * - `right` for turing to the right.
#  *
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# TurningDirection::= ENUMERATED {
#     left, 
#     right 
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 LEFT = 0
uint8 RIGHT = 1


================================================================================
MSG: etsi_its_vam_ts_msgs/StabilityChangeIndication
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF  provides the  indication of  change in stability.
#  *
#  * It shall include the following components: 
#  * 
#  * @field lossProbability: the probability of stability loss. 
#  * 
#  * @field actionDeltaTime: the period over which the the probability of stability loss is estimated. 
#  *
#  * @category: Kinematic information
#  * @revision: V2.1.1
#  */
# StabilityChangeIndication ::= SEQUENCE {
#     lossProbability     StabilityLossProbability,
#     actionDeltaTime     DeltaTimeTenthOfSecond,
#     ...
# }
# ------------------------------------------------------------------------------

StabilityLossProbability loss_probability

DeltaTimeTenthOfSecond action_delta_time


================================================================================
MSG: etsi_its_vam_ts_msgs/StabilityLossProbability
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the estimated probability of a stability level and conversely also the probability of a stability loss.
#  *
#  * The value shall be set to:
#  * - `0` to indicate an estimated probability of a loss of stability of 0 %, i.e. "stable", 
#  * - `n` (`n > 0` and `n < 50`) to indicate the actual stability level,
#  * - `50` to indicate a estimated probability of a loss of stability of 100 %, i.e. "total loss of stability",
#  * - the values between 51 and 62 are reserved for future use,
#  * - `63`: this value indicates that the information is unavailable.
#  *
#  * @unit: 2 %
#  * @category: Kinematic information
#  * @revision: Created in V2.1.1
#  */
# StabilityLossProbability ::= INTEGER {
#     stable                  (0), 
#     totalLossOfStability   (50), 
#     unavailable            (63) 
# } (0..63) 
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 63
uint8 STABLE = 0
uint8 TOTAL_LOSS_OF_STABILITY = 50
uint8 UNAVAILABLE = 63

"""
  __slots__ = ['path_history','path_history_is_present','path_prediction','path_prediction_is_present','safe_distance','safe_distance_is_present','trajectory_interception_indication','trajectory_interception_indication_is_present','acceleration_change_indication','acceleration_change_indication_is_present','heading_change_indication','heading_change_indication_is_present','stability_change_indication','stability_change_indication_is_present']
  _slot_types = ['etsi_its_vam_ts_msgs/PathHistory','bool','etsi_its_vam_ts_msgs/PathPredicted','bool','etsi_its_vam_ts_msgs/SequenceOfSafeDistanceIndication','bool','etsi_its_vam_ts_msgs/SequenceOfTrajectoryInterceptionIndication','bool','etsi_its_vam_ts_msgs/AccelerationChangeIndication','bool','etsi_its_vam_ts_msgs/HeadingChangeIndication','bool','etsi_its_vam_ts_msgs/StabilityChangeIndication','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       path_history,path_history_is_present,path_prediction,path_prediction_is_present,safe_distance,safe_distance_is_present,trajectory_interception_indication,trajectory_interception_indication_is_present,acceleration_change_indication,acceleration_change_indication_is_present,heading_change_indication,heading_change_indication_is_present,stability_change_indication,stability_change_indication_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VruMotionPredictionContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.path_history is None:
        self.path_history = etsi_its_vam_ts_msgs.msg.PathHistory()
      if self.path_history_is_present is None:
        self.path_history_is_present = False
      if self.path_prediction is None:
        self.path_prediction = etsi_its_vam_ts_msgs.msg.PathPredicted()
      if self.path_prediction_is_present is None:
        self.path_prediction_is_present = False
      if self.safe_distance is None:
        self.safe_distance = etsi_its_vam_ts_msgs.msg.SequenceOfSafeDistanceIndication()
      if self.safe_distance_is_present is None:
        self.safe_distance_is_present = False
      if self.trajectory_interception_indication is None:
        self.trajectory_interception_indication = etsi_its_vam_ts_msgs.msg.SequenceOfTrajectoryInterceptionIndication()
      if self.trajectory_interception_indication_is_present is None:
        self.trajectory_interception_indication_is_present = False
      if self.acceleration_change_indication is None:
        self.acceleration_change_indication = etsi_its_vam_ts_msgs.msg.AccelerationChangeIndication()
      if self.acceleration_change_indication_is_present is None:
        self.acceleration_change_indication_is_present = False
      if self.heading_change_indication is None:
        self.heading_change_indication = etsi_its_vam_ts_msgs.msg.HeadingChangeIndication()
      if self.heading_change_indication_is_present is None:
        self.heading_change_indication_is_present = False
      if self.stability_change_indication is None:
        self.stability_change_indication = etsi_its_vam_ts_msgs.msg.StabilityChangeIndication()
      if self.stability_change_indication_is_present is None:
        self.stability_change_indication_is_present = False
    else:
      self.path_history = etsi_its_vam_ts_msgs.msg.PathHistory()
      self.path_history_is_present = False
      self.path_prediction = etsi_its_vam_ts_msgs.msg.PathPredicted()
      self.path_prediction_is_present = False
      self.safe_distance = etsi_its_vam_ts_msgs.msg.SequenceOfSafeDistanceIndication()
      self.safe_distance_is_present = False
      self.trajectory_interception_indication = etsi_its_vam_ts_msgs.msg.SequenceOfTrajectoryInterceptionIndication()
      self.trajectory_interception_indication_is_present = False
      self.acceleration_change_indication = etsi_its_vam_ts_msgs.msg.AccelerationChangeIndication()
      self.acceleration_change_indication_is_present = False
      self.heading_change_indication = etsi_its_vam_ts_msgs.msg.HeadingChangeIndication()
      self.heading_change_indication_is_present = False
      self.stability_change_indication = etsi_its_vam_ts_msgs.msg.StabilityChangeIndication()
      self.stability_change_indication_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_history.array:
        _v1 = val1.path_position
        _v2 = _v1.delta_latitude
        _x = _v2.value
        buff.write(_get_struct_i().pack(_x))
        _v3 = _v1.delta_longitude
        _x = _v3.value
        buff.write(_get_struct_i().pack(_x))
        _v4 = _v1.delta_altitude
        _x = _v4.value
        buff.write(_get_struct_h().pack(_x))
        _v5 = val1.path_delta_time
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.path_history_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.path_prediction.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_prediction.array:
        _v6 = val1.delta_latitude
        _x = _v6.value
        buff.write(_get_struct_i().pack(_x))
        _v7 = val1.delta_longitude
        _x = _v7.value
        buff.write(_get_struct_i().pack(_x))
        _v8 = val1.horizontal_position_confidence
        _v9 = _v8.semi_major_confidence
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v8.semi_minor_confidence
        _x = _v10.value
        buff.write(_get_struct_H().pack(_x))
        _v11 = _v8.semi_major_orientation
        _x = _v11.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.horizontal_position_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
        _v12 = val1.delta_altitude
        _x = _v12.value
        buff.write(_get_struct_h().pack(_x))
        _v13 = val1.altitude_confidence
        _x = _v13.value
        buff.write(_get_struct_B().pack(_x))
        _v14 = val1.path_delta_time
        _x = _v14.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.path_prediction_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.safe_distance.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.safe_distance.array:
        _v15 = val1.subject_station
        _x = _v15.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.subject_station_is_present
        buff.write(_get_struct_B().pack(_x))
        _v16 = val1.safe_distance_indicator
        _x = _v16.value
        buff.write(_get_struct_B().pack(_x))
        _v17 = val1.time_to_collision
        _x = _v17.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.time_to_collision_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.safe_distance_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.trajectory_interception_indication.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_interception_indication.array:
        _v18 = val1.subject_station
        _x = _v18.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.subject_station_is_present
        buff.write(_get_struct_B().pack(_x))
        _v19 = val1.trajectory_interception_probability
        _x = _v19.value
        buff.write(_get_struct_B().pack(_x))
        _v20 = val1.trajectory_interception_confidence
        _x = _v20.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trajectory_interception_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_10B().pack(_x.trajectory_interception_indication_is_present, _x.acceleration_change_indication.accel_or_decel.value, _x.acceleration_change_indication.action_delta_time.value, _x.acceleration_change_indication_is_present, _x.heading_change_indication.direction.value, _x.heading_change_indication.action_delta_time.value, _x.heading_change_indication_is_present, _x.stability_change_indication.loss_probability.value, _x.stability_change_indication.action_delta_time.value, _x.stability_change_indication_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.path_history is None:
        self.path_history = etsi_its_vam_ts_msgs.msg.PathHistory()
      if self.path_prediction is None:
        self.path_prediction = etsi_its_vam_ts_msgs.msg.PathPredicted()
      if self.safe_distance is None:
        self.safe_distance = etsi_its_vam_ts_msgs.msg.SequenceOfSafeDistanceIndication()
      if self.trajectory_interception_indication is None:
        self.trajectory_interception_indication = etsi_its_vam_ts_msgs.msg.SequenceOfTrajectoryInterceptionIndication()
      if self.acceleration_change_indication is None:
        self.acceleration_change_indication = etsi_its_vam_ts_msgs.msg.AccelerationChangeIndication()
      if self.heading_change_indication is None:
        self.heading_change_indication = etsi_its_vam_ts_msgs.msg.HeadingChangeIndication()
      if self.stability_change_indication is None:
        self.stability_change_indication = etsi_its_vam_ts_msgs.msg.StabilityChangeIndication()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPoint()
        _v21 = val1.path_position
        _v22 = _v21.delta_latitude
        start = end
        end += 4
        (_v22.value,) = _get_struct_i().unpack(str[start:end])
        _v23 = _v21.delta_longitude
        start = end
        end += 4
        (_v23.value,) = _get_struct_i().unpack(str[start:end])
        _v24 = _v21.delta_altitude
        start = end
        end += 2
        (_v24.value,) = _get_struct_h().unpack(str[start:end])
        _v25 = val1.path_delta_time
        start = end
        end += 2
        (_v25.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.path_history.array.append(val1)
      start = end
      end += 1
      (self.path_history_is_present,) = _get_struct_B().unpack(str[start:end])
      self.path_history_is_present = bool(self.path_history_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_prediction.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPointPredicted()
        _v26 = val1.delta_latitude
        start = end
        end += 4
        (_v26.value,) = _get_struct_i().unpack(str[start:end])
        _v27 = val1.delta_longitude
        start = end
        end += 4
        (_v27.value,) = _get_struct_i().unpack(str[start:end])
        _v28 = val1.horizontal_position_confidence
        _v29 = _v28.semi_major_confidence
        start = end
        end += 2
        (_v29.value,) = _get_struct_H().unpack(str[start:end])
        _v30 = _v28.semi_minor_confidence
        start = end
        end += 2
        (_v30.value,) = _get_struct_H().unpack(str[start:end])
        _v31 = _v28.semi_major_orientation
        start = end
        end += 2
        (_v31.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.horizontal_position_confidence_is_present = bool(val1.horizontal_position_confidence_is_present)
        _v32 = val1.delta_altitude
        start = end
        end += 2
        (_v32.value,) = _get_struct_h().unpack(str[start:end])
        _v33 = val1.altitude_confidence
        start = end
        end += 1
        (_v33.value,) = _get_struct_B().unpack(str[start:end])
        _v34 = val1.path_delta_time
        start = end
        end += 1
        (_v34.value,) = _get_struct_B().unpack(str[start:end])
        self.path_prediction.array.append(val1)
      start = end
      end += 1
      (self.path_prediction_is_present,) = _get_struct_B().unpack(str[start:end])
      self.path_prediction_is_present = bool(self.path_prediction_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.safe_distance.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.SafeDistanceIndication()
        _v35 = val1.subject_station
        start = end
        end += 4
        (_v35.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.subject_station_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.subject_station_is_present = bool(val1.subject_station_is_present)
        _v36 = val1.safe_distance_indicator
        start = end
        end += 1
        (_v36.value,) = _get_struct_B().unpack(str[start:end])
        _v36.value = bool(_v36.value)
        _v37 = val1.time_to_collision
        start = end
        end += 1
        (_v37.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.time_to_collision_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.time_to_collision_is_present = bool(val1.time_to_collision_is_present)
        self.safe_distance.array.append(val1)
      start = end
      end += 1
      (self.safe_distance_is_present,) = _get_struct_B().unpack(str[start:end])
      self.safe_distance_is_present = bool(self.safe_distance_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_interception_indication.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.TrajectoryInterceptionIndication()
        _v38 = val1.subject_station
        start = end
        end += 4
        (_v38.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.subject_station_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.subject_station_is_present = bool(val1.subject_station_is_present)
        _v39 = val1.trajectory_interception_probability
        start = end
        end += 1
        (_v39.value,) = _get_struct_B().unpack(str[start:end])
        _v40 = val1.trajectory_interception_confidence
        start = end
        end += 1
        (_v40.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trajectory_interception_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trajectory_interception_confidence_is_present = bool(val1.trajectory_interception_confidence_is_present)
        self.trajectory_interception_indication.array.append(val1)
      _x = self
      start = end
      end += 10
      (_x.trajectory_interception_indication_is_present, _x.acceleration_change_indication.accel_or_decel.value, _x.acceleration_change_indication.action_delta_time.value, _x.acceleration_change_indication_is_present, _x.heading_change_indication.direction.value, _x.heading_change_indication.action_delta_time.value, _x.heading_change_indication_is_present, _x.stability_change_indication.loss_probability.value, _x.stability_change_indication.action_delta_time.value, _x.stability_change_indication_is_present,) = _get_struct_10B().unpack(str[start:end])
      self.trajectory_interception_indication_is_present = bool(self.trajectory_interception_indication_is_present)
      self.acceleration_change_indication_is_present = bool(self.acceleration_change_indication_is_present)
      self.heading_change_indication_is_present = bool(self.heading_change_indication_is_present)
      self.stability_change_indication_is_present = bool(self.stability_change_indication_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.path_history.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_history.array:
        _v41 = val1.path_position
        _v42 = _v41.delta_latitude
        _x = _v42.value
        buff.write(_get_struct_i().pack(_x))
        _v43 = _v41.delta_longitude
        _x = _v43.value
        buff.write(_get_struct_i().pack(_x))
        _v44 = _v41.delta_altitude
        _x = _v44.value
        buff.write(_get_struct_h().pack(_x))
        _v45 = val1.path_delta_time
        _x = _v45.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.path_delta_time_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.path_history_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.path_prediction.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.path_prediction.array:
        _v46 = val1.delta_latitude
        _x = _v46.value
        buff.write(_get_struct_i().pack(_x))
        _v47 = val1.delta_longitude
        _x = _v47.value
        buff.write(_get_struct_i().pack(_x))
        _v48 = val1.horizontal_position_confidence
        _v49 = _v48.semi_major_confidence
        _x = _v49.value
        buff.write(_get_struct_H().pack(_x))
        _v50 = _v48.semi_minor_confidence
        _x = _v50.value
        buff.write(_get_struct_H().pack(_x))
        _v51 = _v48.semi_major_orientation
        _x = _v51.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.horizontal_position_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
        _v52 = val1.delta_altitude
        _x = _v52.value
        buff.write(_get_struct_h().pack(_x))
        _v53 = val1.altitude_confidence
        _x = _v53.value
        buff.write(_get_struct_B().pack(_x))
        _v54 = val1.path_delta_time
        _x = _v54.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.path_prediction_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.safe_distance.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.safe_distance.array:
        _v55 = val1.subject_station
        _x = _v55.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.subject_station_is_present
        buff.write(_get_struct_B().pack(_x))
        _v56 = val1.safe_distance_indicator
        _x = _v56.value
        buff.write(_get_struct_B().pack(_x))
        _v57 = val1.time_to_collision
        _x = _v57.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.time_to_collision_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.safe_distance_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.trajectory_interception_indication.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_interception_indication.array:
        _v58 = val1.subject_station
        _x = _v58.value
        buff.write(_get_struct_I().pack(_x))
        _x = val1.subject_station_is_present
        buff.write(_get_struct_B().pack(_x))
        _v59 = val1.trajectory_interception_probability
        _x = _v59.value
        buff.write(_get_struct_B().pack(_x))
        _v60 = val1.trajectory_interception_confidence
        _x = _v60.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.trajectory_interception_confidence_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_10B().pack(_x.trajectory_interception_indication_is_present, _x.acceleration_change_indication.accel_or_decel.value, _x.acceleration_change_indication.action_delta_time.value, _x.acceleration_change_indication_is_present, _x.heading_change_indication.direction.value, _x.heading_change_indication.action_delta_time.value, _x.heading_change_indication_is_present, _x.stability_change_indication.loss_probability.value, _x.stability_change_indication.action_delta_time.value, _x.stability_change_indication_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.path_history is None:
        self.path_history = etsi_its_vam_ts_msgs.msg.PathHistory()
      if self.path_prediction is None:
        self.path_prediction = etsi_its_vam_ts_msgs.msg.PathPredicted()
      if self.safe_distance is None:
        self.safe_distance = etsi_its_vam_ts_msgs.msg.SequenceOfSafeDistanceIndication()
      if self.trajectory_interception_indication is None:
        self.trajectory_interception_indication = etsi_its_vam_ts_msgs.msg.SequenceOfTrajectoryInterceptionIndication()
      if self.acceleration_change_indication is None:
        self.acceleration_change_indication = etsi_its_vam_ts_msgs.msg.AccelerationChangeIndication()
      if self.heading_change_indication is None:
        self.heading_change_indication = etsi_its_vam_ts_msgs.msg.HeadingChangeIndication()
      if self.stability_change_indication is None:
        self.stability_change_indication = etsi_its_vam_ts_msgs.msg.StabilityChangeIndication()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_history.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPoint()
        _v61 = val1.path_position
        _v62 = _v61.delta_latitude
        start = end
        end += 4
        (_v62.value,) = _get_struct_i().unpack(str[start:end])
        _v63 = _v61.delta_longitude
        start = end
        end += 4
        (_v63.value,) = _get_struct_i().unpack(str[start:end])
        _v64 = _v61.delta_altitude
        start = end
        end += 2
        (_v64.value,) = _get_struct_h().unpack(str[start:end])
        _v65 = val1.path_delta_time
        start = end
        end += 2
        (_v65.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.path_delta_time_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.path_delta_time_is_present = bool(val1.path_delta_time_is_present)
        self.path_history.array.append(val1)
      start = end
      end += 1
      (self.path_history_is_present,) = _get_struct_B().unpack(str[start:end])
      self.path_history_is_present = bool(self.path_history_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.path_prediction.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.PathPointPredicted()
        _v66 = val1.delta_latitude
        start = end
        end += 4
        (_v66.value,) = _get_struct_i().unpack(str[start:end])
        _v67 = val1.delta_longitude
        start = end
        end += 4
        (_v67.value,) = _get_struct_i().unpack(str[start:end])
        _v68 = val1.horizontal_position_confidence
        _v69 = _v68.semi_major_confidence
        start = end
        end += 2
        (_v69.value,) = _get_struct_H().unpack(str[start:end])
        _v70 = _v68.semi_minor_confidence
        start = end
        end += 2
        (_v70.value,) = _get_struct_H().unpack(str[start:end])
        _v71 = _v68.semi_major_orientation
        start = end
        end += 2
        (_v71.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.horizontal_position_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.horizontal_position_confidence_is_present = bool(val1.horizontal_position_confidence_is_present)
        _v72 = val1.delta_altitude
        start = end
        end += 2
        (_v72.value,) = _get_struct_h().unpack(str[start:end])
        _v73 = val1.altitude_confidence
        start = end
        end += 1
        (_v73.value,) = _get_struct_B().unpack(str[start:end])
        _v74 = val1.path_delta_time
        start = end
        end += 1
        (_v74.value,) = _get_struct_B().unpack(str[start:end])
        self.path_prediction.array.append(val1)
      start = end
      end += 1
      (self.path_prediction_is_present,) = _get_struct_B().unpack(str[start:end])
      self.path_prediction_is_present = bool(self.path_prediction_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.safe_distance.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.SafeDistanceIndication()
        _v75 = val1.subject_station
        start = end
        end += 4
        (_v75.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.subject_station_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.subject_station_is_present = bool(val1.subject_station_is_present)
        _v76 = val1.safe_distance_indicator
        start = end
        end += 1
        (_v76.value,) = _get_struct_B().unpack(str[start:end])
        _v76.value = bool(_v76.value)
        _v77 = val1.time_to_collision
        start = end
        end += 1
        (_v77.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.time_to_collision_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.time_to_collision_is_present = bool(val1.time_to_collision_is_present)
        self.safe_distance.array.append(val1)
      start = end
      end += 1
      (self.safe_distance_is_present,) = _get_struct_B().unpack(str[start:end])
      self.safe_distance_is_present = bool(self.safe_distance_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_interception_indication.array = []
      for i in range(0, length):
        val1 = etsi_its_vam_ts_msgs.msg.TrajectoryInterceptionIndication()
        _v78 = val1.subject_station
        start = end
        end += 4
        (_v78.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 1
        (val1.subject_station_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.subject_station_is_present = bool(val1.subject_station_is_present)
        _v79 = val1.trajectory_interception_probability
        start = end
        end += 1
        (_v79.value,) = _get_struct_B().unpack(str[start:end])
        _v80 = val1.trajectory_interception_confidence
        start = end
        end += 1
        (_v80.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.trajectory_interception_confidence_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.trajectory_interception_confidence_is_present = bool(val1.trajectory_interception_confidence_is_present)
        self.trajectory_interception_indication.array.append(val1)
      _x = self
      start = end
      end += 10
      (_x.trajectory_interception_indication_is_present, _x.acceleration_change_indication.accel_or_decel.value, _x.acceleration_change_indication.action_delta_time.value, _x.acceleration_change_indication_is_present, _x.heading_change_indication.direction.value, _x.heading_change_indication.action_delta_time.value, _x.heading_change_indication_is_present, _x.stability_change_indication.loss_probability.value, _x.stability_change_indication.action_delta_time.value, _x.stability_change_indication_is_present,) = _get_struct_10B().unpack(str[start:end])
      self.trajectory_interception_indication_is_present = bool(self.trajectory_interception_indication_is_present)
      self.acceleration_change_indication_is_present = bool(self.acceleration_change_indication_is_present)
      self.heading_change_indication_is_present = bool(self.heading_change_indication_is_present)
      self.stability_change_indication_is_present = bool(self.stability_change_indication_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10B = None
def _get_struct_10B():
    global _struct_10B
    if _struct_10B is None:
        _struct_10B = struct.Struct("<10B")
    return _struct_10B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
