# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/VruProfileAndSubprofile.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class VruProfileAndSubprofile(genpy.Message):
  _md5sum = "d660f39a52014318b16a21fdbdcb85e6"
  _type = "etsi_its_vam_ts_msgs/VruProfileAndSubprofile"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the profile of a VRU including sub-profile information
#  * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
#  *
#  * @field pedestrian: VRU Profile 1 - Pedestrian.
#  *
#  * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
#  *
#  * @field motorcyclist: VRU Profile 3  - Motorcyclist.
#  *
#  * @field animal: VRU Profile  4 -  Animal.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruProfileAndSubprofile ::= CHOICE {
#    pedestrian                     VruSubProfilePedestrian,
#    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
#    motorcyclist                   VruSubProfileMotorcyclist,
#    animal                         VruSubProfileAnimal,
#    ...
# }
# ------------------------------------------------------------------------------

uint8 choice

VruSubProfilePedestrian pedestrian
uint8 CHOICE_PEDESTRIAN = 0

VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1

VruSubProfileMotorcyclist motorcyclist
uint8 CHOICE_MOTORCYCLIST = 2

VruSubProfileAnimal animal
uint8 CHOICE_ANIMAL = 3


================================================================================
MSG: etsi_its_vam_ts_msgs/VruSubProfilePedestrian
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a pedestrian.
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`             - to indicate that the information on is unavailable,
#  * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
#  * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
#  * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
#  * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfilePedestrian ::= ENUMERATED {
#     unavailable         (0), 
#     ordinary-pedestrian (1),
#     road-worker         (2), 
#     first-responder     (3),
#     max                 (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 ORDINARY_PEDESTRIAN = 1
uint8 ROAD_WORKER = 2
uint8 FIRST_RESPONDER = 3
uint8 MAX = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/VruSubProfileBicyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
#  *
#  * The value shall be set to:
#  * - 0 `unavailable`           - to indicate that the information  is unavailable,
#  * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
#  * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
#  * - 3 `horse-and-rider`       - to indicate a horse and rider,
#  * - 4 `rollerskater`          - to indicate a rolleskater and skater,
#  * - 5 `e-scooter`             - to indicate an e-scooter and rider,
#  * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
#  * - 7 `pedelec`               - to indicate a pedelec and rider,
#  * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
#  * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileBicyclist ::= ENUMERATED {
#     unavailable          (0), 
#     bicyclist            (1), 
#     wheelchair-user      (2), 
#     horse-and-rider      (3), 
#     rollerskater         (4), 
#     e-scooter            (5), 
#     personal-transporter (6),
#     pedelec              (7), 
#     speed-pedelec        (8),
#     max                  (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 BICYCLIST = 1
uint8 WHEELCHAIR_USER = 2
uint8 HORSE_AND_RIDER = 3
uint8 ROLLERSKATER = 4
uint8 E_SCOOTER = 5
uint8 PERSONAL_TRANSPORTER = 6
uint8 PEDELEC = 7
uint8 SPEED_PEDELEC = 8
uint8 MAX = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/VruSubProfileMotorcyclist
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of a motorcyclist and corresponding vehicle.
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable `                  - to indicate that the information  is unavailable,
#  * - 1 `moped`                         - to indicate a moped and rider,
#  * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
#  * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
#  * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
#  * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileMotorcyclist ::= ENUMERATED { 
#     unavailable                  (0), 
#     moped                        (1), 
#     motorcycle                   (2), 
#     motorcycle-and-sidecar-right (3), 
#     motorcycle-and-sidecar-left  (4), 
#     max                          (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 MOPED = 1
uint8 MOTORCYCLE = 2
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
uint8 MAX = 15


================================================================================
MSG: etsi_its_vam_ts_msgs/VruSubProfileAnimal
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the profile of an animal
#  * 
#  * The value shall be set to:
#  * - 0 `unavailable`     - to indicate that the information  is unavailable,
#  * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
#  * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
#  * - 3 `service-animal`  - to indicate an animal that supports a human being.
#  * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
#  *
#  * @category: VRU information
#  * @revision: Created in V2.1.1
#  */
# VruSubProfileAnimal ::= ENUMERATED {
#     unavailable    (0), 
#     wild-animal    (1), 
#     farm-animal    (2), 
#     service-animal (3),   
#     max            (15)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 UNAVAILABLE = 0
uint8 WILD_ANIMAL = 1
uint8 FARM_ANIMAL = 2
uint8 SERVICE_ANIMAL = 3
uint8 MAX = 15

"""
  # Pseudo-constants
  CHOICE_PEDESTRIAN = 0
  CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1
  CHOICE_MOTORCYCLIST = 2
  CHOICE_ANIMAL = 3

  __slots__ = ['choice','pedestrian','bicyclist_and_light_vru_vehicle','motorcyclist','animal']
  _slot_types = ['uint8','etsi_its_vam_ts_msgs/VruSubProfilePedestrian','etsi_its_vam_ts_msgs/VruSubProfileBicyclist','etsi_its_vam_ts_msgs/VruSubProfileMotorcyclist','etsi_its_vam_ts_msgs/VruSubProfileAnimal']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       choice,pedestrian,bicyclist_and_light_vru_vehicle,motorcyclist,animal

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(VruProfileAndSubprofile, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.choice is None:
        self.choice = 0
      if self.pedestrian is None:
        self.pedestrian = etsi_its_vam_ts_msgs.msg.VruSubProfilePedestrian()
      if self.bicyclist_and_light_vru_vehicle is None:
        self.bicyclist_and_light_vru_vehicle = etsi_its_vam_ts_msgs.msg.VruSubProfileBicyclist()
      if self.motorcyclist is None:
        self.motorcyclist = etsi_its_vam_ts_msgs.msg.VruSubProfileMotorcyclist()
      if self.animal is None:
        self.animal = etsi_its_vam_ts_msgs.msg.VruSubProfileAnimal()
    else:
      self.choice = 0
      self.pedestrian = etsi_its_vam_ts_msgs.msg.VruSubProfilePedestrian()
      self.bicyclist_and_light_vru_vehicle = etsi_its_vam_ts_msgs.msg.VruSubProfileBicyclist()
      self.motorcyclist = etsi_its_vam_ts_msgs.msg.VruSubProfileMotorcyclist()
      self.animal = etsi_its_vam_ts_msgs.msg.VruSubProfileAnimal()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5B().pack(_x.choice, _x.pedestrian.value, _x.bicyclist_and_light_vru_vehicle.value, _x.motorcyclist.value, _x.animal.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pedestrian is None:
        self.pedestrian = etsi_its_vam_ts_msgs.msg.VruSubProfilePedestrian()
      if self.bicyclist_and_light_vru_vehicle is None:
        self.bicyclist_and_light_vru_vehicle = etsi_its_vam_ts_msgs.msg.VruSubProfileBicyclist()
      if self.motorcyclist is None:
        self.motorcyclist = etsi_its_vam_ts_msgs.msg.VruSubProfileMotorcyclist()
      if self.animal is None:
        self.animal = etsi_its_vam_ts_msgs.msg.VruSubProfileAnimal()
      end = 0
      _x = self
      start = end
      end += 5
      (_x.choice, _x.pedestrian.value, _x.bicyclist_and_light_vru_vehicle.value, _x.motorcyclist.value, _x.animal.value,) = _get_struct_5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5B().pack(_x.choice, _x.pedestrian.value, _x.bicyclist_and_light_vru_vehicle.value, _x.motorcyclist.value, _x.animal.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pedestrian is None:
        self.pedestrian = etsi_its_vam_ts_msgs.msg.VruSubProfilePedestrian()
      if self.bicyclist_and_light_vru_vehicle is None:
        self.bicyclist_and_light_vru_vehicle = etsi_its_vam_ts_msgs.msg.VruSubProfileBicyclist()
      if self.motorcyclist is None:
        self.motorcyclist = etsi_its_vam_ts_msgs.msg.VruSubProfileMotorcyclist()
      if self.animal is None:
        self.animal = etsi_its_vam_ts_msgs.msg.VruSubProfileAnimal()
      end = 0
      _x = self
      start = end
      end += 5
      (_x.choice, _x.pedestrian.value, _x.bicyclist_and_light_vru_vehicle.value, _x.motorcyclist.value, _x.animal.value,) = _get_struct_5B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
