# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_vam_ts_msgs/YawRate.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_vam_ts_msgs.msg

class YawRate(genpy.Message):
  _md5sum = "4b93df309164609334f0f4a47f3bd354"
  _type = "etsi_its_vam_ts_msgs/YawRate"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF represents a yaw rate of vehicle at a point in time.
#  *
#  * It shall include the following components: 
#  * 
#  * @field yawRateValue: yaw rate value at a point in time.
#  * 
#  * @field yawRateConfidence: confidence value associated to the yaw rate value.
#  * 
#  * @category: Vehicle Information
#  * @revision: V1.3.1
#  */
# YawRate::= SEQUENCE {
#     yawRateValue         YawRateValue,
#     yawRateConfidence    YawRateConfidence
# }
# ------------------------------------------------------------------------------

YawRateValue yaw_rate_value

YawRateConfidence yaw_rate_confidence


================================================================================
MSG: etsi_its_vam_ts_msgs/YawRateValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the vehicle rotation around z-axis of the coordinate system centred on the centre of mass of the empty-loaded
#  * vehicle. The leading sign denotes the direction of rotation.
#  * 
#  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
#  *
#  * The value shall be set to:
#  * - `-32 766` to indicate that the yaw rate is equal to or greater than 327,66 degrees/second to the right,
#  * - `n` (`n > -32 766` and `n <= 0`) to indicate that the rotation is clockwise (i.e. to the right) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `n` (`n > 0` and `n < 32 766`) to indicate that the rotation is anti-clockwise (i.e. to the left) and is equal to or less than n x 0,01 degrees/s, 
#       and greater than (n-1) x 0,01 degrees/s,
#  * - `32 766` to indicate that the yaw rate is greater than 327.65 degrees/second to the left,
#  * - `32 767` to indicate that the information is not available.
#  * 
#  * The yaw rate value shall be a raw data value, i.e. not filtered, smoothed or otherwise modified.
#  * The reading instant should be the same as for the vehicle acceleration.
#  * 
#  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
#  * 
#  * @unit: 0,01 degree per second. 
#  * @category: Vehicle Information
#  * @revision: Desription revised in V2.1.1 (the meaning of 32766 has changed slightly). 
# */
# YawRateValue ::= INTEGER {
#     negativeOutOfRange (-32766), 
#     positiveOutOfRange (32766), 
#     unavailable        (32767)
# } (-32766..32767)
# ------------------------------------------------------------------------------

int16 value
int16 MIN = -32766
int16 MAX = 32767
int16 NEGATIVE_OUT_OF_RANGE = -32766
int16 POSITIVE_OUT_OF_RANGE = 32766
int16 UNAVAILABLE = 32767


================================================================================
MSG: etsi_its_vam_ts_msgs/YawRateConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
#   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
#   -t
#   vam_ts
#   -o
#   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the yaw rate confidence value which represents the estimated accuracy for a yaw rate value with a default confidence level of 95 %.
#  * If required, the confidence level can be defined by the corresponding standards applying this DE.
#  * 
#  * The value shall be set to:
#  * - `0` if the confidence value is equal to or less than 0,01 degree/second,
#  * - `1` if the confidence value is equal to or less than 0,05 degrees/second or greater than 0,01 degree/second,
#  * - `2` if the confidence value is equal to or less than 0,1 degree/second or greater than 0,05 degree/second,
#  * - `3` if the confidence value is equal to or less than 1 degree/second or greater than 0,1 degree/second,
#  * - `4` if the confidence value is equal to or less than 5 degrees/second or greater than 1 degrees/second,
#  * - `5` if the confidence value is equal to or less than 10 degrees/second or greater than 5 degrees/second,
#  * - `6` if the confidence value is equal to or less than 100 degrees/second or greater than 10 degrees/second,
#  * - `7` if the confidence value is out of range, i.e. greater than 100 degrees/second,
#  * - `8` if the confidence value is unavailable.
#  * 
#  * NOTE: The fact that a yaw rate value is received with confidence value set to `unavailable(8)` can be caused by
#  * several reasons, such as:
#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
#  * - the sensor cannot calculate the accuracy due to lack of variables, or
#  * - there has been a vehicle bus (e.g. CAN bus) error.
#  * In all 3 cases above, the yaw rate value may be valid and used by the application.
#  * 
#  * If a yaw rate value is received and its confidence value is set to `outOfRange(7)`, it means that the 
#  * yaw rate value is not valid and therefore cannot be trusted. Such value is not useful the application.
#  * 
#  * @category: Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# YawRateConfidence ::= ENUMERATED {
#     degSec-000-01 (0),
#     degSec-000-05 (1),
#     degSec-000-10 (2),
#     degSec-001-00 (3), 
#     degSec-005-00 (4),
#     degSec-010-00 (5),
#     degSec-100-00 (6),
#     outOfRange    (7),
#     unavailable   (8)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 DEG_SEC_000_01 = 0
uint8 DEG_SEC_000_05 = 1
uint8 DEG_SEC_000_10 = 2
uint8 DEG_SEC_001_00 = 3
uint8 DEG_SEC_005_00 = 4
uint8 DEG_SEC_010_00 = 5
uint8 DEG_SEC_100_00 = 6
uint8 OUT_OF_RANGE = 7
uint8 UNAVAILABLE = 8

"""
  __slots__ = ['yaw_rate_value','yaw_rate_confidence']
  _slot_types = ['etsi_its_vam_ts_msgs/YawRateValue','etsi_its_vam_ts_msgs/YawRateConfidence']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       yaw_rate_value,yaw_rate_confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(YawRate, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.yaw_rate_value is None:
        self.yaw_rate_value = etsi_its_vam_ts_msgs.msg.YawRateValue()
      if self.yaw_rate_confidence is None:
        self.yaw_rate_confidence = etsi_its_vam_ts_msgs.msg.YawRateConfidence()
    else:
      self.yaw_rate_value = etsi_its_vam_ts_msgs.msg.YawRateValue()
      self.yaw_rate_confidence = etsi_its_vam_ts_msgs.msg.YawRateConfidence()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.yaw_rate_value.value, _x.yaw_rate_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.yaw_rate_value is None:
        self.yaw_rate_value = etsi_its_vam_ts_msgs.msg.YawRateValue()
      if self.yaw_rate_confidence is None:
        self.yaw_rate_confidence = etsi_its_vam_ts_msgs.msg.YawRateConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.yaw_rate_value.value, _x.yaw_rate_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_hB().pack(_x.yaw_rate_value.value, _x.yaw_rate_confidence.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.yaw_rate_value is None:
        self.yaw_rate_value = etsi_its_vam_ts_msgs.msg.YawRateValue()
      if self.yaw_rate_confidence is None:
        self.yaw_rate_confidence = etsi_its_vam_ts_msgs.msg.YawRateConfidence()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.yaw_rate_value.value, _x.yaw_rate_confidence.value,) = _get_struct_hB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_hB = None
def _get_struct_hB():
    global _struct_hB
    if _struct_hB is None:
        _struct_hB = struct.Struct("<hB")
    return _struct_hB
