// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class AccelerationConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AccelerationConfidence
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AccelerationConfidence
    let len;
    let data = new AccelerationConfidence(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/AccelerationConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7b15483e97e308c44ae7babe6a4b0512';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. 
    #  * If required, the confidence level can be defined by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    #  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,
    #  * - `102` if the confidence value is unavailable.
    #  *
    #  * The value 0 shall not be used.
    #  *
    #  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:
    #  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    #  * - the sensor cannot calculate the accuracy due to lack of variables, or
    #  * - there has been a vehicle bus (e.g. CAN bus) error.
    #  * In all 3 cases above, the acceleration value may be valid and used by the application.
    #  * 
    #  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.
    #  *
    #  * @unit 0,1 m/s^2
    #  * @category: Kinematic information
    #  * @revision: Description revised in V2.1.1
    #  */
    # AccelerationConfidence ::= INTEGER {
    #     outOfRange                 (101), 
    #     unavailable                (102)
    # } (0..102)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 102
    uint8 OUT_OF_RANGE = 101
    uint8 UNAVAILABLE = 102
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AccelerationConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
AccelerationConfidence.Constants = {
  MIN: 0,
  MAX: 102,
  OUT_OF_RANGE: 101,
  UNAVAILABLE: 102,
}

module.exports = AccelerationConfidence;
