// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ClusterBreakupReason {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ClusterBreakupReason
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ClusterBreakupReason
    let len;
    let data = new ClusterBreakupReason(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/ClusterBreakupReason';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '107218784ea0f419a3f2aef99d6a9ece';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the reason why a cluster leader intends to break up the cluster.
    #  * 
    #  * The value shall be set to:
    #  * - 0 - `notProvided`                          - if the information is not provided,
    #  * - 1 - `clusteringPurposeCompleted`           - if the cluster purpose has been completed,
    #  * - 2 - `leaderMovedOutOfClusterBoundingBox`   - if the leader moved out of the cluster's bounding box,
    #  * - 3 - `joiningAnotherCluster`                - if the cluster leader is about to join another cluster,
    #  * - 4 - `enteringLowRiskAreaBasedOnMaps`       - if the cluster is entering an area idenrified as low risk based on the use of maps,
    #  * - 5 - `receptionOfCpmContainingCluster`      - if the leader received a Collective Perception Message containing information about the same cluster. 
    #  * - 6 to 15                                    - are reserved for future use.                                    
    #  *
    #  * @category: Cluster information
    #  * @revision: Created in V2.1.1
    # */
    # ClusterBreakupReason ::= ENUMERATED {
    #     notProvided                        (0),
    #     clusteringPurposeCompleted         (1),
    #     leaderMovedOutOfClusterBoundingBox (2),    
    #     joiningAnotherCluster              (3),
    #     enteringLowRiskAreaBasedOnMaps     (4),
    #     receptionOfCpmContainingCluster    (5),
    #     max(15)                                                                 
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 NOT_PROVIDED = 0
    uint8 CLUSTERING_PURPOSE_COMPLETED = 1
    uint8 LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX = 2
    uint8 JOINING_ANOTHER_CLUSTER = 3
    uint8 ENTERING_LOW_RISK_AREA_BASED_ON_MAPS = 4
    uint8 RECEPTION_OF_CPM_CONTAINING_CLUSTER = 5
    uint8 MAX = 15
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ClusterBreakupReason(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
ClusterBreakupReason.Constants = {
  NOT_PROVIDED: 0,
  CLUSTERING_PURPOSE_COMPLETED: 1,
  LEADER_MOVED_OUT_OF_CLUSTER_BOUNDING_BOX: 2,
  JOINING_ANOTHER_CLUSTER: 3,
  ENTERING_LOW_RISK_AREA_BASED_ON_MAPS: 4,
  RECEPTION_OF_CPM_CONTAINING_CLUSTER: 5,
  MAX: 15,
}

module.exports = ClusterBreakupReason;
