// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ClusterLeaveReason {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ClusterLeaveReason
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ClusterLeaveReason
    let len;
    let data = new ClusterLeaveReason(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/ClusterLeaveReason';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1b98840bc866f061cfa18b41ac6d51ea';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the reason why a cluster participant is leaving the cluster.
    #  * 
    #  * The value shall be set to:
    #  * - 0 - `notProvided `                 - if the information is not provided,
    #  * - 1 - `clusterLeaderLost`            - if the cluster leader cannot be found anymore,   
    #  * - 2 - `clusterDisbandedByLeader`     - if the cluster has been disbanded by the leader,
    #  * - 3 - `outOfClusterBoundingBox`      - if the participants moved out of the cluster's bounding box,
    #  * - 4 - `outOfClusterSpeedRange`       - if the cluster speed moved out of a defined range, 
    #  * - 5 - `joiningAnotherCluster`        - if the participant is joining another cluster,
    #  * - 6 - `cancelledJoin`                - if the participant is cancelling a joining procedure,
    #  * - 7 - `failedJoin`                   - if the participant failed to join the cluster,
    #  * - 8 - `safetyCondition`              - if a safety condition applies.
    #  * - 9 to 15                            - are reserved for future use                             
    #  *
    #  * @category: Cluster information
    #  * @revision: Created in V2.1.1
    #  */
    # ClusterLeaveReason ::= ENUMERATED {
    #     notProvided                   (0), 
    #     clusterLeaderLost             (1),    
    #     clusterDisbandedByLeader      (2),    
    #     outOfClusterBoundingBox       (3),    
    #     outOfClusterSpeedRange        (4),
    #     joiningAnotherCluster         (5),
    #     cancelledJoin                 (6),
    #     failedJoin                    (7),
    #     safetyCondition               (8),
    #     max(15)            
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 NOT_PROVIDED = 0
    uint8 CLUSTER_LEADER_LOST = 1
    uint8 CLUSTER_DISBANDED_BY_LEADER = 2
    uint8 OUT_OF_CLUSTER_BOUNDING_BOX = 3
    uint8 OUT_OF_CLUSTER_SPEED_RANGE = 4
    uint8 JOINING_ANOTHER_CLUSTER = 5
    uint8 CANCELLED_JOIN = 6
    uint8 FAILED_JOIN = 7
    uint8 SAFETY_CONDITION = 8
    uint8 MAX = 15
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ClusterLeaveReason(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
ClusterLeaveReason.Constants = {
  NOT_PROVIDED: 0,
  CLUSTER_LEADER_LOST: 1,
  CLUSTER_DISBANDED_BY_LEADER: 2,
  OUT_OF_CLUSTER_BOUNDING_BOX: 3,
  OUT_OF_CLUSTER_SPEED_RANGE: 4,
  JOINING_ANOTHER_CLUSTER: 5,
  CANCELLED_JOIN: 6,
  FAILED_JOIN: 7,
  SAFETY_CONDITION: 8,
  MAX: 15,
}

module.exports = ClusterLeaveReason;
