// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CurvatureConfidence {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CurvatureConfidence
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CurvatureConfidence
    let len;
    let data = new CurvatureConfidence(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/CurvatureConfidence';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b17aabdbf4de6437a91233dd117ad963';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy range of a curvature value with a confidence level of 95 %.
    #  * If required, the confidence level can be defined by the corresponding standards applying this DE.
    #  * 
    #  * The value shall be set to:
    #  * - 0 - `onePerMeter-0-00002` - if the confidence value is less than or equal to 0,00002 m-1,
    #  * - 1 - `onePerMeter-0-0001`  - if the confidence value is less than or equal to 0,0001 m-1 and greater than 0,00002 m-1,
    #  * - 2 - `onePerMeter-0-0005`  - if the confidence value is less than or equal to 0,0005 m-1 and greater than 0,0001 m-1,
    #  * - 3 - `onePerMeter-0-002`   - if the confidence value is less than or equal to 0,002 m-1 and greater than 0,0005 m-1,
    #  * - 4 - `nePerMeter-0-01`     - if the confidence value is less than or equal to 0,01 m-1 and greater than 0,002 m-1,
    #  * - 5 - `nePerMeter-0-1`      - if the confidence value is less than or equal to 0,1 m-1  and greater than 0,01 m-1,
    #  * - 6 - `outOfRange`          - if the confidence value is out of range, i.e. greater than 0,1 m-1,
    #  * - 7 - `unavailable`         - if the confidence value is not available.
    #  * 
    #  * @note:	The fact that a curvature value is received with confidence value set to `unavailable(7)` can be caused by
    #  * several reasons, such as:
    #  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    #  * - the sensor cannot calculate the accuracy due to lack of variables, or
    #  * - there has been a vehicle bus (e.g. CAN bus) error.
    #  * In all 3 cases above, the curvature value may be valid and used by the application.
    #  * 
    #  * @note: If a curvature value is received and its confidence value is set to `outOfRange(6)`, it means that the curvature value is not valid 
    #  * and therefore cannot be trusted. Such value is not useful for the application.
    #  * 
    #  * @category: Vehicle information
    #  * @revision: Description revised in V2.1.1
    # */
    # CurvatureConfidence ::= ENUMERATED {
    #     onePerMeter-0-00002 (0),
    #     onePerMeter-0-0001  (1),
    #     onePerMeter-0-0005  (2),
    #     onePerMeter-0-002   (3),
    #     onePerMeter-0-01    (4),
    #     onePerMeter-0-1     (5),
    #     outOfRange          (6),
    #     unavailable         (7)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 ONE_PER_METER_0_00002 = 0
    uint8 ONE_PER_METER_0_0001 = 1
    uint8 ONE_PER_METER_0_0005 = 2
    uint8 ONE_PER_METER_0_002 = 3
    uint8 ONE_PER_METER_0_01 = 4
    uint8 ONE_PER_METER_0_1 = 5
    uint8 OUT_OF_RANGE = 6
    uint8 UNAVAILABLE = 7
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CurvatureConfidence(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
CurvatureConfidence.Constants = {
  ONE_PER_METER_0_00002: 0,
  ONE_PER_METER_0_0001: 1,
  ONE_PER_METER_0_0005: 2,
  ONE_PER_METER_0_002: 3,
  ONE_PER_METER_0_01: 4,
  ONE_PER_METER_0_1: 5,
  OUT_OF_RANGE: 6,
  UNAVAILABLE: 7,
}

module.exports = CurvatureConfidence;
