// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class CurvatureValue {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type CurvatureValue
    // Serialize message field [value]
    bufferOffset = _serializer.int16(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type CurvatureValue
    let len;
    let data = new CurvatureValue(null);
    // Deserialize message field [value]
    data.value = _deserializer.int16(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/CurvatureValue';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c55bbce40fc32de4e1cbc564edd33f3e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE describes vehicle turning curve with the following information:
    #  * ```
    #  *     Value = 1 / Radius * 10000
    #  * ```
    #  * wherein radius is the vehicle turning curve radius in metres. 
    #  * 
    #  * Positive values indicate a turning curve to the left hand side of the driver.
    #  * It corresponds to the vehicle coordinate system as defined in ISO 8855 [21].
    #  *
    #  * The value shall be set to:
    #  * - `-1023` for  values smaller than -1023,
    #  * - `n` (`n > -1023` and `n < 0`) for negative values equal to or less than `n`, and greater than `(n-1)`,
    #  * - `0` when the vehicle is moving straight,
    #  * - `n` (`n > 0` and `n < 1022`) for positive values equal to or less than `n`, and greater than `(n-1)`,
    #  * - `1022`, for values  greater than 1021,
    #  * - `1023`, if the information is not available.
    #  * 
    #  * @note: The present DE is limited to vehicle types as defined in ISO 8855 [21].
    #  * 
    #  * @unit: 1 over 10 000 metres
    #  * @category: Vehicle information
    #  * @revision: description revised in V2.1.1 (the definition of value 1022 has changed slightly)
    #  */
    # CurvatureValue ::= INTEGER {
    #     outOfRangeNegative (-1023),
    #     straight           (0),
    #     outOfRangePositive (1022), 
    #     unavailable        (1023)
    # } (-1023..1023)
    # ------------------------------------------------------------------------------
    
    int16 value
    int16 MIN = -1023
    int16 MAX = 1023
    int16 OUT_OF_RANGE_NEGATIVE = -1023
    int16 STRAIGHT = 0
    int16 OUT_OF_RANGE_POSITIVE = 1022
    int16 UNAVAILABLE = 1023
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new CurvatureValue(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
CurvatureValue.Constants = {
  MIN: -1023,
  MAX: 1023,
  OUT_OF_RANGE_NEGATIVE: -1023,
  STRAIGHT: 0,
  OUT_OF_RANGE_POSITIVE: 1022,
  UNAVAILABLE: 1023,
}

module.exports = CurvatureValue;
