// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LanePosition = require('./LanePosition.js');
let LanePositionAndType = require('./LanePositionAndType.js');
let TrafficIslandPosition = require('./TrafficIslandPosition.js');
let MapPosition = require('./MapPosition.js');

//-----------------------------------------------------------

class GeneralizedLanePosition {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.choice = null;
      this.traffic_lane_position = null;
      this.non_traffic_lane_position = null;
      this.traffic_island_position = null;
      this.map_position = null;
    }
    else {
      if (initObj.hasOwnProperty('choice')) {
        this.choice = initObj.choice
      }
      else {
        this.choice = 0;
      }
      if (initObj.hasOwnProperty('traffic_lane_position')) {
        this.traffic_lane_position = initObj.traffic_lane_position
      }
      else {
        this.traffic_lane_position = new LanePosition();
      }
      if (initObj.hasOwnProperty('non_traffic_lane_position')) {
        this.non_traffic_lane_position = initObj.non_traffic_lane_position
      }
      else {
        this.non_traffic_lane_position = new LanePositionAndType();
      }
      if (initObj.hasOwnProperty('traffic_island_position')) {
        this.traffic_island_position = initObj.traffic_island_position
      }
      else {
        this.traffic_island_position = new TrafficIslandPosition();
      }
      if (initObj.hasOwnProperty('map_position')) {
        this.map_position = initObj.map_position
      }
      else {
        this.map_position = new MapPosition();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GeneralizedLanePosition
    // Serialize message field [choice]
    bufferOffset = _serializer.uint8(obj.choice, buffer, bufferOffset);
    // Serialize message field [traffic_lane_position]
    bufferOffset = LanePosition.serialize(obj.traffic_lane_position, buffer, bufferOffset);
    // Serialize message field [non_traffic_lane_position]
    bufferOffset = LanePositionAndType.serialize(obj.non_traffic_lane_position, buffer, bufferOffset);
    // Serialize message field [traffic_island_position]
    bufferOffset = TrafficIslandPosition.serialize(obj.traffic_island_position, buffer, bufferOffset);
    // Serialize message field [map_position]
    bufferOffset = MapPosition.serialize(obj.map_position, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GeneralizedLanePosition
    let len;
    let data = new GeneralizedLanePosition(null);
    // Deserialize message field [choice]
    data.choice = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [traffic_lane_position]
    data.traffic_lane_position = LanePosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [non_traffic_lane_position]
    data.non_traffic_lane_position = LanePositionAndType.deserialize(buffer, bufferOffset);
    // Deserialize message field [traffic_island_position]
    data.traffic_island_position = TrafficIslandPosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [map_position]
    data.map_position = MapPosition.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 29;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/GeneralizedLanePosition';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9b4fe5ff1a8871b930596241bcb647b3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates a transversal position in relation to the different lanes of the road. 
    #  * It is an extension of DE_LanePosition to cover locations (sidewalks, bicycle paths), where Vehicle ITS-S would normally not be present. 
    #  *
    #  * The following options are available:
    #  *
    #  * @field trafficLanePosition: a position on a traffic lane. 
    #  * 
    #  * @field nonTrafficLanePosition: a position on a lane which is not a traffic lane.
    #  * 
    #  * @field trafficIslandPosition: a position on a traffic island
    #  * 
    #  * @field mapPosition: a position on a lane identified in a MAPEM.
    #  *  
    #  * @category: Road Topology information
    #  * @revision: created in V2.1.1
    #  */
    # GeneralizedLanePosition::= CHOICE {
    #     trafficLanePosition       LanePosition,
    #     nonTrafficLanePosition    LanePositionAndType,
    #     trafficIslandPosition     TrafficIslandPosition,
    #     mapPosition               MapPosition,
    #     ...
    # }	
    # ------------------------------------------------------------------------------
    
    uint8 choice
    
    LanePosition traffic_lane_position
    uint8 CHOICE_TRAFFIC_LANE_POSITION = 0
    
    LanePositionAndType non_traffic_lane_position
    uint8 CHOICE_NON_TRAFFIC_LANE_POSITION = 1
    
    TrafficIslandPosition traffic_island_position
    uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 2
    
    MapPosition map_position
    uint8 CHOICE_MAP_POSITION = 3
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
    #  *
    #  * For right-hand traffic roads, the value shall be set to:
    #  * - `-1` if the position is off, i.e. besides the road,
    #  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
    #  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
    #  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
    #  *
    #  * For left-hand traffic roads, the value shall be set to:
    #  * - `-1` if the position is off, i.e. besides the road,
    #  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
    #  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
    #  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
    # 
    #  *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
    #  *
    #  * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
    #  * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
    #  * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
    # 
    #  * @category: Road topology information
    #  * @revision: Description revised in V2.1.1
    # */
    # LanePosition ::= INTEGER {
    #     offTheRoad           (-1), 
    #     innerHardShoulder    (0), 
    #     outerHardShoulder    (14) 
    # } (-1..14)
    # ------------------------------------------------------------------------------
    
    int8 value
    int8 MIN = -1
    int8 MAX = 14
    int8 OFF_THE_ROAD = -1
    int8 INNER_HARD_SHOULDER = 0
    int8 OUTER_HARD_SHOULDER = 14
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LanePositionAndType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates a transversal position in resolution of lanes and the associated lane type.
    #  *
    #  * It shall include the following components: 
    #  * 
    #  * @field transversalPosition: the transversal position.
    #  * 
    #  * @field laneType: the type of the lane identified in the component transversalPosition.
    #  * 
    #  * @category Road topology information
    #  * @revision: Created in V2.1.1
    #  */
    # LanePositionAndType::= SEQUENCE {
    #     transversalPosition    LanePosition,
    #     laneType               LaneType,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    
    LanePosition transversal_position
    
    LaneType lane_type
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LaneType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the type of a lane. 
    #  * 
    #  * The value shall be set to:
    #  * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
    #  * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
    #  * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
    #  * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
    #  * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
    #  * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
    #  * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
    #  * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
    #  * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
    #  * - 9	- `taxi`               - Lane dedicated to movement of taxis,
    #  * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
    #  * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
    #  * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
    #  * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
    #  * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
    #                                  separating the two directional carriageways of the highway,
    #  * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
    #  * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
    #  * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
    #  * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
    #  * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
    #                                  the road surface edge and the boundary of a road,
    #  * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre.
    #  * - values 21 to 30             reserved for future use. 
    #  *
    #  * @category: Road topology information
    #  * @revision: Created in V2.1.1
    # */
    # LaneType::= INTEGER{
    # 	traffic              (0),
    # 	through	             (1),
    # 	reversible           (2),
    # 	acceleration         (3),
    # 	deceleration         (4),
    # 	leftHandTurning      (5),
    # 	rightHandTurning     (6),
    # 	dedicatedVehicle     (7),
    # 	bus                  (8),
    # 	taxi                 (9),
    # 	hov                  (10),
    # 	hot                  (11),
    # 	pedestrian           (12),
    # 	cycleLane            (13),
    # 	median               (14),   
    # 	striping             (15),
    # 	trackedVehicle       (16),
    # 	parking	             (17),
    # 	emergency            (18),
    # 	verge                (19),
    # 	minimumRiskManoeuvre (20),
    # 	unknown              (31)
    # }(0..31)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 31
    uint8 TRAFFIC = 0
    uint8 THROUGH = 1
    uint8 REVERSIBLE = 2
    uint8 ACCELERATION = 3
    uint8 DECELERATION = 4
    uint8 LEFT_HAND_TURNING = 5
    uint8 RIGHT_HAND_TURNING = 6
    uint8 DEDICATED_VEHICLE = 7
    uint8 BUS = 8
    uint8 TAXI = 9
    uint8 HOV = 10
    uint8 HOT = 11
    uint8 PEDESTRIAN = 12
    uint8 CYCLE_LANE = 13
    uint8 MEDIAN = 14
    uint8 STRIPING = 15
    uint8 TRACKED_VEHICLE = 16
    uint8 PARKING = 17
    uint8 EMERGENCY = 18
    uint8 VERGE = 19
    uint8 MINIMUM_RISK_MANOEUVRE = 20
    uint8 UNKNOWN = 31
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/TrafficIslandPosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * Ths DF represents the a position on a traffic island between two lanes. 
    #  *
    #  * It shall include the following components: 
    #  *
    #  * @field oneSide: represents one lane.
    #  * 
    #  * @field otherSide: represents the other lane.
    #  * 
    #  * @category: Road Topology information
    #  * @revision: Created in V2.1.1
    #  */
    # TrafficIslandPosition ::= SEQUENCE {
    #     oneSide      LanePositionAndType,
    #     otherSide    LanePositionAndType,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    
    LanePositionAndType one_side
    
    LanePositionAndType other_side
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/MapPosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
    #  *
    #  * It shall include the following components: 
    #  * 
    #  * @field mapReference: optionally identifies the MAPEM containing the topology information.
    #  * It is absent if the MAPEM topology is known from the context.
    #  * 
    #  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
    #  *
    #  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
    #  * conflict area of an intersection which connects e.g an ingress with an egress lane.
    #  *
    #  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
    #  * 
    #  * @category: Road topology information
    #  * @revision: Created in V2.1.1
    #  */
    # MapPosition ::= SEQUENCE {
    #     mapReference                MapReference OPTIONAL,
    #     laneId                      Identifier1B OPTIONAL,
    #     connectionId                Identifier1B OPTIONAL, 
    #     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    
    MapReference map_reference
    bool map_reference_is_present
    
    Identifier1B lane_id
    bool lane_id_is_present
    
    Identifier1B connection_id
    bool connection_id_is_present
    
    LongitudinalLanePosition longitudinal_lane_position
    bool longitudinal_lane_position_is_present
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/MapReference
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
    #  *
    #  * The following options are provided:
    #  * 
    #  * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
    #  * 
    #  * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
    #  *
    #  * @category: Road topology information
    #  * @revision: Created in V2.1.1
    #  */
    # MapReference::= CHOICE {
    # 	roadsegment     RoadSegmentReferenceId,
    # 	intersection    IntersectionReferenceId
    # 	}
    # ------------------------------------------------------------------------------
    
    uint8 choice
    
    RoadSegmentReferenceId roadsegment
    uint8 CHOICE_ROADSEGMENT = 0
    
    IntersectionReferenceId intersection
    uint8 CHOICE_INTERSECTION = 1
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/RoadSegmentReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF represents a unique id for a road segment
    #  *
    #  * It shall include the following components: 
    #  *
    #  * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
    #  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    #  *
    #  * @field id: the identifier of the road segment.
    #  *
    #  * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
    #  * @category: GeoReference information
    #  * @revision: created in V2.1.1
    #  */
    # RoadSegmentReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/Identifier2B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE is a general identifier.
    #  * 
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # Identifier2B ::= INTEGER (0..65535)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/IntersectionReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
    #  *
    #  * It shall include the following components: 
    #  *
    #  * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
    #  * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    #  *
    #  * @field id: the identifier of the intersection
    #  *
    #  * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
    #  * @category: Road topology information
    #  * @revision: created in V2.1.1
    #  */
    # IntersectionReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/Identifier1B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE is a general identifier.
    #  * 
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # Identifier1B ::= INTEGER (0..255)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LongitudinalLanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DF represents the estimated position along the longitudinal length of a particular lane. 
    #  *
    #  * It shall include the following components: 
    #  *
    #  * @field  longitudinalLanePositionValue: the mean value of the longitudinal position within a particular length.
    #  *
    #  * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
    #  *
    #  * @category: Road topology information
    #  * @revision: created in V2.1.1
    #  */
    # LongitudinalLanePosition ::= SEQUENCE {
    #     longitudinalLanePositionValue         LongitudinalLanePositionValue,
    #     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
    # }
    # ------------------------------------------------------------------------------
    
    LongitudinalLanePositionValue longitudinal_lane_position_value
    
    LongitudinalLanePositionConfidence longitudinal_lane_position_confidence
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
    #  * 
    #  * The value shall be set to:
    #  * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
    #  * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
    #  * - `32 767` if the longitudinal offset information is not available. 
    #  *
    #  * @unit 0,1 metre
    #  * @category: GeoReference information
    #  * @revision: Created in V2.1.1
    # */
    # LongitudinalLanePositionValue ::= INTEGER {
    #     outOfRange(32766),
    #     unavailable(32767)
    # }(0..32767)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 32767
    uint16 OUT_OF_RANGE = 32766
    uint16 UNAVAILABLE = 32767
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/LongitudinalLanePositionConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
    #  * If required, the confidence level can be defined by the corresponding standards applying this DE.
    #  *
    #  * The value shall be set to:
    #  * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
    #  * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
    #  * - `1 023` if the confidence value is unavailable.
    #  *
    #  * @unit 0,1 metre
    #  * @category: GeoReference information
    #  * @revision: Created in V2.1.1
    # */
    # LongitudinalLanePositionConfidence ::= INTEGER {
    #     outOfRange  (1022),
    #     unavailable (1023)  
    # } (0..1023)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 1023
    uint16 OUT_OF_RANGE = 1022
    uint16 UNAVAILABLE = 1023
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GeneralizedLanePosition(null);
    if (msg.choice !== undefined) {
      resolved.choice = msg.choice;
    }
    else {
      resolved.choice = 0
    }

    if (msg.traffic_lane_position !== undefined) {
      resolved.traffic_lane_position = LanePosition.Resolve(msg.traffic_lane_position)
    }
    else {
      resolved.traffic_lane_position = new LanePosition()
    }

    if (msg.non_traffic_lane_position !== undefined) {
      resolved.non_traffic_lane_position = LanePositionAndType.Resolve(msg.non_traffic_lane_position)
    }
    else {
      resolved.non_traffic_lane_position = new LanePositionAndType()
    }

    if (msg.traffic_island_position !== undefined) {
      resolved.traffic_island_position = TrafficIslandPosition.Resolve(msg.traffic_island_position)
    }
    else {
      resolved.traffic_island_position = new TrafficIslandPosition()
    }

    if (msg.map_position !== undefined) {
      resolved.map_position = MapPosition.Resolve(msg.map_position)
    }
    else {
      resolved.map_position = new MapPosition()
    }

    return resolved;
    }
};

// Constants for message
GeneralizedLanePosition.Constants = {
  CHOICE_TRAFFIC_LANE_POSITION: 0,
  CHOICE_NON_TRAFFIC_LANE_POSITION: 1,
  CHOICE_TRAFFIC_ISLAND_POSITION: 2,
  CHOICE_MAP_POSITION: 3,
}

module.exports = GeneralizedLanePosition;
