// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class LaneType {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LaneType
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LaneType
    let len;
    let data = new LaneType(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/LaneType';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c492684564e374e0613d34673a80316b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the type of a lane. 
    #  * 
    #  * The value shall be set to:
    #  * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
    #  * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
    #  * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
    #  * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
    #  * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
    #  * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
    #  * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
    #  * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
    #  * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
    #  * - 9	- `taxi`               - Lane dedicated to movement of taxis,
    #  * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
    #  * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
    #  * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
    #  * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
    #  * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
    #                                  separating the two directional carriageways of the highway,
    #  * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
    #  * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
    #  * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
    #  * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
    #  * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
    #                                  the road surface edge and the boundary of a road,
    #  * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre.
    #  * - values 21 to 30             reserved for future use. 
    #  *
    #  * @category: Road topology information
    #  * @revision: Created in V2.1.1
    # */
    # LaneType::= INTEGER{
    # 	traffic              (0),
    # 	through	             (1),
    # 	reversible           (2),
    # 	acceleration         (3),
    # 	deceleration         (4),
    # 	leftHandTurning      (5),
    # 	rightHandTurning     (6),
    # 	dedicatedVehicle     (7),
    # 	bus                  (8),
    # 	taxi                 (9),
    # 	hov                  (10),
    # 	hot                  (11),
    # 	pedestrian           (12),
    # 	cycleLane            (13),
    # 	median               (14),   
    # 	striping             (15),
    # 	trackedVehicle       (16),
    # 	parking	             (17),
    # 	emergency            (18),
    # 	verge                (19),
    # 	minimumRiskManoeuvre (20),
    # 	unknown              (31)
    # }(0..31)
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 31
    uint8 TRAFFIC = 0
    uint8 THROUGH = 1
    uint8 REVERSIBLE = 2
    uint8 ACCELERATION = 3
    uint8 DECELERATION = 4
    uint8 LEFT_HAND_TURNING = 5
    uint8 RIGHT_HAND_TURNING = 6
    uint8 DEDICATED_VEHICLE = 7
    uint8 BUS = 8
    uint8 TAXI = 9
    uint8 HOV = 10
    uint8 HOT = 11
    uint8 PEDESTRIAN = 12
    uint8 CYCLE_LANE = 13
    uint8 MEDIAN = 14
    uint8 STRIPING = 15
    uint8 TRACKED_VEHICLE = 16
    uint8 PARKING = 17
    uint8 EMERGENCY = 18
    uint8 VERGE = 19
    uint8 MINIMUM_RISK_MANOEUVRE = 20
    uint8 UNKNOWN = 31
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LaneType(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
LaneType.Constants = {
  MIN: 0,
  MAX: 31,
  TRAFFIC: 0,
  THROUGH: 1,
  REVERSIBLE: 2,
  ACCELERATION: 3,
  DECELERATION: 4,
  LEFT_HAND_TURNING: 5,
  RIGHT_HAND_TURNING: 6,
  DEDICATED_VEHICLE: 7,
  BUS: 8,
  TAXI: 9,
  HOV: 10,
  HOT: 11,
  PEDESTRIAN: 12,
  CYCLE_LANE: 13,
  MEDIAN: 14,
  STRIPING: 15,
  TRACKED_VEHICLE: 16,
  PARKING: 17,
  EMERGENCY: 18,
  VERGE: 19,
  MINIMUM_RISK_MANOEUVRE: 20,
  UNKNOWN: 31,
}

module.exports = LaneType;
