// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class LongitudinalAccelerationValue {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LongitudinalAccelerationValue
    // Serialize message field [value]
    bufferOffset = _serializer.int16(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LongitudinalAccelerationValue
    let len;
    let data = new LongitudinalAccelerationValue(null);
    // Deserialize message field [value]
    data.value = _deserializer.int16(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/LongitudinalAccelerationValue';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1f4802021e901886b6068cce53ff978d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    #  /**
    #  * This DE represents the vehicle acceleration at longitudinal direction in the centre of the mass of the empty vehicle.
    #  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
    #  *
    #  * The value shall be set to:
    #  * - `-160` for acceleration values equal to or less than -16 m/s^2,
    #  * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is braking with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2
    #  * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
    #  * - `160` for acceleration values greater than 15,9 m/s^2,
    #  * - `161` when the data is unavailable. 
    #  * 
    #  * This acceleration is along the tangent plane of the road surface and does not include gravity components.
    #  * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.
    #  * 
    #  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
    #  * @unit: 0,1 m/s^2
    #  * @category: Vehicle information
    #  * @revision: description revised in V2.1.1 (the meaning of 160 has changed slightly). T
    #  */
    # LongitudinalAccelerationValue::= INTEGER {
    #     negativeOutOfRange (-160),
    #     positiveOutOfRange (160),
    #     unavailable        (161)  
    # } (-160 .. 161)
    # ------------------------------------------------------------------------------
    
    int16 value
    int16 MIN = -160
    int16 MAX = 161
    int16 NEGATIVE_OUT_OF_RANGE = -160
    int16 POSITIVE_OUT_OF_RANGE = 160
    int16 UNAVAILABLE = 161
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LongitudinalAccelerationValue(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
LongitudinalAccelerationValue.Constants = {
  MIN: -160,
  MAX: 161,
  NEGATIVE_OUT_OF_RANGE: -160,
  POSITIVE_OUT_OF_RANGE: 160,
  UNAVAILABLE: 161,
}

module.exports = LongitudinalAccelerationValue;
