// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SemiAxisLength = require('./SemiAxisLength.js');
let Wgs84AngleValue = require('./Wgs84AngleValue.js');

//-----------------------------------------------------------

class PositionConfidenceEllipse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.semi_major_axis_length = null;
      this.semi_minor_axis_length = null;
      this.semi_major_axis_orientation = null;
    }
    else {
      if (initObj.hasOwnProperty('semi_major_axis_length')) {
        this.semi_major_axis_length = initObj.semi_major_axis_length
      }
      else {
        this.semi_major_axis_length = new SemiAxisLength();
      }
      if (initObj.hasOwnProperty('semi_minor_axis_length')) {
        this.semi_minor_axis_length = initObj.semi_minor_axis_length
      }
      else {
        this.semi_minor_axis_length = new SemiAxisLength();
      }
      if (initObj.hasOwnProperty('semi_major_axis_orientation')) {
        this.semi_major_axis_orientation = initObj.semi_major_axis_orientation
      }
      else {
        this.semi_major_axis_orientation = new Wgs84AngleValue();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PositionConfidenceEllipse
    // Serialize message field [semi_major_axis_length]
    bufferOffset = SemiAxisLength.serialize(obj.semi_major_axis_length, buffer, bufferOffset);
    // Serialize message field [semi_minor_axis_length]
    bufferOffset = SemiAxisLength.serialize(obj.semi_minor_axis_length, buffer, bufferOffset);
    // Serialize message field [semi_major_axis_orientation]
    bufferOffset = Wgs84AngleValue.serialize(obj.semi_major_axis_orientation, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PositionConfidenceEllipse
    let len;
    let data = new PositionConfidenceEllipse(null);
    // Deserialize message field [semi_major_axis_length]
    data.semi_major_axis_length = SemiAxisLength.deserialize(buffer, bufferOffset);
    // Deserialize message field [semi_minor_axis_length]
    data.semi_minor_axis_length = SemiAxisLength.deserialize(buffer, bufferOffset);
    // Deserialize message field [semi_major_axis_orientation]
    data.semi_major_axis_orientation = Wgs84AngleValue.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 6;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/PositionConfidenceEllipse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd35633e20701a856e25b3dda8856d1f8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
    #  * confidence level of 95 %. The centre of the ellipse shape corresponds to the reference
    #  * position point for which the position accuracy is evaluated.
    #  *
    #  * It shall include the following components: 
    #  *
    #  * @field semiMajorAxisLength: half of length of the major axis, i.e. distance between the centre point
    #  * and major axis point of the position accuracy ellipse. 
    #  *
    #  * @field semiMinorAxisLength: half of length of the minor axis, i.e. distance between the centre point
    #  * and minor axis point of the position accuracy ellipse. 
    #  *
    #  * @field semiMajorAxisOrientation: orientation direction of the ellipse major axis of the position accuracy
    #  * ellipse with regards to the WGS84 north. 
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  *
    #  * @category GeoReference information
    #  * @revision: created in V2.1.1 based on @ref PosConfidenceEllipse
    #  */
    # PositionConfidenceEllipse ::= SEQUENCE {
    #     semiMajorAxisLength         SemiAxisLength,
    #     semiMinorAxisLength         SemiAxisLength,
    #     semiMajorAxisOrientation    Wgs84AngleValue
    # }
    # ------------------------------------------------------------------------------
    
    SemiAxisLength semi_major_axis_length
    
    SemiAxisLength semi_minor_axis_length
    
    Wgs84AngleValue semi_major_axis_orientation
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/SemiAxisLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the horizontal position confidence value which represents the estimated absolute position accuracy, in one of the axis direction as defined in a shape of ellipse with a 
    #  * confidence level of 95 %. 
    #  * 
    #  * The value shall be set to:
    #  * - `n` (`n > 0` and `n < 4 094`) if the accuracy is equal to or less than n * 0,01 metre,
    #  * - `4 094` if the accuracy is out of range, i.e. greater than 4,093 m,
    #  * - `4 095` if the accuracy information is unavailable.
    #  *
    #  * The value 0 shall not be used.
    #  * 
    #  * @note: The fact that a position coordinate value is received with confidence value set to `unavailable(4095)`.
    #  * can be caused by several reasons, such as:
    #  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    #  * - the sensor cannot calculate the accuracy due to lack of variables, or
    #  * - there has been a vehicle bus (e.g. CAN bus) error.
    #  * In all 3 cases above, the position coordinate value may be valid and used by the application.
    #  * If a position coordinate value is received and its confidence value is set to `outOfRange(4094)`, it means that
    #  * the position coordinate value is not valid and therefore cannot be trusted. Such value is not useful
    #  * for the application.
    # 
    #  * @unit 0,01 metre 
    #  * @category: GeoReference Information
    #  * @revision: Description revised in V2.1.1
    #  */
    # SemiAxisLength ::= INTEGER{
    #     doNotUse    (0),
    #     outOfRange  (4094), 
    #     unavailable (4095)
    # } (0..4095)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 4095
    uint16 DO_NOT_USE = 0
    uint16 OUT_OF_RANGE = 4094
    uint16 UNAVAILABLE = 4095
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/Wgs84AngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE represents an angle value in degrees described in the WGS84 reference system with respect to the WGS84 north.
    #  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    #  * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    #  *
    #  * @unit 0,1 degrees
    #  * @category: GeoReference Information
    #  * @revision: Created in V2.1.1
    # */
    # Wgs84AngleValue ::= INTEGER { 
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PositionConfidenceEllipse(null);
    if (msg.semi_major_axis_length !== undefined) {
      resolved.semi_major_axis_length = SemiAxisLength.Resolve(msg.semi_major_axis_length)
    }
    else {
      resolved.semi_major_axis_length = new SemiAxisLength()
    }

    if (msg.semi_minor_axis_length !== undefined) {
      resolved.semi_minor_axis_length = SemiAxisLength.Resolve(msg.semi_minor_axis_length)
    }
    else {
      resolved.semi_minor_axis_length = new SemiAxisLength()
    }

    if (msg.semi_major_axis_orientation !== undefined) {
      resolved.semi_major_axis_orientation = Wgs84AngleValue.Resolve(msg.semi_major_axis_orientation)
    }
    else {
      resolved.semi_major_axis_orientation = new Wgs84AngleValue()
    }

    return resolved;
    }
};

module.exports = PositionConfidenceEllipse;
