// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let StationId = require('./StationId.js');
let SafeDistanceIndicator = require('./SafeDistanceIndicator.js');
let DeltaTimeTenthOfSecond = require('./DeltaTimeTenthOfSecond.js');

//-----------------------------------------------------------

class SafeDistanceIndication {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.subject_station = null;
      this.subject_station_is_present = null;
      this.safe_distance_indicator = null;
      this.time_to_collision = null;
      this.time_to_collision_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('subject_station')) {
        this.subject_station = initObj.subject_station
      }
      else {
        this.subject_station = new StationId();
      }
      if (initObj.hasOwnProperty('subject_station_is_present')) {
        this.subject_station_is_present = initObj.subject_station_is_present
      }
      else {
        this.subject_station_is_present = false;
      }
      if (initObj.hasOwnProperty('safe_distance_indicator')) {
        this.safe_distance_indicator = initObj.safe_distance_indicator
      }
      else {
        this.safe_distance_indicator = new SafeDistanceIndicator();
      }
      if (initObj.hasOwnProperty('time_to_collision')) {
        this.time_to_collision = initObj.time_to_collision
      }
      else {
        this.time_to_collision = new DeltaTimeTenthOfSecond();
      }
      if (initObj.hasOwnProperty('time_to_collision_is_present')) {
        this.time_to_collision_is_present = initObj.time_to_collision_is_present
      }
      else {
        this.time_to_collision_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SafeDistanceIndication
    // Serialize message field [subject_station]
    bufferOffset = StationId.serialize(obj.subject_station, buffer, bufferOffset);
    // Serialize message field [subject_station_is_present]
    bufferOffset = _serializer.bool(obj.subject_station_is_present, buffer, bufferOffset);
    // Serialize message field [safe_distance_indicator]
    bufferOffset = SafeDistanceIndicator.serialize(obj.safe_distance_indicator, buffer, bufferOffset);
    // Serialize message field [time_to_collision]
    bufferOffset = DeltaTimeTenthOfSecond.serialize(obj.time_to_collision, buffer, bufferOffset);
    // Serialize message field [time_to_collision_is_present]
    bufferOffset = _serializer.bool(obj.time_to_collision_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SafeDistanceIndication
    let len;
    let data = new SafeDistanceIndication(null);
    // Deserialize message field [subject_station]
    data.subject_station = StationId.deserialize(buffer, bufferOffset);
    // Deserialize message field [subject_station_is_present]
    data.subject_station_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [safe_distance_indicator]
    data.safe_distance_indicator = SafeDistanceIndicator.deserialize(buffer, bufferOffset);
    // Deserialize message field [time_to_collision]
    data.time_to_collision = DeltaTimeTenthOfSecond.deserialize(buffer, bufferOffset);
    // Deserialize message field [time_to_collision_is_present]
    data.time_to_collision_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/SafeDistanceIndication';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3a0fb8f493fb4bb2d7552ecd1960483e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF provides the safe distance indication of a traffic participant with other traffic participant(s).
    #  *
    #  * It shall include the following components: 
    #  * 
    #  * @field subjectStation: optionally indicates one "other" traffic participant identified by its ITS-S.
    #  *  
    #  * @field safeDistanceIndicator: indicates whether the distance between the ego ITS-S and the traffic participant(s) is safe.
    #  * If subjectStation is present then it indicates whether the distance between the ego ITS-S and the traffic participant indicated in the component subjectStation is safe. 
    #  *
    #  * @field timeToCollision: optionally indicated the time-to-collision calculated as sqrt(LaDi^2 + LoDi^2 + VDi^2/relative speed 
    #  * and represented in  the  nearest 100  ms. This component may be present only if subjectStation is present. 
    #  *
    #  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
    #  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
    #  *
    #  * @category: Traffic information, Kinematic information
    #  * @revision: created in V2.1.1
    #  */
    # SafeDistanceIndication ::= SEQUENCE {
    #     subjectStation           StationId OPTIONAL,
    #     safeDistanceIndicator    SafeDistanceIndicator,
    #     timeToCollision          DeltaTimeTenthOfSecond OPTIONAL,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    
    StationId subject_station
    bool subject_station_is_present
    
    SafeDistanceIndicator safe_distance_indicator
    
    DeltaTimeTenthOfSecond time_to_collision
    bool time_to_collision_is_present
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/StationId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the identifier of an ITS-S.
    #  * The ITS-S ID may be a pseudonym. It may change over space and/or over time.
    #  *
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1 based on @ref StationID
    #  */
    # StationId ::= INTEGER(0..4294967295)
    # ------------------------------------------------------------------------------
    
    uint32 value
    uint32 MIN = 0
    uint32 MAX = 4294967295
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/SafeDistanceIndicator
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates if a distance is safe. 
    #  *
    #  * The value shall be set to:
    #  * -  `FALSE`  if  the triple  {LaD,  LoD, VD} < {MSLaD, MSLoD, MSVD} is simultaneously  satisfied with confidence level of  90 % or  more, 
    #  * -  `TRUE` otherwise. 
    #  *
    #  * @note: the abbreviations used are Lateral Distance (LaD),  Longitudinal Distance (LoD) and Vertical Distance (VD) 
    #  * and their respective  thresholds, Minimum  Safe  Lateral  Distance (MSLaD), Minimum  Safe  Longitudinal Distance  (MSLoD),  and  Minimum  Safe Vertical Distance (MSVD).
    #  *
    #  * @category: Traffic information, Kinematic information
    #  * @revision: created in V2.1.1
    # */
    # SafeDistanceIndicator::= BOOLEAN
    # ------------------------------------------------------------------------------
    
    bool value
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE represents a difference in time with respect to a reference time.
    #  *
    #  * The value shall be set to:
    #  * - `0` for a difference in time of 0 seconds. 
    #  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
    #  *
    #  * @unit: 0,1 s
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # DeltaTimeTenthOfSecond::= INTEGER {
    #     unavailable (127)  
    # } (0..127) 
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 127
    uint8 UNAVAILABLE = 127
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SafeDistanceIndication(null);
    if (msg.subject_station !== undefined) {
      resolved.subject_station = StationId.Resolve(msg.subject_station)
    }
    else {
      resolved.subject_station = new StationId()
    }

    if (msg.subject_station_is_present !== undefined) {
      resolved.subject_station_is_present = msg.subject_station_is_present;
    }
    else {
      resolved.subject_station_is_present = false
    }

    if (msg.safe_distance_indicator !== undefined) {
      resolved.safe_distance_indicator = SafeDistanceIndicator.Resolve(msg.safe_distance_indicator)
    }
    else {
      resolved.safe_distance_indicator = new SafeDistanceIndicator()
    }

    if (msg.time_to_collision !== undefined) {
      resolved.time_to_collision = DeltaTimeTenthOfSecond.Resolve(msg.time_to_collision)
    }
    else {
      resolved.time_to_collision = new DeltaTimeTenthOfSecond()
    }

    if (msg.time_to_collision_is_present !== undefined) {
      resolved.time_to_collision_is_present = msg.time_to_collision_is_present;
    }
    else {
      resolved.time_to_collision_is_present = false
    }

    return resolved;
    }
};

module.exports = SafeDistanceIndication;
