// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let StabilityLossProbability = require('./StabilityLossProbability.js');
let DeltaTimeTenthOfSecond = require('./DeltaTimeTenthOfSecond.js');

//-----------------------------------------------------------

class StabilityChangeIndication {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.loss_probability = null;
      this.action_delta_time = null;
    }
    else {
      if (initObj.hasOwnProperty('loss_probability')) {
        this.loss_probability = initObj.loss_probability
      }
      else {
        this.loss_probability = new StabilityLossProbability();
      }
      if (initObj.hasOwnProperty('action_delta_time')) {
        this.action_delta_time = initObj.action_delta_time
      }
      else {
        this.action_delta_time = new DeltaTimeTenthOfSecond();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type StabilityChangeIndication
    // Serialize message field [loss_probability]
    bufferOffset = StabilityLossProbability.serialize(obj.loss_probability, buffer, bufferOffset);
    // Serialize message field [action_delta_time]
    bufferOffset = DeltaTimeTenthOfSecond.serialize(obj.action_delta_time, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type StabilityChangeIndication
    let len;
    let data = new StabilityChangeIndication(null);
    // Deserialize message field [loss_probability]
    data.loss_probability = StabilityLossProbability.deserialize(buffer, bufferOffset);
    // Deserialize message field [action_delta_time]
    data.action_delta_time = DeltaTimeTenthOfSecond.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/StabilityChangeIndication';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd2e0a0447428a3f42ba04af0feb2312c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF  provides the  indication of  change in stability.
    #  *
    #  * It shall include the following components: 
    #  * 
    #  * @field lossProbability: the probability of stability loss. 
    #  * 
    #  * @field actionDeltaTime: the period over which the the probability of stability loss is estimated. 
    #  *
    #  * @category: Kinematic information
    #  * @revision: V2.1.1
    #  */
    # StabilityChangeIndication ::= SEQUENCE {
    #     lossProbability     StabilityLossProbability,
    #     actionDeltaTime     DeltaTimeTenthOfSecond,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    
    StabilityLossProbability loss_probability
    
    DeltaTimeTenthOfSecond action_delta_time
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/StabilityLossProbability
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the estimated probability of a stability level and conversely also the probability of a stability loss.
    #  *
    #  * The value shall be set to:
    #  * - `0` to indicate an estimated probability of a loss of stability of 0 %, i.e. "stable", 
    #  * - `n` (`n > 0` and `n < 50`) to indicate the actual stability level,
    #  * - `50` to indicate a estimated probability of a loss of stability of 100 %, i.e. "total loss of stability",
    #  * - the values between 51 and 62 are reserved for future use,
    #  * - `63`: this value indicates that the information is unavailable.
    #  *
    #  * @unit: 2 %
    #  * @category: Kinematic information
    #  * @revision: Created in V2.1.1
    #  */
    # StabilityLossProbability ::= INTEGER {
    #     stable                  (0), 
    #     totalLossOfStability   (50), 
    #     unavailable            (63) 
    # } (0..63) 
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 63
    uint8 STABLE = 0
    uint8 TOTAL_LOSS_OF_STABILITY = 50
    uint8 UNAVAILABLE = 63
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/DeltaTimeTenthOfSecond
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /** 
    #  * This DE represents a difference in time with respect to a reference time.
    #  *
    #  * The value shall be set to:
    #  * - `0` for a difference in time of 0 seconds. 
    #  * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
    #  *
    #  * @unit: 0,1 s
    #  * @category: Basic information
    #  * @revision: Created in V2.1.1
    # */
    # DeltaTimeTenthOfSecond::= INTEGER {
    #     unavailable (127)  
    # } (0..127) 
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 127
    uint8 UNAVAILABLE = 127
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new StabilityChangeIndication(null);
    if (msg.loss_probability !== undefined) {
      resolved.loss_probability = StabilityLossProbability.Resolve(msg.loss_probability)
    }
    else {
      resolved.loss_probability = new StabilityLossProbability()
    }

    if (msg.action_delta_time !== undefined) {
      resolved.action_delta_time = DeltaTimeTenthOfSecond.Resolve(msg.action_delta_time)
    }
    else {
      resolved.action_delta_time = new DeltaTimeTenthOfSecond()
    }

    return resolved;
    }
};

module.exports = StabilityChangeIndication;
