// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class VruDeviceUsage {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VruDeviceUsage
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VruDeviceUsage
    let len;
    let data = new VruDeviceUsage(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/VruDeviceUsage';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '42c5549e58d5cc36da7a46a1ef04b5a0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the possible usage conditions of the VRU device.
    # 
    #  * - The value shall be set to:
    #  * - 0 `unavailable`      - to indicate that the usage conditions are unavailable,
    #  * - 1 `other`            - to indicate that the VRU device is in a state not defined below,
    #  * - 2 `idle`             - to indicate that the human is currently not interacting with the device,
    #  * - 3 `listeningToAudio` - to indicate that any audio source other than calling is in use,
    #  * - 4 `typing`           - to indicate that the human is texting or performaing any other manual input activity,
    #  * - 5 `calling`          - to indicate that the VRU device is currently receiving a call,
    #  * - 6 `playingGames`     - to indicate that the human is playing games,
    #  * - 7 `reading`          - to indicate that the human is reading on the VRU device,
    #  * - 8 `viewing`          - to indicate that the human is watching dynamic content, including following navigation prompts, viewing videos or other visual contents that are not static.
    #  * - value 9 to 255       - are reserved for future usage. Value 255 set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruDeviceUsage ::= ENUMERATED {
    #     unavailable      (0), 
    #     other            (1), 
    #     idle             (2), 
    #     listeningToAudio (3), 
    #     typing           (4), 
    #     calling          (5), 
    #     playingGames     (6), 
    #     reading          (7), 
    #     viewing          (8), 
    #     max              (255)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 OTHER = 1
    uint8 IDLE = 2
    uint8 LISTENING_TO_AUDIO = 3
    uint8 TYPING = 4
    uint8 CALLING = 5
    uint8 PLAYING_GAMES = 6
    uint8 READING = 7
    uint8 VIEWING = 8
    uint8 MAX = 255
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VruDeviceUsage(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
VruDeviceUsage.Constants = {
  UNAVAILABLE: 0,
  OTHER: 1,
  IDLE: 2,
  LISTENING_TO_AUDIO: 3,
  TYPING: 4,
  CALLING: 5,
  PLAYING_GAMES: 6,
  READING: 7,
  VIEWING: 8,
  MAX: 255,
}

module.exports = VruDeviceUsage;
