// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class VruEnvironment {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VruEnvironment
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VruEnvironment
    let len;
    let data = new VruEnvironment(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/VruEnvironment';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2f81d09462c40c2854f5083ff0a36878';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the possible VRU environment conditions.
    #  *
    #  * - The value shall be set to:
    #  * - 0 `unavailable`            - to indicate that the information on the type of environment is unavailable,
    #  * - 1 `intersectionCrossing`   - to indicate that the VRU is on an intersection or crossing,
    #  * - 2 `zebraCrossing`          - to indicate that the VRU is on a  zebra crossing (crosswalk),
    #  * - 3 `sidewalk`               - to indicate that the VRU is on a sidewalk,
    #  * - 4 `onVehicleRoad`          - to indicate that the VRU is on a traffic lane,
    #  * - 5 `protectedGeographicArea`- to indicate that the VRU is in a protected area.
    #  * - value 5 to 255             - are reserved for future usage. Value 255 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruEnvironment ::= ENUMERATED {
    #     unavailable             (0), 
    #     intersectionCrossing    (1), 
    #     zebraCrossing           (2), 
    #     sidewalk                (3), 
    #     onVehicleRoad           (4), 
    #     protectedGeographicArea (5), 
    #     max                     (255)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 INTERSECTION_CROSSING = 1
    uint8 ZEBRA_CROSSING = 2
    uint8 SIDEWALK = 3
    uint8 ON_VEHICLE_ROAD = 4
    uint8 PROTECTED_GEOGRAPHIC_AREA = 5
    uint8 MAX = 255
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VruEnvironment(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
VruEnvironment.Constants = {
  UNAVAILABLE: 0,
  INTERSECTION_CROSSING: 1,
  ZEBRA_CROSSING: 2,
  SIDEWALK: 3,
  ON_VEHICLE_ROAD: 4,
  PROTECTED_GEOGRAPHIC_AREA: 5,
  MAX: 255,
}

module.exports = VruEnvironment;
