// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let VruProfileAndSubprofile = require('./VruProfileAndSubprofile.js');
let VruSizeClass = require('./VruSizeClass.js');
let VruExteriorLights = require('./VruExteriorLights.js');

//-----------------------------------------------------------

class VruLowFrequencyContainer {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.profile_and_subprofile = null;
      this.size_class = null;
      this.size_class_is_present = null;
      this.exterior_lights = null;
      this.exterior_lights_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('profile_and_subprofile')) {
        this.profile_and_subprofile = initObj.profile_and_subprofile
      }
      else {
        this.profile_and_subprofile = new VruProfileAndSubprofile();
      }
      if (initObj.hasOwnProperty('size_class')) {
        this.size_class = initObj.size_class
      }
      else {
        this.size_class = new VruSizeClass();
      }
      if (initObj.hasOwnProperty('size_class_is_present')) {
        this.size_class_is_present = initObj.size_class_is_present
      }
      else {
        this.size_class_is_present = false;
      }
      if (initObj.hasOwnProperty('exterior_lights')) {
        this.exterior_lights = initObj.exterior_lights
      }
      else {
        this.exterior_lights = new VruExteriorLights();
      }
      if (initObj.hasOwnProperty('exterior_lights_is_present')) {
        this.exterior_lights_is_present = initObj.exterior_lights_is_present
      }
      else {
        this.exterior_lights_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type VruLowFrequencyContainer
    // Serialize message field [profile_and_subprofile]
    bufferOffset = VruProfileAndSubprofile.serialize(obj.profile_and_subprofile, buffer, bufferOffset);
    // Serialize message field [size_class]
    bufferOffset = VruSizeClass.serialize(obj.size_class, buffer, bufferOffset);
    // Serialize message field [size_class_is_present]
    bufferOffset = _serializer.bool(obj.size_class_is_present, buffer, bufferOffset);
    // Serialize message field [exterior_lights]
    bufferOffset = VruExteriorLights.serialize(obj.exterior_lights, buffer, bufferOffset);
    // Serialize message field [exterior_lights_is_present]
    bufferOffset = _serializer.bool(obj.exterior_lights_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type VruLowFrequencyContainer
    let len;
    let data = new VruLowFrequencyContainer(null);
    // Deserialize message field [profile_and_subprofile]
    data.profile_and_subprofile = VruProfileAndSubprofile.deserialize(buffer, bufferOffset);
    // Deserialize message field [size_class]
    data.size_class = VruSizeClass.deserialize(buffer, bufferOffset);
    // Deserialize message field [size_class_is_present]
    data.size_class_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [exterior_lights]
    data.exterior_lights = VruExteriorLights.deserialize(buffer, bufferOffset);
    // Deserialize message field [exterior_lights_is_present]
    data.exterior_lights_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += VruExteriorLights.getMessageSize(object.exterior_lights);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/VruLowFrequencyContainer';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9e15d098edbcc645e345818e6ee07813';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * @details VruLowFrequencyContainer
    #  * The VRU LF container of the VAM contains potentially slow-changing information of the VRU ITS-S.
    #  * It is mandatory with higher periodicity as specified in clause 6.2 or when VRU cluster operation container is present.
    #  * It includes the following components (setting indications are specified in clause 7.3.4 of TS 103 300-3): 
    #  *
    #  * @field profileAndSubprofile: profile of the ITS-S that originates the VAM, including sub-profile information. 
    #  * @field sizeClass: information about the size of the VRU. 
    #  * @field exteriorLights: status of the most important exterior lights switches of the VRU ITS-S that originates the VAM. 
    #  *        _(conditional mandatory as specified in clause 7.3.4 of TS 103 300-3)_ 
    #  * 
    #  * @category: VRU information
    #  * @revision: V2.2.1
    #  */
    #     VruLowFrequencyContainer ::= SEQUENCE {
    #         profileAndSubprofile     VruProfileAndSubprofile,
    #         sizeClass                VruSizeClass OPTIONAL,        
    # 		exteriorLights           VruExteriorLights OPTIONAL,
    #        ...
    #     }
    # ------------------------------------------------------------------------------
    
    VruProfileAndSubprofile profile_and_subprofile
    
    VruSizeClass size_class
    bool size_class_is_present
    
    VruExteriorLights exterior_lights
    bool exterior_lights_is_present
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruProfileAndSubprofile
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF indicates the profile of a VRU including sub-profile information
    #  * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2 [18]:
    #  *
    #  * @field pedestrian: VRU Profile 1 - Pedestrian.
    #  *
    #  * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
    #  *
    #  * @field motorcyclist: VRU Profile 3  - Motorcyclist.
    #  *
    #  * @field animal: VRU Profile  4 -  Animal.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruProfileAndSubprofile ::= CHOICE {
    #    pedestrian                     VruSubProfilePedestrian,
    #    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
    #    motorcyclist                   VruSubProfileMotorcyclist,
    #    animal                         VruSubProfileAnimal,
    #    ...
    # }
    # ------------------------------------------------------------------------------
    
    uint8 choice
    
    VruSubProfilePedestrian pedestrian
    uint8 CHOICE_PEDESTRIAN = 0
    
    VruSubProfileBicyclist bicyclist_and_light_vru_vehicle
    uint8 CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1
    
    VruSubProfileMotorcyclist motorcyclist
    uint8 CHOICE_MOTORCYCLIST = 2
    
    VruSubProfileAnimal animal
    uint8 CHOICE_ANIMAL = 3
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSubProfilePedestrian
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the profile of a pedestrian.
    #  * 
    #  * The value shall be set to:
    #  * - 0 `unavailable`             - to indicate that the information on is unavailable,
    #  * - 1 `ordinary-pedestrian`     - to indicate a pedestrian to which no more-specific profile applies,
    #  * - 2 `road-worker`             - to indicate a pedestrian with the role of a road worker,
    #  * - 3 `first-responder`         - to indicate a pedestrian with the role of a first responder.
    #  * - value 4 to 15               - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruSubProfilePedestrian ::= ENUMERATED {
    #     unavailable         (0), 
    #     ordinary-pedestrian (1),
    #     road-worker         (2), 
    #     first-responder     (3),
    #     max                 (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 ORDINARY_PEDESTRIAN = 1
    uint8 ROAD_WORKER = 2
    uint8 FIRST_RESPONDER = 3
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSubProfileBicyclist
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. 
    #  *
    #  * The value shall be set to:
    #  * - 0 `unavailable`           - to indicate that the information  is unavailable,
    #  * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
    #  * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
    #  * - 3 `horse-and-rider`       - to indicate a horse and rider,
    #  * - 4 `rollerskater`          - to indicate a rolleskater and skater,
    #  * - 5 `e-scooter`             - to indicate an e-scooter and rider,
    #  * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
    #  * - 7 `pedelec`               - to indicate a pedelec and rider,
    #  * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
    #  * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruSubProfileBicyclist ::= ENUMERATED {
    #     unavailable          (0), 
    #     bicyclist            (1), 
    #     wheelchair-user      (2), 
    #     horse-and-rider      (3), 
    #     rollerskater         (4), 
    #     e-scooter            (5), 
    #     personal-transporter (6),
    #     pedelec              (7), 
    #     speed-pedelec        (8),
    #     max                  (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 BICYCLIST = 1
    uint8 WHEELCHAIR_USER = 2
    uint8 HORSE_AND_RIDER = 3
    uint8 ROLLERSKATER = 4
    uint8 E_SCOOTER = 5
    uint8 PERSONAL_TRANSPORTER = 6
    uint8 PEDELEC = 7
    uint8 SPEED_PEDELEC = 8
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSubProfileMotorcyclist
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the profile of a motorcyclist and corresponding vehicle.
    #  * 
    #  * The value shall be set to:
    #  * - 0 `unavailable `                  - to indicate that the information  is unavailable,
    #  * - 1 `moped`                         - to indicate a moped and rider,
    #  * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
    #  * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
    #  * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
    #  * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruSubProfileMotorcyclist ::= ENUMERATED { 
    #     unavailable                  (0), 
    #     moped                        (1), 
    #     motorcycle                   (2), 
    #     motorcycle-and-sidecar-right (3), 
    #     motorcycle-and-sidecar-left  (4), 
    #     max                          (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 MOPED = 1
    uint8 MOTORCYCLE = 2
    uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3
    uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSubProfileAnimal
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the profile of an animal
    #  * 
    #  * The value shall be set to:
    #  * - 0 `unavailable`     - to indicate that the information  is unavailable,
    #  * - 1 `wild-animal`     - to indicate a animal living in the wildness, 
    #  * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
    #  * - 3 `service-animal`  - to indicate an animal that supports a human being.
    #  * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruSubProfileAnimal ::= ENUMERATED {
    #     unavailable    (0), 
    #     wild-animal    (1), 
    #     farm-animal    (2), 
    #     service-animal (3),   
    #     max            (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 WILD_ANIMAL = 1
    uint8 FARM_ANIMAL = 2
    uint8 SERVICE_ANIMAL = 3
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSizeClass
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE indicates the approximate size of a VRU including the VRU vehicle used.
    #  * 
    #  * The value shall be set to:
    #  * - 0 `unavailable`    - to indicate that there is no matched size class or due to privacy reasons in profile 1, 
    #  * - 1 `low`            - to indicate that the VRU size class is low depending on the VRU profile,
    #  * - 2 `medium`         - to indicate that the VRU size class is medium depending on the VRU profile,
    #  * - 3 `high`           - to indicate that the VRU size class is high depending on the VRU profile.
    #  * - 4 to 15            - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */
    # VruSizeClass ::= ENUMERATED { 
    #     unavailable (0), 
    #     low         (1), 
    #     medium      (2), 
    #     high        (3), 
    #     max         (15)
    # }
    # ------------------------------------------------------------------------------
    
    uint8 value
    uint8 UNAVAILABLE = 0
    uint8 LOW = 1
    uint8 MEDIUM = 2
    uint8 HIGH = 3
    uint8 MAX = 15
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruExteriorLights
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DF represents the status of the exterior light switches of a VRU.
    #  * This DF is an extension of the vehicular DE @ref ExteriorLights.
    #  *
    #  * It shall include the following components: 
    #  * 
    #  * @field vehicular:  represents the status of the exterior light switches of a road vehicle.
    #  * 
    #  * @field vruSpecific: represents the status of the exterior light switches of a VRU.
    #  *
    #  * @category: VRU information
    #  * @revision: created in V2.1.1
    #  */
    # VruExteriorLights ::= SEQUENCE {
    #    vehicular      ExteriorLights, 
    #    vruSpecific    VruSpecificExteriorLights,
    #    ...
    # }
    # ------------------------------------------------------------------------------
    
    ExteriorLights vehicular
    
    VruSpecificExteriorLights vru_specific
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/ExteriorLights
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
    #  *
    #  * The corresponding bit shall be set to 1 under the following conditions:
    #  * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
    #  * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
    #  * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
    #  * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
    #  * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
    #  * - 5 - `reverseLightOn`         - when the reverse light switch is on,
    #  * - 6 - `fogLightOn`             - when the tail fog light switch is on,
    #  * - 7 - `parkingLightsOn`        - when the parking light switch is on.
    #  * 
    #  * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
    #  * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
    #  * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
    #  * if the corresponding lamps are alight or not.
    #  * 
    #  * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
    #  * the corresponding bit shall be set to `0`.
    #  * 
    #  * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
    #  * alternate with the blinking interval.
    #  * 
    #  * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
    #  * 
    #  * @category Vehicle information
    #  * @revision: Description revised in V2.1.1
    #  */
    # ExteriorLights ::= BIT STRING {
    #     lowBeamHeadlightsOn      (0),
    #     highBeamHeadlightsOn     (1),
    #     leftTurnSignalOn         (2),
    #     rightTurnSignalOn        (3),
    #     daytimeRunningLightsOn   (4),
    #     reverseLightOn           (5),
    #     fogLightOn               (6),
    #     parkingLightsOn          (7)
    # } (SIZE(8))
    # ------------------------------------------------------------------------------
    
    uint8[] value
    uint8 bits_unused
    uint8 SIZE_BITS = 8
    uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
    uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
    uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
    uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
    uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
    uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5
    uint8 BIT_INDEX_FOG_LIGHT_ON = 6
    uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7
    
    
    ================================================================================
    MSG: etsi_its_vam_ts_msgs/VruSpecificExteriorLights
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE describes the status of the exterior light switches of a VRU.
    #  *
    #  * The value of each bit indicates the state of the switch, which commands the corresponding light. 
    #  * The bit corresponding to a specific light shall be set to 1, when the corresponding switch is turned on, either manually by the driver or VRU 
    #  * or automatically by a vehicle or VRU system: 
    #  * - 0 `unavailable`     - indicates no information available, 
    #  * - 1 `backFlashLight ` - indicates the status of the back flash light,
    #  * - 2 `helmetLight`     - indicates the status of the helmet light,
    #  * - 3 `armLight`        - indicates the status of the arm light,
    #  * - 4 `legLight`        - indicates the status of the leg light,
    #  * - 5 `wheelLight`      - indicates the status of the wheel light. 
    #  * - Bits 6 to 8         - are reserved for future use. 
    #  * The bit values do not indicate if the corresponding lamps are alight or not.
    #  * If  VRU is not equipped with a certain light or if the light switch status information is not available, the corresponding bit shall be set to 0.
    #  *
    #  * @category: VRU information
    #  * @revision: Created in V2.1.1
    #  */ 
    # VruSpecificExteriorLights ::= BIT STRING {
    #     unavailable    (0),
    #     backFlashLight (1),
    #     helmetLight    (2),
    #     armLight       (3),
    #     legLight       (4),
    #     wheelLight     (5)
    # } (SIZE(8))
    # ------------------------------------------------------------------------------
    
    uint8[] value
    uint8 bits_unused
    uint8 SIZE_BITS = 8
    uint8 BIT_INDEX_UNAVAILABLE = 0
    uint8 BIT_INDEX_BACK_FLASH_LIGHT = 1
    uint8 BIT_INDEX_HELMET_LIGHT = 2
    uint8 BIT_INDEX_ARM_LIGHT = 3
    uint8 BIT_INDEX_LEG_LIGHT = 4
    uint8 BIT_INDEX_WHEEL_LIGHT = 5
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new VruLowFrequencyContainer(null);
    if (msg.profile_and_subprofile !== undefined) {
      resolved.profile_and_subprofile = VruProfileAndSubprofile.Resolve(msg.profile_and_subprofile)
    }
    else {
      resolved.profile_and_subprofile = new VruProfileAndSubprofile()
    }

    if (msg.size_class !== undefined) {
      resolved.size_class = VruSizeClass.Resolve(msg.size_class)
    }
    else {
      resolved.size_class = new VruSizeClass()
    }

    if (msg.size_class_is_present !== undefined) {
      resolved.size_class_is_present = msg.size_class_is_present;
    }
    else {
      resolved.size_class_is_present = false
    }

    if (msg.exterior_lights !== undefined) {
      resolved.exterior_lights = VruExteriorLights.Resolve(msg.exterior_lights)
    }
    else {
      resolved.exterior_lights = new VruExteriorLights()
    }

    if (msg.exterior_lights_is_present !== undefined) {
      resolved.exterior_lights_is_present = msg.exterior_lights_is_present;
    }
    else {
      resolved.exterior_lights_is_present = false
    }

    return resolved;
    }
};

module.exports = VruLowFrequencyContainer;
