// Auto-generated. Do not edit!

// (in-package etsi_its_vam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class YawRateValue {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type YawRateValue
    // Serialize message field [value]
    bufferOffset = _serializer.int16(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type YawRateValue
    let len;
    let data = new YawRateValue(null);
    // Deserialize message field [value]
    data.value = _deserializer.int16(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_vam_ts_msgs/YawRateValue';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e3b161ebe37d85dc95ef2e8ed443aac6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
    # python3
    #   utils/codegen/codegen-py/asn1ToRosMsg.py
    #   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
    #   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
    #   -t
    #   vam_ts
    #   -o
    #   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
    # ------------------------------------------------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # /**
    #  * This DE represents the vehicle rotation around z-axis of the coordinate system centred on the centre of mass of the empty-loaded
    #  * vehicle. The leading sign denotes the direction of rotation.
    #  * 
    #  * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
    #  *
    #  * The value shall be set to:
    #  * - `-32 766` to indicate that the yaw rate is equal to or greater than 327,66 degrees/second to the right,
    #  * - `n` (`n > -32 766` and `n <= 0`) to indicate that the rotation is clockwise (i.e. to the right) and is equal to or less than n x 0,01 degrees/s, 
    #       and greater than (n-1) x 0,01 degrees/s,
    #  * - `n` (`n > 0` and `n < 32 766`) to indicate that the rotation is anti-clockwise (i.e. to the left) and is equal to or less than n x 0,01 degrees/s, 
    #       and greater than (n-1) x 0,01 degrees/s,
    #  * - `32 766` to indicate that the yaw rate is greater than 327.65 degrees/second to the left,
    #  * - `32 767` to indicate that the information is not available.
    #  * 
    #  * The yaw rate value shall be a raw data value, i.e. not filtered, smoothed or otherwise modified.
    #  * The reading instant should be the same as for the vehicle acceleration.
    #  * 
    #  * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
    #  * 
    #  * @unit: 0,01 degree per second. 
    #  * @category: Vehicle Information
    #  * @revision: Desription revised in V2.1.1 (the meaning of 32766 has changed slightly). 
    # */
    # YawRateValue ::= INTEGER {
    #     negativeOutOfRange (-32766), 
    #     positiveOutOfRange (32766), 
    #     unavailable        (32767)
    # } (-32766..32767)
    # ------------------------------------------------------------------------------
    
    int16 value
    int16 MIN = -32766
    int16 MAX = 32767
    int16 NEGATIVE_OUT_OF_RANGE = -32766
    int16 POSITIVE_OUT_OF_RANGE = 32766
    int16 UNAVAILABLE = 32767
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new YawRateValue(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
YawRateValue.Constants = {
  MIN: -32766,
  MAX: 32767,
  NEGATIVE_OUT_OF_RANGE: -32766,
  POSITIVE_OUT_OF_RANGE: 32766,
  UNAVAILABLE: 32767,
}

module.exports = YawRateValue;
