
"use strict";

let CurvatureConfidence = require('./CurvatureConfidence.js');
let ClusterJoinInfo = require('./ClusterJoinInfo.js');
let LongitudinalLanePositionConfidence = require('./LongitudinalLanePositionConfidence.js');
let VruMovementControl = require('./VruMovementControl.js');
let Altitude = require('./Altitude.js');
let SequenceOfTrajectoryInterceptionIndication = require('./SequenceOfTrajectoryInterceptionIndication.js');
let YawRateValue = require('./YawRateValue.js');
let ReferencePositionWithConfidence = require('./ReferencePositionWithConfidence.js');
let LongitudinalLanePositionValue = require('./LongitudinalLanePositionValue.js');
let StandardLength12b = require('./StandardLength12b.js');
let Wgs84Angle = require('./Wgs84Angle.js');
let GenerationDeltaTime = require('./GenerationDeltaTime.js');
let SequenceOfCartesianPosition3d = require('./SequenceOfCartesianPosition3d.js');
let RadialShapesList = require('./RadialShapesList.js');
let BasicContainer = require('./BasicContainer.js');
let PosConfidenceEllipse = require('./PosConfidenceEllipse.js');
let LongitudinalAccelerationValue = require('./LongitudinalAccelerationValue.js');
let VruSubProfileBicyclist = require('./VruSubProfileBicyclist.js');
let LanePositionAndType = require('./LanePositionAndType.js');
let Identifier1B = require('./Identifier1B.js');
let ExteriorLights = require('./ExteriorLights.js');
let VruClusterProfiles = require('./VruClusterProfiles.js');
let AccelerationChange = require('./AccelerationChange.js');
let LongitudinalLanePosition = require('./LongitudinalLanePosition.js');
let RadialShape = require('./RadialShape.js');
let Wgs84AngleConfidence = require('./Wgs84AngleConfidence.js');
let Identifier2B = require('./Identifier2B.js');
let VerticalAccelerationValue = require('./VerticalAccelerationValue.js');
let DeltaLongitude = require('./DeltaLongitude.js');
let DeltaTimeQuarterSecond = require('./DeltaTimeQuarterSecond.js');
let ClusterBreakupInfo = require('./ClusterBreakupInfo.js');
let VruLowFrequencyContainer = require('./VruLowFrequencyContainer.js');
let RadialShapeDetails = require('./RadialShapeDetails.js');
let AltitudeValue = require('./AltitudeValue.js');
let LongitudinalAcceleration = require('./LongitudinalAcceleration.js');
let VruClusterOperationContainer = require('./VruClusterOperationContainer.js');
let VruDeviceUsage = require('./VruDeviceUsage.js');
let AngleConfidence = require('./AngleConfidence.js');
let VruClusterInformationContainer = require('./VruClusterInformationContainer.js');
let VruClusterInformation = require('./VruClusterInformation.js');
let MapPosition = require('./MapPosition.js');
let RectangularShape = require('./RectangularShape.js');
let CurvatureCalculationMode = require('./CurvatureCalculationMode.js');
let YawRate = require('./YawRate.js');
let SequenceOfSafeDistanceIndication = require('./SequenceOfSafeDistanceIndication.js');
let AltitudeConfidence = require('./AltitudeConfidence.js');
let SpeedValue = require('./SpeedValue.js');
let EllipticalShape = require('./EllipticalShape.js');
let StationId = require('./StationId.js');
let VruExteriorLights = require('./VruExteriorLights.js');
let IntersectionReferenceId = require('./IntersectionReferenceId.js');
let CurvatureValue = require('./CurvatureValue.js');
let CircularShape = require('./CircularShape.js');
let PathHistory = require('./PathHistory.js');
let CartesianAngle = require('./CartesianAngle.js');
let SafeDistanceIndicator = require('./SafeDistanceIndicator.js');
let LateralAcceleration = require('./LateralAcceleration.js');
let LateralAccelerationValue = require('./LateralAccelerationValue.js');
let TrajectoryInterceptionProbability = require('./TrajectoryInterceptionProbability.js');
let VruHighFrequencyContainer = require('./VruHighFrequencyContainer.js');
let ClusterLeaveReason = require('./ClusterLeaveReason.js');
let PathDeltaTime = require('./PathDeltaTime.js');
let StabilityChangeIndication = require('./StabilityChangeIndication.js');
let VruEnvironment = require('./VruEnvironment.js');
let MapReference = require('./MapReference.js');
let AccelerationConfidence = require('./AccelerationConfidence.js');
let DeltaTimeTenthOfSecond = require('./DeltaTimeTenthOfSecond.js');
let LanePosition = require('./LanePosition.js');
let PathPoint = require('./PathPoint.js');
let Speed = require('./Speed.js');
let VruSubProfileAnimal = require('./VruSubProfileAnimal.js');
let RoadSegmentReferenceId = require('./RoadSegmentReferenceId.js');
let VruSpecificExteriorLights = require('./VruSpecificExteriorLights.js');
let TrafficParticipantType = require('./TrafficParticipantType.js');
let VamParameters = require('./VamParameters.js');
let CartesianAngleValue = require('./CartesianAngleValue.js');
let TurningDirection = require('./TurningDirection.js');
let GeneralizedLanePosition = require('./GeneralizedLanePosition.js');
let ClusterLeaveInfo = require('./ClusterLeaveInfo.js');
let SemiAxisLength = require('./SemiAxisLength.js');
let VerticalAcceleration = require('./VerticalAcceleration.js');
let AccelerationChangeIndication = require('./AccelerationChangeIndication.js');
let Longitude = require('./Longitude.js');
let CartesianPosition3d = require('./CartesianPosition3d.js');
let Wgs84AngleValue = require('./Wgs84AngleValue.js');
let VAM = require('./VAM.js');
let CartesianCoordinate = require('./CartesianCoordinate.js');
let TrajectoryInterceptionConfidence = require('./TrajectoryInterceptionConfidence.js');
let PathPredicted = require('./PathPredicted.js');
let DeltaLatitude = require('./DeltaLatitude.js');
let PathPointPredicted = require('./PathPointPredicted.js');
let PolygonalShape = require('./PolygonalShape.js');
let ItsPduHeader = require('./ItsPduHeader.js');
let VruMotionPredictionContainer = require('./VruMotionPredictionContainer.js');
let VruSubProfilePedestrian = require('./VruSubProfilePedestrian.js');
let PositionConfidenceEllipse = require('./PositionConfidenceEllipse.js');
let VruSizeClass = require('./VruSizeClass.js');
let RadialShapes = require('./RadialShapes.js');
let MessageId = require('./MessageId.js');
let TrajectoryInterceptionIndication = require('./TrajectoryInterceptionIndication.js');
let Curvature = require('./Curvature.js');
let CardinalNumber1B = require('./CardinalNumber1B.js');
let SpeedConfidence = require('./SpeedConfidence.js');
let HeadingValue = require('./HeadingValue.js');
let ClusterBreakupReason = require('./ClusterBreakupReason.js');
let YawRateConfidence = require('./YawRateConfidence.js');
let VruProfileAndSubprofile = require('./VruProfileAndSubprofile.js');
let VruSubProfileMotorcyclist = require('./VruSubProfileMotorcyclist.js');
let HeadingChangeIndication = require('./HeadingChangeIndication.js');
let Latitude = require('./Latitude.js');
let TrafficIslandPosition = require('./TrafficIslandPosition.js');
let OrdinalNumber1B = require('./OrdinalNumber1B.js');
let VruAwareness = require('./VruAwareness.js');
let ItsPduHeaderVam = require('./ItsPduHeaderVam.js');
let DeltaReferencePosition = require('./DeltaReferencePosition.js');
let SafeDistanceIndication = require('./SafeDistanceIndication.js');
let LaneType = require('./LaneType.js');
let CartesianCoordinateSmall = require('./CartesianCoordinateSmall.js');
let StabilityLossProbability = require('./StabilityLossProbability.js');
let DeltaAltitude = require('./DeltaAltitude.js');
let Shape = require('./Shape.js');

module.exports = {
  CurvatureConfidence: CurvatureConfidence,
  ClusterJoinInfo: ClusterJoinInfo,
  LongitudinalLanePositionConfidence: LongitudinalLanePositionConfidence,
  VruMovementControl: VruMovementControl,
  Altitude: Altitude,
  SequenceOfTrajectoryInterceptionIndication: SequenceOfTrajectoryInterceptionIndication,
  YawRateValue: YawRateValue,
  ReferencePositionWithConfidence: ReferencePositionWithConfidence,
  LongitudinalLanePositionValue: LongitudinalLanePositionValue,
  StandardLength12b: StandardLength12b,
  Wgs84Angle: Wgs84Angle,
  GenerationDeltaTime: GenerationDeltaTime,
  SequenceOfCartesianPosition3d: SequenceOfCartesianPosition3d,
  RadialShapesList: RadialShapesList,
  BasicContainer: BasicContainer,
  PosConfidenceEllipse: PosConfidenceEllipse,
  LongitudinalAccelerationValue: LongitudinalAccelerationValue,
  VruSubProfileBicyclist: VruSubProfileBicyclist,
  LanePositionAndType: LanePositionAndType,
  Identifier1B: Identifier1B,
  ExteriorLights: ExteriorLights,
  VruClusterProfiles: VruClusterProfiles,
  AccelerationChange: AccelerationChange,
  LongitudinalLanePosition: LongitudinalLanePosition,
  RadialShape: RadialShape,
  Wgs84AngleConfidence: Wgs84AngleConfidence,
  Identifier2B: Identifier2B,
  VerticalAccelerationValue: VerticalAccelerationValue,
  DeltaLongitude: DeltaLongitude,
  DeltaTimeQuarterSecond: DeltaTimeQuarterSecond,
  ClusterBreakupInfo: ClusterBreakupInfo,
  VruLowFrequencyContainer: VruLowFrequencyContainer,
  RadialShapeDetails: RadialShapeDetails,
  AltitudeValue: AltitudeValue,
  LongitudinalAcceleration: LongitudinalAcceleration,
  VruClusterOperationContainer: VruClusterOperationContainer,
  VruDeviceUsage: VruDeviceUsage,
  AngleConfidence: AngleConfidence,
  VruClusterInformationContainer: VruClusterInformationContainer,
  VruClusterInformation: VruClusterInformation,
  MapPosition: MapPosition,
  RectangularShape: RectangularShape,
  CurvatureCalculationMode: CurvatureCalculationMode,
  YawRate: YawRate,
  SequenceOfSafeDistanceIndication: SequenceOfSafeDistanceIndication,
  AltitudeConfidence: AltitudeConfidence,
  SpeedValue: SpeedValue,
  EllipticalShape: EllipticalShape,
  StationId: StationId,
  VruExteriorLights: VruExteriorLights,
  IntersectionReferenceId: IntersectionReferenceId,
  CurvatureValue: CurvatureValue,
  CircularShape: CircularShape,
  PathHistory: PathHistory,
  CartesianAngle: CartesianAngle,
  SafeDistanceIndicator: SafeDistanceIndicator,
  LateralAcceleration: LateralAcceleration,
  LateralAccelerationValue: LateralAccelerationValue,
  TrajectoryInterceptionProbability: TrajectoryInterceptionProbability,
  VruHighFrequencyContainer: VruHighFrequencyContainer,
  ClusterLeaveReason: ClusterLeaveReason,
  PathDeltaTime: PathDeltaTime,
  StabilityChangeIndication: StabilityChangeIndication,
  VruEnvironment: VruEnvironment,
  MapReference: MapReference,
  AccelerationConfidence: AccelerationConfidence,
  DeltaTimeTenthOfSecond: DeltaTimeTenthOfSecond,
  LanePosition: LanePosition,
  PathPoint: PathPoint,
  Speed: Speed,
  VruSubProfileAnimal: VruSubProfileAnimal,
  RoadSegmentReferenceId: RoadSegmentReferenceId,
  VruSpecificExteriorLights: VruSpecificExteriorLights,
  TrafficParticipantType: TrafficParticipantType,
  VamParameters: VamParameters,
  CartesianAngleValue: CartesianAngleValue,
  TurningDirection: TurningDirection,
  GeneralizedLanePosition: GeneralizedLanePosition,
  ClusterLeaveInfo: ClusterLeaveInfo,
  SemiAxisLength: SemiAxisLength,
  VerticalAcceleration: VerticalAcceleration,
  AccelerationChangeIndication: AccelerationChangeIndication,
  Longitude: Longitude,
  CartesianPosition3d: CartesianPosition3d,
  Wgs84AngleValue: Wgs84AngleValue,
  VAM: VAM,
  CartesianCoordinate: CartesianCoordinate,
  TrajectoryInterceptionConfidence: TrajectoryInterceptionConfidence,
  PathPredicted: PathPredicted,
  DeltaLatitude: DeltaLatitude,
  PathPointPredicted: PathPointPredicted,
  PolygonalShape: PolygonalShape,
  ItsPduHeader: ItsPduHeader,
  VruMotionPredictionContainer: VruMotionPredictionContainer,
  VruSubProfilePedestrian: VruSubProfilePedestrian,
  PositionConfidenceEllipse: PositionConfidenceEllipse,
  VruSizeClass: VruSizeClass,
  RadialShapes: RadialShapes,
  MessageId: MessageId,
  TrajectoryInterceptionIndication: TrajectoryInterceptionIndication,
  Curvature: Curvature,
  CardinalNumber1B: CardinalNumber1B,
  SpeedConfidence: SpeedConfidence,
  HeadingValue: HeadingValue,
  ClusterBreakupReason: ClusterBreakupReason,
  YawRateConfidence: YawRateConfidence,
  VruProfileAndSubprofile: VruProfileAndSubprofile,
  VruSubProfileMotorcyclist: VruSubProfileMotorcyclist,
  HeadingChangeIndication: HeadingChangeIndication,
  Latitude: Latitude,
  TrafficIslandPosition: TrafficIslandPosition,
  OrdinalNumber1B: OrdinalNumber1B,
  VruAwareness: VruAwareness,
  ItsPduHeaderVam: ItsPduHeaderVam,
  DeltaReferencePosition: DeltaReferencePosition,
  SafeDistanceIndication: SafeDistanceIndication,
  LaneType: LaneType,
  CartesianCoordinateSmall: CartesianCoordinateSmall,
  StabilityLossProbability: StabilityLossProbability,
  DeltaAltitude: DeltaAltitude,
  Shape: Shape,
};
